TITAN_HONOR_ID = "Honor";


TITAN_HONOR_CFG = { };

TITAN_HONOR_KILLSTODAY = {};
TITAN_HONOR_VERSION = 1.11;
TITAN_HONOR_USERS = {};


TITAN_HONOR_LASTKILL = "";
TITAN_HONOR_PLAYER = nil;
TITAN_HONOR_VARSLOADED = false;
TITAN_HONOR_PENDINGUPDATE = false;
TITAN_HONOR_LASTWIN_TIMESTAMP = 0;


-- auto-joining BG
TITAN_HONOR_BGCONFIRM = 0;
TITAN_HONOR_BGAUTOJOINTIMER = 15;


TITAN_HONOR_LastEstimated = 0;
TITAN_HONOR_InBattleground = false;
TITAN_HONOR_Map = "";
TITAN_HONOR_EnterTime = 0;


-- function hooks
local old_StaticPopup_OnHide;		-- Detects when you click 'hide' on BG invite request.

function TitanPanelHonorButton_OnLoad()

	this.registry = {
		id = TITAN_HONOR_ID,
		builtIn = 0,
		version = TITAN_HONOR_VERSION,
		menuText = "Honor",
		buttonTextFunction = "TitanPanelHonorButton_GetButtonText", 
		tooltipTitle ="Honor Count", 
		tooltipTextFunction = "TitanPanelHonorButton_GetTooltipText", 
		frequency = 1,
		savedVariables = {
			ShowLabelText = 1,

			BG_AutoJoin = 1,
			BG_AutoRelease = 1,

			Verbose = 1,
		}
	};

	old_StaticPopup_OnHide = StaticPopup_OnHide;
	StaticPopup_OnHide = TitanPanelHonorButton_StaticPopup_OnHide;

 	this:RegisterEvent("PLAYER_LEAVING_WORLD");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("CHAT_MSG_COMBAT_HONOR_GAIN");
	this:RegisterEvent("PLAYER_DEAD");
	this:RegisterEvent("UPDATE_BATTLEFIELD_STATUS");
end

function TitanPanelHonorButton_OnEvent()
	if (event == "PLAYER_ENTERING_WORLD") then
		
		if (TITAN_HONOR_VARSLOADED) then
			TitanPanelHonorButton_GetPlayerName();
		else
			TITAN_HONOR_PENDINGUPDATE = true;
		end

		
		-- is player entering or leaving a BG?
		local i, id, map, elapsed, gained;
		for i=1, MAX_BATTLEFIELD_QUEUES do

			_, map, id = GetBattlefieldStatus(i);
			if (id ~= 0) then

				-- Player entering a BG

				TITAN_HONOR_InBattleground = true;
				TITAN_HONOR_Map = map;
				TITAN_HONOR_LastEstimated = TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP;
				TITAN_HONOR_EnterTime = time();

				return
			end
		end

		if (TITAN_HONOR_InBattleground) then

			-- Player just left a BG

			gained = math.floor(TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP - TITAN_HONOR_LastEstimated);
			elapsed = math.floor( (time() - TITAN_HONOR_EnterTime) / 60 );

			local tmp_gained;

			tmp_gained = gained;

			if (gained < 0) then
				gained = "?";
				tmp_gained = TITAN_HONOR_TXT_HONOR_UNKNOWN;
			end

			-- BG Honor History
			if (elapsed > 2 and gained ~= "?") then
				if (not TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].BGHonorHistory[TITAN_HONOR_Map]) then
					TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].BGHonorHistory[TITAN_HONOR_Map] = {};
				end

				table.insert(TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].BGHonorHistory[TITAN_HONOR_Map], { honor = gained, time = elapsed } );
				if (table.getn(TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].BGHonorHistory[TITAN_HONOR_Map]) > 10) then
					table.remove(TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].BGHonorHistory[TITAN_HONOR_Map], 1);
				end
			end

			TITAN_HONOR_InBattleground = false;
		end

	elseif (event == "UPDATE_BATTLEFIELD_STATUS") then
		TitanPanelHonorButton_CheckBGConfirm();

	elseif (event == "PLAYER_DEAD") then
		-- Auto-Release upon death. But not when soulstoned, and only in battlegrounds.
		local status;
		for i=1, MAX_BATTLEFIELD_QUEUES do
			local s, _, _ = GetBattlefieldStatus(i);
			if (s == "active") then
				status = "active";
				break;
			end
		end

		if ((status == "active") and (not HasSoulstone()) and (TitanGetVar(TITAN_HONOR_ID, "BG_AutoRelease") == 1)) then
			RepopMe();
		end

	elseif (event == "CHAT_MSG_COMBAT_HONOR_GAIN") then
		local rank, ecp, est;

		_, _, TITAN_HONOR_LASTKILL, rank, ecp = string.find(arg1, TITAN_HONOR_TXT_HONORKILL_PATTERN);

		if (not TITAN_HONOR_LASTKILL) then

			_, _, TITAN_HONOR_LASTKILL = string.find(arg1, TITAN_HONOR_TXT_HONORBONUS_PATTERN);
			if (TITAN_HONOR_LASTKILL) then
				TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP = TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP + tonumber(TITAN_HONOR_LASTKILL);
				TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].bonusCP = TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].bonusCP + tonumber(TITAN_HONOR_LASTKILL);

				if (TitanGetVar(TITAN_HONOR_ID, "Verbose") == 1) then
					local txt;
					txt = format(TITAN_HONOR_CHAT_BONUSPATTERN, math.floor(tonumber(TITAN_HONOR_LASTKILL)));
					DEFAULT_CHAT_FRAME:AddMessage(txt, 1, 1, 0);
				end

			end

		else

			if (not TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER][TITAN_HONOR_LASTKILL]) then
				TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER][TITAN_HONOR_LASTKILL] = 0;
			end

			TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER][TITAN_HONOR_LASTKILL] = TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER][TITAN_HONOR_LASTKILL] + 1;

			if (ecp) then
				est = TitanPanelHonorButton_EstimateCP(ecp);
				TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP = TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP + est;
				TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].killsCP = TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].killsCP + est;
			end

			if (TitanGetVar(TITAN_HONOR_ID, "Verbose") == 1) then
				local txt;
				txt = format(TITAN_HONOR_CHAT_KILLPATTERN, TITAN_HONOR_LASTKILL, tonumber(TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER][TITAN_HONOR_LASTKILL]), math.floor(est));
				DEFAULT_CHAT_FRAME:AddMessage(txt, 1, 1, 0);
			end
		end

	elseif (event == "VARIABLES_LOADED") then
		TITAN_HONOR_VARSLOADED = true;
		if (TITAN_HONOR_PENDINGUPDATE) then
			TitanPanelHonorButton_GetPlayerName();
		end
	end

	TitanPanelButton_UpdateButton(TITAN_HONOR_ID);		
end

function TitanPanelHonorButton_OnClick(button)

end

function TitanPanelHonorButton_GetButtonText(id)
	
	if(not TITAN_HONOR_PLAYER) then
		return "Honor: ", "Loading";
	end
	
	TitanPanelHonorButton_CheckBGConfirm();

	local Text, z, cp;

	z = 0;
	if(TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER]) then
		for _ in pairs(TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER]) do
			z = z + 1;
		end
	end
	

	cp = math.floor(TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP);

	Text = format(TITAN_HONOR_BUTTON_PATTERN, TitanUtils_GetHighlightText(cp), TitanUtils_GetGreenText(z));

	return TITAN_HONOR_BUTTON_LABEL, Text;
end

function TitanPanelHonorButton_GetTooltipText()
	local txt, hk, hc, ac, z;
	hk = GetPVPLifetimeStats();
	hc = GetHonorCurrency();
	ac = GetArenaCurrency();
	
	z = 0;
	for _ in pairs(TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER]) do
		z = z + 1;
	end

	-- BG stats
	local bg, honorArr, avgHonor, avgTime, bgSession, dataPoints, bgstats;

	bgstats = "";

	
	for bg, honorArr in pairs(TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].BGHonorHistory) do
		avgHonor = 0;
		avgTime = 0;

		dataPoints = table.getn(honorArr);
		
		for _, bgSession in pairs(honorArr) do
			avgHonor = avgHonor + bgSession.honor;
			avgTime = avgTime + bgSession.time;
		end
	
		avgHonor = math.floor(avgHonor / dataPoints);
		avgTime = math.floor(avgTime / dataPoints);

		bgstats =	bgstats.."\n"..TitanUtils_GetHighlightText(bg..TITAN_HONOR_TOOLTIP_STATS).."\n"..
				TITAN_HONOR_TOOLTIP_AVG_HONOR.."\t"..TitanUtils_GetHighlightText(avgHonor).."\n"..
				TITAN_HONOR_TOOLTIP_HONORPERHOUR.."\t"..TitanUtils_GetHighlightText(math.floor((avgHonor/avgTime)*60)).." ("..TitanUtils_GetHighlightText(math.floor((avgHonor/avgTime)))..")\n"..
				"";

	end


	local txt, gained = 0;
	txt = "";
	if (TITAN_HONOR_InBattleground) then
		gained = math.floor(TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP - TITAN_HONOR_LastEstimated);
		txt =	"\n"..TitanUtils_GetHighlightText(TITAN_HONOR_TOOLTIP_CURRENTBG).."\n"..
			TITAN_HONOR_TOOLTIP_HONORSOFAR.."\t"..TitanUtils_GetHighlightText(gained);
	end


	return ""..
		TitanUtils_GetHighlightText(TITAN_HONOR_TOOLTIP_CURRENCY).."\n"..
		TITAN_HONOR_TOOLTIP_HONORCP.."\t"..TitanUtils_GetHighlightText(hc).."\n"..
		TITAN_HONOR_TOOLTIP_ARENACP.."\t"..TitanUtils_GetHighlightText(ac).."\n"..
		"\n"..
		
		TitanUtils_GetHighlightText(TITAN_HONOR_TOOLTIP_TODAY).."\n"..
		TITAN_HONOR_TOOLTIP_HKS.."\t"..TitanUtils_GetGreenText(z).."\n"..
		TITAN_HONOR_TOOLTIP_HONORFROMHK.."\t"..TitanUtils_GetHighlightText(math.floor(TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].killsCP)).."\n"..
		TITAN_HONOR_TOOLTIP_BONUSHONOR.."\t"..TitanUtils_GetHighlightText(math.floor(TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].bonusCP)).."\n"..
		TITAN_HONOR_TOOLTIP_HONOREST.."\t"..TitanUtils_GetHighlightText(math.floor(TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP)).."\n"..



		bgstats..txt..


	"";



end

function TitanPanelRightClickMenu_PrepareHonorMenu()
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[TITAN_HONOR_ID].menuText);
	TitanPanelRightClickMenu_AddSpacer();


	-- Add toggle for batleground auto-joining
	info = {};
	info.text = TITAN_HONOR_MENU_AUTOJOIN;
	info.func = TitanPanelHonorButton_ToggleVar_BG_AutoJoin;
	info.checked = TitanGetVar(TITAN_HONOR_ID, "BG_AutoJoin");
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- Add toggle for auto-release in bgs
	info = {};
	info.text = TITAN_HONOR_MENU_AUTORES;
	info.func = TitanPanelHonorButton_ToggleVar_BG_AutoRelease;
	info.checked = TitanGetVar(TITAN_HONOR_ID, "BG_AutoRelease");
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- Add toggle for verbose mode
	info = {};
	info.text = TITAN_HONOR_MENU_SHOWHONORGAIN;
	info.func = TitanPanelHonorButton_ToggleVar_Verbose;
	info.checked = TitanGetVar(TITAN_HONOR_ID, "Verbose");
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	TitanPanelRightClickMenu_AddSpacer();	
	TitanPanelRightClickMenu_AddToggleLabelText(TITAN_HONOR_ID);
	
	TitanPanelRightClickMenu_AddSpacer();	
	TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, TITAN_HONOR_ID, TITAN_PANEL_MENU_FUNC_HIDE);
end

function TitanPanelHonorButton_GetPlayerName()
	local pname;

	pname = UnitName("player");
	if (pname and pname ~= UNKNOWNOBJECT and pname ~= UKNOWNBEING and pname ~= TITAN_HONOR_TXT_UNKNOWN_ENITY) then
		TitanPanelHonorButton_Login();
	end
end


function TitanPanelHonorButton_Login()

	TITAN_HONOR_PLAYER = UnitName("player").." "..GetCVar("realmName");


	-- new player?
	if(not TITAN_HONOR_USERS[TITAN_HONOR_PLAYER]) then
		-- backward compatability
		if(not TITAN_HONOR_KILLSLIFETIME) then
			TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER] = { };
			TITAN_HONOR_CFG[TITAN_HONOR_PLAYER] = { yesterdayHK = 0, yesterdayCP = 0 }
		end
		-- new var
		TITAN_HONOR_USERS[TITAN_HONOR_PLAYER] = { version = TITAN_HONOR_VERSION }
	end

	if (not TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP) then
		TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP = 0;
	end

	if (not TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].killsCP) then
		TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].killsCP = 0;
	end


	if (not TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].bonusCP) then
		TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].bonusCP = 0;
	end


	if (not TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].BGHonorHistory) then
		TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].BGHonorHistory = {};
	end

	-- check for new day, reset if it is
	TitanPanelHonorButton_ResetToday();

end

function TitanPanelHonorButton_ResetToday()
	local hk, contribution;

	-- Yesterday's values
	hk, contribution = GetPVPYesterdayStats();

	-- if yesterday's values differ from when last logged in, wipe kills for today
	if (	TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].yesterdayHK ~= hk or
		TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].yesterdayCP ~= contribution
	) then
		-- new day
		TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].yesterdayHK = hk;
		TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].yesterdayCP = contribution;

		TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER] = {};

		-- wipe estinated CP for today
		TITAN_HONOR_CFG[TITAN_HONOR_PLAYER].estCP = 0;
		
	end
end

function TitanPanelHonorButton_EstimateCP(ecp)
	if (TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER][TITAN_HONOR_LASTKILL] > 10) then
		return 0
	elseif (TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER][TITAN_HONOR_LASTKILL] == 1) then
		return ecp
	else
		return ecp - ( (TITAN_HONOR_KILLSTODAY[TITAN_HONOR_PLAYER][TITAN_HONOR_LASTKILL] - 1) / 10 * ecp );
	end
end



----------------------------
-- TitanVar Toggles
----------------------------

function TitanPanelHonorButton_ToggleVar_BG_AutoRelease()
	TitanToggleVar(TITAN_HONOR_ID, "BG_AutoRelease");
	TitanPanelButton_UpdateButton(TITAN_HONOR_ID);
end

function TitanPanelHonorButton_ToggleVar_BG_AutoJoin()
	TitanToggleVar(TITAN_HONOR_ID, "BG_AutoJoin");
	TitanPanelButton_UpdateButton(TITAN_HONOR_ID);
end

function TitanPanelHonorButton_ToggleVar_Verbose()
	TitanToggleVar(TITAN_HONOR_ID, "Verbose");
	TitanPanelButton_UpdateButton(TITAN_HONOR_ID);
end




------------------------------------------------
-- Auto-join Battlegrounds (from TitanHonorPlus)
------------------------------------------------
function TitanPanelHonorButton_CheckBGConfirm()
	local status, index;

	for i=1,MAX_BATTLEFIELD_QUEUES do
		status,_,_ = GetBattlefieldStatus(i);
		if(status == "confirm") then
			index = i;
			break
		end
	end

	if ((status == "confirm") and (TitanGetVar(TITAN_HONOR_ID, "BG_AutoJoin") == 1)) then
		if (StaticPopup_Visible("CONFIRM_BATTLEFIELD_ENTRY")) then
			if (TITAN_HONOR_BGCONFIRM == 0) then
				DEFAULT_CHAT_FRAME:AddMessage(TITAN_HONOR_TXT_AUTOJOIN, 1, 1, 0);
				TITAN_HONOR_BGCONFIRM = GetTime() + TITAN_HONOR_BGAUTOJOINTIMER;
			elseif (GetTime() > TITAN_HONOR_BGCONFIRM) then
				TITAN_HONOR_BGCONFIRM = 0;
				DEFAULT_CHAT_FRAME:AddMessage(TITAN_HONOR_TXT_NOWJOIN, 1, 1, 0);
				AcceptBattlefieldPort(index,1)
				StaticPopup_Hide("CONFIRM_BATTLEFIELD_ENTRY");
			end
		end
	end
end

-- If the "Hide" button is clicked when ready to enter BG.
-- It means the user doesn't want to join, so we disable auto-join.
function TitanPanelHonorButton_StaticPopup_OnHide()
	old_StaticPopup_OnHide();
	if (this.which == "CONFIRM_BATTLEFIELD_ENTRY") and (TITAN_HONOR_BGCONFIRM ~= 0) then
		TITAN_HONOR_BGCONFIRM = 0;
		DEFAULT_CHAT_FRAME:AddMessage(TITAN_HONOR_TXT_CANCELJOIN, 1, 1, 0);
	end
end