TBG_Files_Arenas_IsLoaded = true; -- Indicates this file has been loaded into memory.

-- ## Scans the targets of players within the arena.
function TBG_Arena_GetRaidTargets()
	if (not TBG_IsArena(TBG.Var.Player.zone)) then return nil;                 end
	if (TBG.DB.players.arena == nil)          then TBG.DB.players.arena = { }; end

	for i = 1, GetNumRaidMembers() do
		local id = "raid" .. i .. "target";

		-- If this is a hostile player.
		if (UnitCanAttack(id, "player") and UnitIsPlayer(id)) then
			if (TBG.DB.players.arena[UnitName(id)] == nil and UnitName(id) ~= UNKNOWN) then
				TBG.DB.players.arena[UnitName(id)]       = { };
				TBG.DB.players.arena[UnitName(id)].name  = UnitName(id);
				TBG.DB.players.arena[UnitName(id)].class = UnitClass(id);
			end
		end
	end
end


-- ## Adds the mouseover player to the players within the arena.
function TBG_Arena_GetMousePlayer()
	if (not TBG_IsArena(TBG.Var.Player.zone)) then return nil; end

	-- If this is a hostile player.
	if (UnitCanAttack("mouseover", "player") and UnitIsPlayer("mouseover")) then
		if (TBG.DB.players.arena == nil) then TBG.DB.players.arena = { }; end

		-- Add the player to the list of hostile players.
		if (TBG.DB.players.arena[UnitName("mouseover")] == nil and UnitName("mouseover") ~= UNKNOWN) then
			TBG.DB.players.arena[UnitName("mouseover")]       = { };
			TBG.DB.players.arena[UnitName("mouseover")].name  = UnitName("mouseover");
			TBG.DB.players.arena[UnitName("mouseover")].class = UnitClass("mouseover");
		end
	end
end


-- ## Prints a list of hostile players within the arena.
function TBG_Arena_Other_UpdateHostilePlayers(hide)
	local b = 1;

	if (hide ~= true) then
		if (not TBG_IsArena(TBG.Var.Player.zone)) then return nil;  end

		-- Create list if it doesn't exist.
		if (TBG.DB.players.arena == nil) then TBG.DB.players.arena = { }; end

		-- Loop through all of the players. Do not bother updating if in combat, as buttons cannot be set with macros in combat.
		if (not InCombatLockdown() and TBG_Saved("MDB_Other_PlayersList")) then
			for name, player in pairs(TBG.DB.players.arena) do
				if (b > 5) then break; end

				local color = "";
				local class = "";

				if (TBG_Saved("MDB_Other_PlayersList_ColorClass")) then
					color = TBG.Var.Const.COLOR_CLASS[TBG.Var.Const.NAME_CLASS[player.class]].color;
				else
					color = TBG.Var.Const.COLOR_WHITE;
				end

				if (TBG_Saved("MDB_Other_PlayersList_PrintClass")) then class = TBG.Var.Const.COLOR_WHITE .. " (" .. player.class .. ")"; end

				local text = color .. player.name .. class;

				getglobal("TBGX_Display_ArenaPlayers_" .. b):SetAttribute("type1", "macro");
				getglobal("TBGX_Display_ArenaPlayers_" .. b):SetAttribute("macrotext", "/target " .. player.name);
				getglobal("TBGX_Display_ArenaPlayers_" .. b .. "Text"):SetText(text);
				getglobal("TBGX_Display_ArenaPlayers_" .. b):Show();

				b = b + 1;
			end
		end
	end

	-- Hide any unused buttons.
	if (not InCombatLockdown()) then
		for i = b, 5 do
			getglobal("TBGX_Display_ArenaPlayers_" .. i):Hide();
		end
	end
end
