TBG_Files_Hooks_IsLoaded = true; -- Indicates this file has been loaded into memory.

-- ## Stores the default value for all hooked Blizzard functions.
function TBG_Hooks_StoreBlizzard()
	Hook_Blizzard_BattlefieldFrame_UpdateStatus   = BattlefieldFrame_UpdateStatus;
	Hook_Blizzard_CloseDropDownMenus              = CloseDropDownMenus;
	Hook_Blizzard_DialogBattlefieldEntryUpdate    = StaticPopupDialogs["CONFIRM_BATTLEFIELD_ENTRY"].OnUpdate;
	Hook_Blizzard_DialogBattlefieldEntryAccept    = StaticPopupDialogs["CONFIRM_BATTLEFIELD_ENTRY"].OnAccept;
	Hook_Blizzard_DialogDeathOnShow               = StaticPopupDialogs["DEATH"].OnShow;
	Hook_Blizzard_RepopMe                         = RepopMe;
	Hook_Blizzard_ToggleDropDownMenu              = ToggleDropDownMenu;
	Hook_Blizzard_WorldStateFrame_ToggleMinimap   = WorldStateFrame_ToggleMinimap;
	Hook_Blizzard_WorldStateScoreFrameTab_OnClick = WorldStateScoreFrameTab_OnClick;
	Hook_Blizzard_WorldStateScoreFrame_Update     = WorldStateScoreFrame_Update;
	Hook_Blizzard_ToggleWorldStateScoreFrame      = ToggleWorldStateScoreFrame;
	Hook_Blizzard_ShowUIPanel                     = ShowUIPanel;
	Hook_Blizzard_HideUIPanel                     = HideUIPanel;
	Hook_Blizzard_LeaveBattlefield                = LeaveBattlefield;
	Hook_Blizzard_ChatFrame_MessageEventHandler   = ChatFrame_MessageEventHandler;
	Hook_Blizzard_PVPTeam_Update                  = PVPTeam_Update;
	Hook_Blizzard_RaidGroupButton_OnEnter         = nil; -- Hooked in update function.

	Hook_Blizzard_MiniMapBattlefieldFrame              = MiniMapBattlefieldFrame:GetScript("OnClick");
	Hook_Blizzard_StaticPopup1Button2OnClick           = StaticPopup1Button2:GetScript("OnClick");
	Hook_Blizzard_QuestFrameCompleteButton_OnShow      = QuestFrameCompleteButton:GetScript("OnShow");
	Hook_Blizzard_QuestFrameCompleteQuestButton_OnShow = QuestFrameCompleteQuestButton:GetScript("OnShow");
	Hook_Blizzard_BattlefieldFrame_OnShow              = BattlefieldFrame:GetScript("OnShow");
	Hook_Blizzard_GameTooltip_SetUnit                  = GameTooltip:GetScript("OnTooltipSetUnit");
	Hook_Blizzard_RaidFrame_OnShow                     = RaidFrame:GetScript("OnShow");

	BattlefieldMinimap_LoadUI();
	if (BattlefieldMinimapCloseButton) then
		Hook_Blizzard_BattlefieldMinimapCloseButton = BattlefieldMinimapCloseButton:GetScript("OnClick");
	end

	StaticPopupDialogs[TBG.Var.Const.DIALOG_CONSOLE_RELOADUI] = {
		text         = TBG.Text.Message.DIALOG_CONSOLE_RELOADUI,
		button1      = TBG.Text.Message.DIALOG_CONSOLE_RELOADUI_RELOAD,
		button2      = CANCEL,
		OnAccept 	 = function() ReloadUI(); end,
		timeout      = 0,
		whileDead    = 1,
		hideOnEscape = 1,
	};

	StaticPopupDialogs[TBG.Var.Const.DIALOG_INTRODUCTION] = {
		text         = TBG.Text.Message.DIALOG_INTRODUCTION,
		button1      = OKAY,
		whileDead    = 1,
		hideOnEscape = 1,
		timeout      = 0,
	};

	StaticPopupDialogs[TBG.Var.Const.DIALOG_RELOAD_HISTORY] = {
		text         = TBG.Text.Message.DIALOG_RELOAD_HISTORY,
		button1      = OKAY,
		showAlert    = 1,
		whileDead    = 1,
		hideOnEscape = 1,
		timeout      = 60,
	};

	StaticPopupDialogs[TBG.Var.Const.DIALOG_PROFILE] = {
		text         = TBG.Text.Message.DIALOG_PROFILE_NAME_INCORRECT,
		button1      = OKAY,
		showAlert    = 1,
		whileDead    = 1,
		hideOnEscape = 1,
		timeout      = 60,
	};
end


-- ## Stores the default value for all hooked Titan functions.
function TBG_Hooks_StoreTitan()
	Hook_Titan_TitanPanelRightClickMenu_BarOnClick = TitanPanelRightClickMenu_BarOnClick;
end


-- ## Restores Blizzard functions back to the original.
function TBG_Hooks_RestoreBlizzard()
	BattlefieldFrame_UpdateStatus                            = Hook_Blizzard_BattlefieldFrame_UpdateStatus;
	CloseDropDownMenus                                       = Hook_Blizzard_CloseDropDownMenus;
	StaticPopupDialogs["CONFIRM_BATTLEFIELD_ENTRY"].OnUpdate = Hook_Blizzard_DialogBattlefieldEntryUpdate;
	StaticPopupDialogs["CONFIRM_BATTLEFIELD_ENTRY"].OnAccept = Hook_Blizzard_DialogBattlefieldEntryAccept;
	StaticPopupDialogs["DEATH"].OnShow                       = Hook_Blizzard_DialogDeathOnShow;
	RepopMe                                                  = Hook_Blizzard_RepopMe;
	ToggleDropDownMenu                                       = Hook_Blizzard_ToggleDropDownMenu;
	WorldStateFrame_ToggleMinimap                            = Hook_Blizzard_WorldStateFrame_ToggleMinimap;
	WorldStateScoreFrameTab_OnClick                          = Hook_Blizzard_WorldStateScoreFrameTab_OnClick;
	WorldStateScoreFrame_Update                              = Hook_Blizzard_WorldStateScoreFrame_Update;
	ToggleWorldStateScoreFrame                               = Hook_Blizzard_ToggleWorldStateScoreFrame;
	ShowUIPanel                                              = Hook_Blizzard_ShowUIPanel;
	HideUIPanel                                              = Hook_Blizzard_HideUIPanel;
	LeaveBattlefield                                         = Hook_Blizzard_LeaveBattlefield;
	ChatFrame_MessageEventHandler                            = Hook_Blizzard_ChatFrame_MessageEventHandler;
	PVPTeam_Update                                           = Hook_Blizzard_PVPTeam_Update;

	MiniMapBattlefieldFrame:SetScript("OnClick",      Hook_Blizzard_MiniMapBattlefieldFrame);
	StaticPopup1Button2:SetScript("OnClick",          Hook_Blizzard_StaticPopup1Button2OnClick);
	QuestFrameCompleteButton:SetScript("OnShow",      Hook_Blizzard_QuestFrameCompleteButton_OnShow);
	QuestFrameCompleteQuestButton:SetScript("OnShow", Hook_Blizzard_QuestFrameCompleteQuestButton_OnShow);
	BattlefieldFrame:SetScript("OnShow",              Hook_Blizzard_BattlefieldFrame_OnShow);
	GameTooltip:SetScript("OnTooltipSetUnit",         Hook_Blizzard_GameTooltip_SetUnit);
	RaidFrame:SetScript("OnShow",                     Hook_Blizzard_RaidFrame_OnShow);

	BattlefieldMinimap_LoadUI();
	if (BattlefieldMinimapCloseButton) then
		BattlefieldMinimapCloseButton:SetScript("OnClick", Hook_Blizzard_BattlefieldMinimapCloseButton);
	end
end


-- ## Restored Titan functions back to the original.
function TBG_Hooks_RestoreTitan()
	TitanPanelRightClickMenu_BarOnClick = Hook_Titan_TitanPanelRightClickMenu_BarOnClick;
end


-- ## Replace existing Blizzard functions, with the new functions.
function TBG_Hooks_HookBlizzard()
	BattlefieldFrame_UpdateStatus                            = TBG_Hooks_Functions_BattlefieldFrame_UpdateStatus;
	CloseDropDownMenus                                       = TBG_Hooks_Functions_CloseDropDownMenus;
	StaticPopupDialogs["CONFIRM_BATTLEFIELD_ENTRY"].OnUpdate = TBG_Hooks_Functions_StaticPopupDialogs_ConfirmBattlefieldEntry_OnUpdate;
	StaticPopupDialogs["CONFIRM_BATTLEFIELD_ENTRY"].OnAccept = TBG_Hooks_Functions_StaticPopupDialogs_ConfirmBattlefieldEntry_OnAccept;
	StaticPopupDialogs["DEATH"].OnShow                       = TBG_Hooks_Functions_StaticPopupDialogs_Death_OnShow;
	RepopMe                                                  = TBG_Hooks_Functions_RepopMe;
	ToggleDropDownMenu                                       = TBG_Hooks_Functions_ToggleDropDownMenu;
	WorldStateFrame_ToggleMinimap                            = TBG_Hooks_Functions_WorldStateFrame_ToggleMinimap;
	WorldStateScoreFrameTab_OnClick                          = TBG_Hooks_Functions_WorldStateScoreFrameTab_OnClick;
	WorldStateScoreFrame_Update                              = TBG_Hooks_Functions_WorldStateScoreFrame_Update;
	ToggleWorldStateScoreFrame                               = TBG_Hooks_Functions_ToggleWorldStateScoreFrame;
	ShowUIPanel                                              = TBG_Hooks_Functions_ShowUIPanel;
	HideUIPanel                                              = TBG_Hooks_Functions_HideUIPanel;
	LeaveBattlefield                                         = TBG_Hooks_Functions_LeaveBattlefield;
	ChatFrame_MessageEventHandler                            = TBG_Hooks_Functions_ChatFrame_MessageEventHandler;
	PVPTeam_Update                                           = TBG_Hooks_Functions_PVPTeam_Update;

	MiniMapBattlefieldFrame:SetScript("OnClick",      TBG_Hooks_Functions_MiniMapBattlefieldFrame_OnClick);
	StaticPopup1Button2:SetScript("OnClick",          TBG_Hooks_Functions_StaticPopup1Button2OnClick);
	QuestFrameCompleteButton:SetScript("OnShow",      TBG_Hooks_Functions_QuestFrameCompleteButton_OnShow);
	QuestFrameCompleteQuestButton:SetScript("OnShow", TBG_Hooks_Functions_QuestFrameCompleteQuestButton_OnShow);
	BattlefieldFrame:SetScript("OnShow",              TBG_Hooks_Functions_BattlefieldFrame_OnShow);
	GameTooltip:SetScript("OnTooltipSetUnit",         TBG_Hooks_Functions_GameTooltip_SetUnit);
	RaidFrame:SetScript("OnShow",                     TBG_Hooks_Functions_RaidFrame_OnShow);

	BattlefieldMinimap_LoadUI();
	if (BattlefieldMinimapCloseButton) then
		BattlefieldMinimapCloseButton:SetScript("OnClick", TBG_Hooks_Functions_BattlefieldMinimapCloseButton);
	end
end


-- ## Replace existing Titan Panel functions, with the new functions.
function TBG_Hooks_HookTitan()
	TitanPanelRightClickMenu_BarOnClick = TBG_Hooks_Functions_TitanPanelRightClickMenu_BarOnClick;
end


-- ## FUNCTIONS


function TBG_Hooks_Functions_BattlefieldFrame_UpdateStatus(tooltipOnly)
	local status, mapName, instanceID, levelRangeMin, levelRangeMax, teamSize, registeredMatch;
	local numberQueues = 0;
	local waitTime, timeInQueue;
	local tooltip;
	local showRightClickText;
	BATTLEFIELD_SHUTDOWN_TIMER = 0;

	-- Reset tooltip
	MiniMapBattlefieldFrame.tooltip = nil;
	MiniMapBattlefieldFrame.waitTime = {};
	MiniMapBattlefieldFrame.status = nil;

	-- Copy current queues into previous queues
	if ( not tooltipOnly ) then
		PREVIOUS_BATTLEFIELD_QUEUES = {};
		for index, value in pairs(CURRENT_BATTLEFIELD_QUEUES) do
			tinsert(PREVIOUS_BATTLEFIELD_QUEUES, value);
		end
		CURRENT_BATTLEFIELD_QUEUES = {};
	end

	for i=1, MAX_BATTLEFIELD_QUEUES do
		status, mapName, instanceID, levelRangeMin, levelRangeMax, teamSize, registeredMatch = GetBattlefieldStatus(i);
		if ( mapName ) then
			if (  instanceID ~= 0 ) then
				mapName = mapName.." "..instanceID;
			end
			if ( teamSize ~= 0 ) then
				mapName = mapName.." "..format(PVP_TEAMSIZE, teamSize, teamSize);
			end
		end
		tooltip = nil;
		MiniMapBattlefieldFrame_isArena();
		if ( not tooltipOnly and (status ~= "confirm") ) then
			StaticPopup_Hide("CONFIRM_BATTLEFIELD_ENTRY", i);
		end

		if ( status ~= "none" ) then
			numberQueues = numberQueues+1;
			if ( status == "queued" ) then
				-- Update queue info show button on minimap
				waitTime = GetBattlefieldEstimatedWaitTime(i);
				timeInQueue = GetBattlefieldTimeWaited(i)/1000;
				if ( waitTime == 0 ) then
					waitTime = QUEUE_TIME_UNAVAILABLE;
				elseif ( waitTime < 60000 ) then
					waitTime = LESS_THAN_ONE_MINUTE;
				else
					waitTime = SecondsToTime(waitTime/1000, 1);
				end
				MiniMapBattlefieldFrame.waitTime[i] = waitTime;
				tooltip = format(BATTLEFIELD_IN_QUEUE, mapName, waitTime, SecondsToTime(timeInQueue));

				if ( not tooltipOnly ) then
					if ( not IsAlreadyInQueue(mapName) ) then
						UIFrameFadeIn(MiniMapBattlefieldFrame, CHAT_FRAME_FADE_TIME);
						BattlegroundShineFadeIn();
						--PlaySound("PVPENTERQUEUE");
					end
					tinsert(CURRENT_BATTLEFIELD_QUEUES, mapName);
				end
				showRightClickText = 1;
			elseif ( status == "confirm" ) then
				-- Have been accepted show enter battleground dialog
				tooltip = format(BATTLEFIELD_QUEUE_CONFIRM, mapName, SecondsToTime(GetBattlefieldPortExpiration(i)/1000));
				if ( not tooltipOnly ) then
					local dialog = StaticPopup_Show("CONFIRM_BATTLEFIELD_ENTRY", mapName, nil, i);
					if ( dialog ) then
						dialog.data = i;
					end
					--PlaySound("PVPTHROUGHQUEUE");
					MiniMapBattlefieldFrame:Show();
				end
				showRightClickText = 1;
			elseif ( status == "active" ) then
				-- In the battleground
				if ( teamSize ~= 0 ) then
					tooltip = mapName;
				else
					tooltip = format(BATTLEFIELD_IN_BATTLEFIELD, mapName);
				end
				BATTLEFIELD_SHUTDOWN_TIMER = GetBattlefieldInstanceExpiration()/1000;
				BATTLEFIELD_TIMER_THRESHOLD_INDEX = 1;
				PREVIOUS_BATTLEFIELD_MOD = 0;
				MiniMapBattlefieldFrame.status = status;
			elseif ( status == "error" ) then
				-- Should never happen haha
			end
			if ( tooltip ) then
				if ( MiniMapBattlefieldFrame.tooltip ) then
					MiniMapBattlefieldFrame.tooltip = MiniMapBattlefieldFrame.tooltip.."\n\n"..tooltip;
				else
					MiniMapBattlefieldFrame.tooltip = tooltip;
				end
			end
		end
	end
	-- See if should add right click message
	if ( MiniMapBattlefieldFrame.tooltip and showRightClickText ) then
		MiniMapBattlefieldFrame.tooltip = MiniMapBattlefieldFrame.tooltip.."\n"..RIGHT_CLICK_MESSAGE;
	elseif ( MiniMapBattlefieldFrame_isArena() ) then
		MiniMapBattlefieldFrame.tooltip = MiniMapBattlefieldFrame.tooltip;
	end

	if ( not tooltipOnly ) then
		MiniMapBattlefieldFrame_isArena();
		if ( numberQueues == 0 ) then
			-- Clear everything out
			MiniMapBattlefieldFrame:Hide();
		else
			MiniMapBattlefieldFrame:Show();
		end
	end
	BattlefieldFrame.numQueues = numberQueues;
end


function TBG_Hooks_Functions_CloseDropDownMenus(level)
	Hook_Blizzard_CloseDropDownMenus(level);

	if (DropDownList1 and not DropDownList1:IsVisible() and TBG.Var.Addon.drop_down_menu_open ~= false) then
		TBG.Var.Addon.drop_down_menu_open = false;
		TBG_Tooltip_Load();
		TBG_Tooltip_AlwaysShow();
	end
end


function TBG_Hooks_Functions_StaticPopupDialogs_ConfirmBattlefieldEntry_OnUpdate(dialog, elapsed)
	if (this.which == "CONFIRM_BATTLEFIELD_ENTRY" and this.data and TBG.DB.bgs.names[TBG.DB.bgs.blizzard[this.data]]) then
		TBG_HideBattlegroundReadyPopup();
	end

	if (TBG_Saved("MDW_Other_ModifyPopupQueueExpire") and this.which == "CONFIRM_BATTLEFIELD_ENTRY" and this.data and not this.added) then
		local text = getglobal(this:GetName() .. "Text");
		local pop  = { };

		pop.dialog    = this;
		pop.text      = getglobal(this:GetName() .. "Text");
		pop.old_text  = pop.text:GetText();
		pop.which     = this.which;
		pop.data      = this.data;

		_, pop.text_arg1, pop.text_arg2, pop.text_arg3, pop.text_arg4, pop.text_arg5 = GetBattlefieldStatus(pop.data);

		table.insert(TBG.DB.popups, pop);

		this.added = true;
	end
end


function TBG_Hooks_Functions_StaticPopupDialogs_ConfirmBattlefieldEntry_OnAccept(data)
	TBG.Var.External.blizzard_interactbg = true;
	Hook_Blizzard_DialogBattlefieldEntryAccept(data);
	TBG.Var.External.blizzard_interactbg = false;
end


function TBG_Hooks_Functions_StaticPopupDialogs_Death_OnShow()
	TBG_Hooks_Functions_RepopMe();
	Hook_Blizzard_DialogDeathOnShow();
end


function TBG_Hooks_Functions_RepopMe()
	local stack = debugstack(4);

	-- If the player is attempting to release via clicking the button or command is typed in chat, then allow.
	if (string.find(stack, "OnClick") or string.find(stack, "ChatFrame")) then
		Hook_Blizzard_RepopMe();

	else

		-- If this is a battleground and automatic release is enabled.
		if (TBG_IsBattleground(TBG.Var.Player.zone) and TBG_Saved("MGB_AutoReleaseGhost")) then

			 -- If the player has a soulstone and auto release is ok, or if they do not have a soulstone.
			 if ((HasSoulstone() and not TBG_Saved("MGB_AutoReleaseCheck")) or not HasSoulstone()) then
				Hook_Blizzard_RepopMe();
			 end
		end
	end
end


function TBG_Hooks_Functions_ToggleDropDownMenu(level, value, dropDownFrame, anchorName, xOffset, yOffset)
	if (TBGX_Menu_DD_DisplayOrderFrame)   then TBGX_Menu_DD_DisplayOrderFrame:Hide();   end
	if (TBGX_Menu1_DD_General_BGJoinPriority_DropDown) then TBGX_Menu1_DD_General_BGJoinPriority_DropDown:Hide(); end

	local name = dropDownFrame;

	if (dropDownFrame ~= nil and type(dropDownFrame) ~= "string") then
		name = dropDownFrame:GetName();
	end

	if (name ~= nil and string.find(name, "TBG")) then
		if (TBG.Var.Addon.drop_down_menu_open) then
			TBG.Var.Addon.drop_down_menu_open = false;
		elseif (dropDownFrame == TBGX_RightClickMenu) then
			TBG.Var.Addon.drop_down_menu_open = dropDownFrame;
		end
	end

	Hook_Blizzard_ToggleDropDownMenu(level, value, dropDownFrame, anchorName, xOffset, yOffset);
end


-- ## Hides or shows the battleground minimap.
function TBG_Hooks_Functions_WorldStateFrame_ToggleMinimap()
	if (TBG_IsArena(TBG.Var.Player.zone)) then return nil; end

	-- If this is a battleground or a world pvp area, determine if the battlemap needs to be shown or hidden.
	local showmap = TBG_Saved("MGI_AutoShowMinimap");

	-- Check if the user has changed the settings for this zone manually.
	if (TBG.Var.External.blizzard_manualshowbg) then
		if (TBG.Var.External.blizzard_manualshowbg == "SHOW") then
			showmap = true;
		elseif (TBG.Var.External.blizzard_manualshowbg == "HIDE") then
			showmap = false;
		end
	end

	BattlefieldMinimap_LoadUI();

	BattlefieldMinimap:UnregisterEvent("PLAYER_ENTERING_WORLD");
	BattlefieldMinimap:UnregisterEvent("ZONE_CHANGE");
	BattlefieldMinimap:UnregisterEvent("ZONE_CHANGED_NEW_AREA");

	-- If we want to show the battlemap.
	if (showmap and not BattlefieldMinimap:IsShown() and (TBG_IsSupported(TBG.Var.Player.zone) or (not TBG_IsSupported(TBG.Var.Player.zone) and TBG.Var.External.blizzard_manualshowbg ~= nil))) then
		if (not IsActiveBattlefieldArena() and BattlefieldMinimap) then
			SHOW_BATTLEFIELD_MINIMAP = "1";
			MiniMapBattlefieldFrame.status = "active";
			BattlefieldMinimap:Show();
		end

	-- If we want to hide the battlemap.
	elseif ((not showmap and BattlefieldMinimap:IsShown()) or (not TBG_IsSupported(TBG.Var.Player.zone) and TBG.Var.External.blizzard_manualshowbg == nil)) then
		if (BattlefieldMinimap) then

			SHOW_BATTLEFIELD_MINIMAP = "0";
			MiniMapBattlefieldFrame.status = "";

			BattlefieldMinimap:Hide();
		end
	end
end


function TBG_Hooks_Functions_WorldStateScoreFrameTab_OnClick(tab)
	if (not tab) then tab = this; end
	TBG.Var.BG.score_frame_tab = tab:GetID();

	Hook_Blizzard_WorldStateScoreFrameTab_OnClick(tab);
end


function TBG_Hooks_Functions_WorldStateScoreFrame_Update(...)
	Hook_Blizzard_WorldStateScoreFrame_Update(...);
	TBG_LeaderBoard_StatFrameColorNamesByClass();
end


function TBG_Hooks_Functions_MiniMapBattlefieldFrame_OnClick()
	if (IsShiftKeyDown()) then
		if ((TBG_Saved("MGI_AutoShowMinimap") and BattlefieldMinimap:IsShown())  or (not TBG_IsSupported(TBG.Var.Player.zone) and BattlefieldMinimap:IsShown())) then
			TBG.Var.External.blizzard_manualshowbg = "HIDE";
		elseif ((not TBG_Saved("MGI_AutoShowMinimap") and not BattlefieldMinimap:IsShown()) or (not TBG_IsSupported(TBG.Var.Player.zone) and not BattlefieldMinimap:IsShown())) then
			TBG.Var.External.blizzard_manualshowbg = "SHOW";
		else
			TBG.Var.External.blizzard_manualshowbg = nil;
		end
	end

	return Hook_Blizzard_MiniMapBattlefieldFrame();
end


function TBG_Hooks_Functions_StaticPopup1Button2OnClick()
	if (TBG_Saved("MGB_AutoJoin") and not TBG.Var.Const.AUTO_JOIN.paused) then
		TBG.Var.Const.AUTO_JOIN.paused = true;
	end

	return Hook_Blizzard_StaticPopup1Button2OnClick();
end


function TBG_Hooks_Functions_BattlefieldMinimapCloseButton()
	if ((TBG_Saved("MGI_AutoShowMinimap") and BattlefieldMinimap:IsShown()) or (not TBG_IsSupported(TBG.Var.Player.zone) and attlefieldMinimap:IsShown())) then
		TBG.Var.External.blizzard_manualshowbg = "HIDE";
	else
		TBG.Var.External.blizzard_manualshowbg = nil;
	end

	return Hook_Blizzard_BattlefieldMinimapCloseButton();
end


function TBG_Hooks_Functions_TitanPanelRightClickMenu_BarOnClick()
	local r = Hook_Titan_TitanPanelRightClickMenu_BarOnClick();

	if (this.value == TBG.Var.Const.ADDON_ID) then
		TBG_Settings_ToggleTitan();
	end

	return r;
end


function TBG_Hooks_Functions_QuestFrameCompleteButton_OnShow()
	local auto  = false;
	local npc   = QuestFrameNpcNameText:GetText();
	local quest = GetTitleText();
	local id    = 0;

	if (TBG_Saved("MGB_AutoTurnInQuests")) then
		if (TBG_Saved("AutoTurnInQuests")[npc] ~= nil and TBG_Saved("AutoTurnInQuests")[npc].names ~= nil and TBG_Saved("AutoTurnInQuests")[npc].names[quest] ~= nil) then
			auto = true;
			id   = TBG_Saved("AutoTurnInQuests")[npc].names[quest];
		end

		if (auto) then
			TBGX_QuestFrame_AutoQuestComplete_Add:Hide();
			TBGX_QuestFrame_AutoQuestComplete_Remove:Show();
		else
			TBGX_QuestFrame_AutoQuestComplete_Add:Show();
			TBGX_QuestFrame_AutoQuestComplete_Remove:Hide();
		end
	end

	if (not TBG_IsModifierKeyDown() and TBG_Saved("MGB_AutoTurnInQuests")) then
		if (auto) then
			if (TBG_Saved("AutoTurnInQuests")[npc].index[id].scanned == false and TBG_Saved("AutoTurnInQuests")[npc].index[id].items == nil) then
				local n = GetNumQuestItems();
				TBG_Saved("AutoTurnInQuests")[npc].index[id].items = { };

				for i = 1, n, 1 do
					local name, _, count = GetQuestItemInfo("required", i);

					TBG_Saved("AutoTurnInQuests")[npc].index[id].items[i]       = { };
					TBG_Saved("AutoTurnInQuests")[npc].index[id].items[i].name  = name;
					TBG_Saved("AutoTurnInQuests")[npc].index[id].items[i].count = count;
				end

				if (n == 0) then
					TBG_Saved("AutoTurnInQuests")[npc].index[id].no_items = true;
				end

				TBG_Saved("AutoTurnInQuests")[npc].index[id].scanned = true;
			end
		end

		-- Complete quest if available and on auto.
		if (IsQuestCompletable() and auto) then
			TBG_Saved("AutoTurnInQuests")[npc].no_items_last_quest = nil;
			TBG_Saved("AutoTurnInQuests")[npc].items_last_quest    = nil;

			local OnClick = QuestFrameCompleteButton:GetScript("OnClick");
			OnClick();
		end

		-- Do not complete quest if on auto and not available.
		if (not IsQuestCompletable() and auto) then

			-- If there was no gossip frame and this quest is not completable, announce.
			if (TBG_Saved("AutoTurnInQuests")[npc].gossip ~= true) then
				TBG_Quest_AnnounceInvalidComplete();
			else

				-- If this quest has items, but cannot be turned in, then do not check it again.
				if (TBG_Saved("AutoTurnInQuests")[npc].index[id].items ~= nil) then
					TBG_Saved("AutoTurnInQuests")[npc].items_last_quest = id;
				end

				-- If this quest has no items to track, but cannot be turned in, do not check it for turn in again.
				if (TBG_Saved("AutoTurnInQuests")[npc].index[id].no_items == true) then
					TBG_Saved("AutoTurnInQuests")[npc].no_items_last_quest = id;
				end

				local OnClick = QuestFrameCancelButton:GetScript("OnClick");
				OnClick();
			end
		end
	end
end


function TBG_Hooks_Functions_QuestFrameCompleteQuestButton_OnShow()
	if (not TBG_IsModifierKeyDown() and TBG_Saved("MGB_AutoTurnInQuests")) then
		local npc   = QuestFrameNpcNameText:GetText();
		local quest = GetTitleText();

		if (TBG_Saved("AutoTurnInQuests")[npc] ~= nil and TBG_Saved("AutoTurnInQuests")[npc].names ~= nil and TBG_Saved("AutoTurnInQuests")[npc].names[quest] ~= nil) then
			local OnClick = QuestFrameCompleteQuestButton:GetScript("OnClick");
			OnClick();
		end
	end
end


function TBG_Hooks_Functions_BattlefieldFrame_OnShow()
	Hook_Blizzard_BattlefieldFrame_OnShow();

	-- If auto queue is enabled.
	if (TBG_Saved("MGB_AutoQueue") and not TBG_IsModifierKeyDown()) then
		local JoinAsAGroup = BattlefieldFrameGroupJoinButton:GetScript("OnClick");
		local Join         = BattlefieldFrameJoinButton:GetScript("OnClick");
		local bg           = BattlefieldFrameFrameLabel:GetText();

		-- If auto queue is enabled for this battleground.
		if (TBG_Saved("MGB_AutoQueue_Which")[bg] == true) then

			-- If the player is in a group and the leader of the group, queue as a group.
			if (UnitIsPartyLeader("player") ~= nil and not TBG_IsModifierKeyDown()) then
				JoinAsAGroup();

			-- Otherwise, queue alone.
			elseif (not TBG_IsModifierKeyDown()) then
				Join();
			end
		end

		TBG_Tip_Generate("QUEUE_AUTO");
	end
end

function TBG_Hooks_Functions_ToggleWorldStateScoreFrame()
	if (TBG_IsSupported(TBG.Var.Player.zone) and TBG_Saved("MGI_LeaderBoard_UseCustomLeaderBoard")) then

		-- Do not show if in an arena and it hasn't been completed yet.
		if (TBG_IsArena(TBG.Var.Player.zone) and GetBattlefieldWinner() == nil) then
			TBGX_LeaderBoard:Hide();
		else

			-- Show if not visible.
			if (not TBGX_LeaderBoard:IsVisible()) then
				TBGX_LeaderBoard:Show();
			else
				TBGX_LeaderBoard:Hide();
			end
		end
	else
		Hook_Blizzard_ToggleWorldStateScoreFrame();
	end
end


function TBG_Hooks_Functions_ShowUIPanel(panel)
	if (panel and panel:GetName() == "WorldStateScoreFrame" and TBG_IsSupported(TBG.Var.Player.zone) and TBG_Saved("MGI_LeaderBoard_UseCustomLeaderBoard")) then
		TBGX_LeaderBoard:Show();
	else
		Hook_Blizzard_ShowUIPanel(panel);
	end
end


function TBG_Hooks_Functions_HideUIPanel(panel)
	if (panel and panel:GetName() == "WorldStateScoreFrame" and TBGX_LeaderBoard) then
		TBGX_LeaderBoard:Hide();
	end

	Hook_Blizzard_HideUIPanel(panel);
end


function TBG_Hooks_Functions_LeaveBattlefield()
	HideUIPanel(WorldStateScoreFrame);
	TBG_Init_ResetPanels();

	if (BattlefieldMinimap) then
		SHOW_BATTLEFIELD_MINIMAP = "0";
		MiniMapBattlefieldFrame.status = "";

		BattlefieldMinimap:Hide();
	end

	TBG.Var.Player.zone = nil;
	Hook_Blizzard_LeaveBattlefield();
end


function TBG_Hooks_Functions_ChatFrame_MessageEventHandler(event)
	if (TBG_IsSupported(TBG.Var.Player.zone)) then

		-- If these options are only enabled for Alterac Valley and this isn't Alterac Valley, then skip.
		if (TBG_Saved("MGI_BG_DoNotShow_AVOnly") and TBG.Var.Player.zone ~= TBG.Text.Ref.BG_AV) then
		else

			-- Looting message.
			if (TBG_Saved("MGI_BG_DoNotShowLoot") and (event == "CHAT_MSG_LOOT" or event == "CHAT_MSG_MONEY")) then return true; end

			-- System message.
			if (event == "CHAT_MSG_SYSTEM") then

				-- Death message.
				if (TBG_Saved("MGI_BG_DoNotShowDeaths") and string.find(arg1, TBG.Text.Ref.PLAYER_DEATH)) then return true; end

				-- Raid change messages.
				if (TBG_Saved("MGI_BG_DoNotShowRaidChanges")) then
					if (string.find(arg1, TBG.Text.Ref.RAID_JOIN))	then return true; end
					if (string.find(arg1, TBG.Text.Ref.RAID_LEAVE)) then return true; end
				end

				-- Battleground change messages.
				if (TBG_Saved("MGI_BG_DoNotShowBattlegroundChanges")) then
					if (string.find(arg1, TBG.Text.Ref.BG_JOIN)) 	then return true; end
					if (string.find(arg1, TBG.Text.Ref.BG_LEAVE)) 	then return true; end
				end
			end
		end
	end

	-- Yell filtering for Alterac Valley.
	if (TBG.Var.Player.zone == TBG.Text.Ref.BG_AV) then
		if (event == "CHAT_MSG_MONSTER_YELL") then

			-- Modify herald messages.
			if (TBG_Saved("MGI_AV_YellConvertHerald") and arg2 == TBG.Text.Ref.AV_HERALD) then

				-- Find appropriate message type.
				if (string.find(arg1, FACTION_ALLIANCE)) then
					TBG_Event_TriggerChatMessage("CHAT_MSG_BG_SYSTEM_ALLIANCE");
				elseif (string.find(arg1, FACTION_HORDE)) then
					TBG_Event_TriggerChatMessage("CHAT_MSG_BG_SYSTEM_HORDE");
				else
					TBG_Event_TriggerChatMessage("CHAT_MSG_BG_SYSTEM_NEUTRAL");
				end

				return true;

			-- Modify boss yells.
			elseif (TBG_Saved("MGI_AV_YellConvertImportant") and TBG.Text.Ref.AV_YELL_BOSS[arg2]) then
				local action = "";
				local text   = "";

				-- If this is not a buff yell, set as engaged.
				if (not string.find(arg1, TBG.Text.Ref.AV_YELL_BOSS[arg2].buff)) then
					action = "ENGAGE";
				end

				-- Check against known engage and reset messages.
				for i = 1, table.getn(TBG.Text.Ref.AV_YELL_BOSS[arg2]) do
					if (string.find(arg1, TBG.Text.Ref.AV_YELL_BOSS[arg2][i].msg)) then
						action = TBG.Text.Ref.AV_YELL_BOSS[arg2][i].action;

						-- If this is an actual engage action, reset the timer. The addon missed a reset somewhere if the timer is not zero.
						if (action == "ENGAGE") then TBG.DB.active.stats.bg.stats.generals[TBG.Text.Ref.AV_YELL_BOSS[arg2].faction].timer = 0; end

						break;
					end
				end

				-- If the boss has been engaged.
				if (action == "ENGAGE" and TBG.DB.active.stats.bg.stats.generals[TBG.Text.Ref.AV_YELL_BOSS[arg2].faction].timer == 0) then
					text                                                                                 = TBG.Text.Message.BG_AV_GENERAL_UNDER_ATTACK;
					TBG.DB.active.stats.bg.stats.generals[TBG.Text.Ref.AV_YELL_BOSS[arg2].faction].timer = GetTime();
				end

				-- If the boss has been reset.
				if (action == "RESET" and TBG.DB.active.stats.bg.stats.generals[TBG.Text.Ref.AV_YELL_BOSS[arg2].faction].timer > 0) then
					text                                                                                 = TBG.Text.Message.BG_AV_GENERAL_RESET;
					TBG.DB.active.stats.bg.stats.generals[TBG.Text.Ref.AV_YELL_BOSS[arg2].faction].timer = 0;
				end

				-- If this is an action, then print it.
				if (text ~= "") then
					arg1 = string.gsub(text, "{faction}", TBG.Text.Ref.AV_YELL_BOSS[arg2].faction, 1);

					if (TBG.Text.Ref.AV_YELL_BOSS[arg2].faction == FACTION_ALLIANCE) then
						TBG_Event_TriggerChatMessage("CHAT_MSG_BG_SYSTEM_ALLIANCE");
					else
						TBG_Event_TriggerChatMessage("CHAT_MSG_BG_SYSTEM_HORDE");
					end
				end

				-- Supress any other messages from this NPC.
				return true;

			-- Modify captain yells.
			elseif (TBG_Saved("MGI_AV_YellConvertImportant") and TBG.Text.Ref.AV_YELL_CAPTAIN[arg2]) then
				local action = "";
				local text   = "";

				-- Check if this is a buff yell.
				if (string.find(arg1, TBG.Text.Ref.AV_YELL_CAPTAIN[arg2].buff.msg)) then
					text = TBG.Text.Ref.AV_YELL_CAPTAIN[arg2].buff.txt;
					arg1 = text;

				-- Check against known engage and reset messages.
				else
					for i = 1, table.getn(TBG.Text.Ref.AV_YELL_CAPTAIN[arg2]) do
						if (string.find(arg1, TBG.Text.Ref.AV_YELL_CAPTAIN[arg2][i].msg)) then
							action = TBG.Text.Ref.AV_YELL_CAPTAIN[arg2][i].action;
							break;
						end
					end

					if (action == "ENGAGE") then text = TBG.Text.Message.BG_AV_CAPTAIN_UNDER_ATTACK; 	end -- If the captain has been engaged.
					if (action == "RESET") 	then text = TBG.Text.Message.BG_AV_CAPTAIN_RESET; 			end -- If the captain has been reset.

					if (text ~= "") then
						arg1 = string.gsub(text, "{faction}", TBG.Text.Ref.AV_YELL_CAPTAIN[arg2].faction, 1);
					end
				end

				if (text ~= "") then
					if (TBG.Text.Ref.AV_YELL_CAPTAIN[arg2].faction == FACTION_ALLIANCE) then
						TBG_Event_TriggerChatMessage("CHAT_MSG_BG_SYSTEM_ALLIANCE");
					else
						TBG_Event_TriggerChatMessage("CHAT_MSG_BG_SYSTEM_HORDE")
					end

					return true;
				end
			end

			if (TBG_Saved("MGI_AV_YellPreventOther")) then

				-- Search the yell and supress.
				for i = 1, table.getn(TBG.Text.Ref.AV_YELL_HIDE) do
					if (string.find(arg1, TBG.Text.Ref.AV_YELL_HIDE[i])) then
						return true;
					end
				end

				-- Search the NPC name and supress.
				for i = 1, table.getn(TBG.Text.Ref.AV_NPC_HIDE) do
					if (string.find(arg2, TBG.Text.Ref.AV_NPC_HIDE[i])) then
						return true;
					end
				end
			end
		end
	end

	Hook_Blizzard_ChatFrame_MessageEventHandler(event);
end


function TBG_Hooks_Functions_RaidGroupButton_OnEnter(frame)
	Hook_Blizzard_RaidGroupButton_OnEnter(frame);


	if (not frame.Hook_Blizzard_OnClick) then

		frame.Hook_Blizzard_OnClick = frame:GetScript("OnClick");
		frame:SetScript("OnClick", function()
			this.Hook_Blizzard_OnClick();

			if (IsControlKeyDown()) then
				if (not TBG.DB.players.assists[UnitName(this.unit)] and UnitName(this.unit) ~= UNKNOWN) then
					TBG.DB.players.assists[UnitName(this.unit)] = { };
					TBG.DB.players.assists[UnitName(this.unit)].target = this.unit .. "target";
					TBG.DB.players.assists[UnitName(this.unit)].unit   = this.unit;
				end

			elseif (IsAltKeyDown()) then
				TBG.DB.players.assists[UnitName(this.unit)] = nil;
			end
		end);
	end
end


function TBG_Hooks_Functions_GameTooltip_SetUnit()
	Hook_Blizzard_GameTooltip_SetUnit();
	TBG_Arena_GetMousePlayer();
end


function TBG_Hooks_Functions_RaidFrame_OnShow()
	Hook_Blizzard_RaidFrame_OnShow();
	TBG_Tip_Generate("ASSIST");
end


function TBG_Hooks_Functions_PVPTeam_Update()
	Hook_Blizzard_PVPTeam_Update();

	for b = 1, 3 do
		local button = getglobal("PVPTeam" .. b .. "Data");

		if (button:IsVisible()) then
			getglobal(button:GetName() .. "RatingLabel"):ClearAllPoints();

			if (not TBG_Saved("MDB_Other_PvPFrame_ArenaPoints")) then
				getglobal(button:GetName() .. "RatingLabel"):SetPoint("LEFT", getglobal(button:GetName() .. "Name"), "RIGHT", 0, 0);

				if (getglobal(button:GetName() .. "PointsLabel")) then
					getglobal(button:GetName() .. "PointsLabel"):Hide();
					getglobal(button:GetName() .. "Points"):Hide();
				end

			else
				local rating = getglobal(button:GetName() .. "Rating"):GetText() + 0;
				local points = 0;

				-- Calculate the amount of points the team will get from this rating.
				if (rating > 1500) then
					points = 2894 / (1 + 259 * math.exp(1) ^ (-0.0025 * rating));
				else
					points = 0.206 * rating + 99;
				end

				points = TBG_MathRound(points, 0);

				-- Modify frames.
				getglobal(button:GetName() .. "RatingLabel"):SetPoint("LEFT", getglobal(button:GetName() .. "Name"), "RIGHT", 0, 6);

				-- Create points if applicable.
				if (not getglobal(button:GetName() .. "PointsLabel")) then
					local label = CreateFrame("Button", button:GetName() .. "PointsLabel", button, "TBGX_Template_Button_MenuList");
					local text  = CreateFrame("Button", button:GetName() .. "Points", button, "TBGX_Template_Button_MenuList");

					getglobal(button:GetName() .. "PointsLabelText"):SetJustifyH("RIGHT");
					getglobal(button:GetName() .. "PointsText"):SetJustifyH("RIGHT");

					label:SetWidth(50);
					label:SetHeight(12);
					text:SetWidth(29);
					text:SetHeight(12);

					getglobal(button:GetName() .. "PointsLabelText"):SetWidth(50);
					getglobal(button:GetName() .. "PointsText"):SetWidth(29);

					getglobal(button:GetName() .. "PointsLabelText"):SetFontObject("GameFontDisableSmall");
					getglobal(button:GetName() .. "PointsText"):SetFontObject("GameFontNormalSmall");

					label:EnableMouse(0);
					text:EnableMouse(0);

					label:SetPoint("TOPLEFT", getglobal(button:GetName() .. "RatingLabel"), "BOTTOMLEFT", 0, 0);
					text:SetPoint("LEFT", getglobal(button:GetName() .. "PointsLabel"), "RIGHT", 5, 0);

					getglobal(button:GetName() .. "PointsLabelText"):SetText(TBG.Text.Label.Other.PVPFRAME_POINTS .. ":");
				end

				-- Set text.
				getglobal(button:GetName() .. "PointsText"):SetText(TBG.Var.Const.COLOR_BLUE .. points);
				getglobal(button:GetName() .. "PointsLabel"):Show();
				getglobal(button:GetName() .. "Points"):Show();
			end
		end
	end
end