TBG_Files_LeaderBoard_IsLoaded = true; -- Indicates this file has been loaded into memory.

function TBG_LeaderBoard_OnLoad()

	TBGX_LeaderBoard_Name.sort = "name";
	TBGX_LeaderBoard_NameText:SetText("Name");

	TBGX_LeaderBoard_Server.sort = "server";
	TBGX_LeaderBoard_ServerText:SetText("Server");

	TBGX_LeaderBoard_ArenaTeam.sort = "team";
	TBGX_LeaderBoard_ArenaTeamText:SetText("Team");

	TBGX_LeaderBoard_ArenaKillingBlows.sort = "kills";
	TBGX_LeaderBoard_ArenaKillingBlowsText:SetText("Killing Blows");
	TBGX_LeaderBoard_ArenaKillingBlowsText:SetJustifyH("CENTER");

	TBGX_LeaderBoard_ArenaDamageDone.sort = "damage";
	TBGX_LeaderBoard_ArenaDamageDoneText:SetText("Damage Done");
	TBGX_LeaderBoard_ArenaDamageDoneText:SetJustifyH("CENTER");

	TBGX_LeaderBoard_ArenaHealingDone.sort = "healing";
	TBGX_LeaderBoard_ArenaHealingDoneText:SetText("Healing Done");
	TBGX_LeaderBoard_ArenaHealingDoneText:SetJustifyH("CENTER");

	TBGX_LeaderBoard_ArenaRating.sort = "rating";
	TBGX_LeaderBoard_ArenaRatingText:SetText("Rating");
	TBGX_LeaderBoard_ArenaRatingText:SetJustifyH("CENTER");

	TBGX_LeaderBoard_ArenaUnratedDamageDone.sort = "damage";
	TBGX_LeaderBoard_ArenaUnratedDamageDoneText:SetText("Damage Done");
	TBGX_LeaderBoard_ArenaUnratedDamageDoneText:SetJustifyH("CENTER");

	TBGX_LeaderBoard_ArenaUnratedHealingDone.sort = "healing";
	TBGX_LeaderBoard_ArenaUnratedHealingDoneText:SetText("Healing Done");
	TBGX_LeaderBoard_ArenaUnratedHealingDoneText:SetJustifyH("CENTER");

	TBGX_LeaderBoard_KillingBlows.sort = "kills";
	TBGX_LeaderBoard_KillingBlowsText:SetText("Killing Blows");
	TBGX_LeaderBoard_KillingBlowsText:SetJustifyH("CENTER");

	TBGX_LeaderBoard_Deaths.sort = "deaths";
	TBGX_LeaderBoard_DeathsText:SetText("Deaths");
	TBGX_LeaderBoard_DeathsText:SetJustifyH("CENTER");

	TBGX_LeaderBoard_HonorableKills.sort = "hk";
	TBGX_LeaderBoard_HonorableKillsText:SetText("Honorable Kills");
	TBGX_LeaderBoard_HonorableKillsText:SetJustifyH("CENTER");

	TBGX_LeaderBoard_DamageDone.sort = "damage";
	TBGX_LeaderBoard_DamageDoneText:SetText("Damage Done");
	TBGX_LeaderBoard_DamageDoneText:SetJustifyH("CENTER");

	TBGX_LeaderBoard_HealingDone.sort = "healing";
	TBGX_LeaderBoard_HealingDoneText:SetText("Healing Done");
	TBGX_LeaderBoard_HealingDoneText:SetJustifyH("CENTER");

	TBGX_LeaderBoard_BonusHonor.sort = "cp";
	TBGX_LeaderBoard_BonusHonorText:SetText("Bonus Honor");
	TBGX_LeaderBoard_BonusHonorText:SetJustifyH("CENTER");

	TBGX_LeaderBoard_Column1Text:SetJustifyH("CENTER");
	TBGX_LeaderBoard_Column2Text:SetJustifyH("CENTER");
	TBGX_LeaderBoard_Column3Text:SetJustifyH("CENTER");
	TBGX_LeaderBoard_Column4Text:SetJustifyH("CENTER");
	TBGX_LeaderBoard_Column5Text:SetJustifyH("CENTER");

	TBGX_LeaderBoard_Class.sortType  = "class";
	TBGX_LeaderBoard_Column1.sort    = "stat1";
	TBGX_LeaderBoard_Column2.sort    = "stat2";
	TBGX_LeaderBoard_Column3.sort    = "stat3";
	TBGX_LeaderBoard_Column4.sort    = "stat4";
	TBGX_LeaderBoard_Column5.sort    = "stat5";
end


function TBG_LeaderBoard_OnShow()
	PanelTemplates_SetNumTabs(this, 3);
	TBG_LeaderBoard_Resize();

	TBG.Var.General.leader_board_tab = "ALL";
	TBG_LeaderBoard_SetHeader();
	PanelTemplates_SetTab(TBGX_LeaderBoard, 1);

	TBG_LeaderBoard_UpdatePlayers();
end


function TBG_LeaderBoard_OnUpdate() end


function TBG_LeaderBoard_UpdateList()
	local frame        = "TBGX_LeaderBoard";
	local winner       = GetBattlefieldWinner();

	-- If the battleground has been won.
	if (winner) then
		getglobal(frame .. "_PlayerCount"):Hide();
		getglobal(frame .. "_LeaveButton"):Show();

		local close_time = TBG_SecondsToTime(GetBattlefieldInstanceExpiration() / 1000, 1);

		-- Set up battleground closing in estimate.
		if (TBG.DB.active.stats.bg.close_estimate == nil) then TBG.DB.active.stats.bg.close_estimate = GetTime() + TBG.Var.BG.bg_close_delay; end

		-- If close time is unavailable, guess.
		if (close_time == "") then
			local t = TBG_SecondsToTime(TBG.DB.active.stats.bg.close_estimate - GetTime(), 1);

			if (t ~= nil and t ~= "") then close_time = "~ " .. t; end
		end

		-- If the close time is completely unavailable.
		if (close_time == nil or close_time == "") then
			getglobal(frame .. "_ClosingIn"):Hide();

		else
			local closing_in = TIME_TO_PORT .. TBG.Var.Const.COLOR_RED .. " " .. close_time .. TBG.Var.Const.COLOR_WHITE .. ".";

			getglobal(frame .. "_ClosingIn"):SetText(closing_in);
			getglobal(frame .. "_ClosingIn"):Show();
			getglobal(frame .. "_ClosingIn"):ClearAllPoints();
		end

		if (TBG_LeaderBoard_GetPlayerCount() > MAX_WORLDSTATE_SCORE_BUTTONS) then
			getglobal(frame .. "_ClosingIn"):SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -154, 80);
		else
			getglobal(frame .. "_ClosingIn"):SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -124, 80);
		end

		TBG_LeaderBoard_SetHeader();
	else
		getglobal(frame .. "_PlayerCount"):Show();
		getglobal(frame .. "_LeaveButton"):Hide();
		getglobal(frame .. "_ClosingIn"):Hide();
	end

	local time_elapsed = TIME_ELAPSED;

	-- Set the time elapsed.
	if (TBG.DB.active.stats.bg.run ~= nil and TBG.DB.active.stats.bg.run ~= "" and TBG.DB.active.stats.bg.run > 0) then
		time_elapsed = time_elapsed .. TBG.Var.Const.COLOR_WHITE .. " " .. TBG_SecondsToTime(TBG.DB.active.stats.bg.run / 1000, 1);
	else
		if (TBG.DB.active.stats.bg.run_estimate ~= nil and TBG.DB.active.stats.bg.run_estimate ~= "" and TBG.DB.active.stats.bg.run_estimate > 0) then
			time_elapsed = time_elapsed .. TBG.Var.Const.COLOR_WHITE .. " ~ " .. TBG_SecondsToTime(GetTime() - TBG.DB.active.stats.bg.run_estimate, 1);
		else
			time_elapsed = time_elapsed .. TBG.Var.Const.COLOR_RED .. " " .. TBG.Text.Label.Tooltip.INSTANCE_RUN_TIME_NA;
		end
	end

	if (winner and TBG.Var.BG.final_bg_run_time == 0) then
		TBG.Var.BG.final_bg_run_time = time_elapsed;
	end

	if (winner) then
		time_elapsed = TBG.Var.BG.final_bg_run_time;
	end

	getglobal(frame .. "_BattlegroundRunTime"):SetText(time_elapsed);
	getglobal(frame .. "_BattlegroundRunTime"):ClearAllPoints();
	getglobal(frame .. "_BattlegroundRunTime"):SetPoint("TOPRIGHT", TBG.Var.BG.leader_board_last_button, "BOTTOMRIGHT", -2, -4);
end


function TBG_LeaderBoard_UpdatePlayers()
	local nscores      = table.getn(TBG.DB.players.list);
	local scroll_bar   = false;
	local frame        = "TBGX_LeaderBoard";
	local winner       = GetBattlefieldWinner();
	local arena, rated = IsActiveBattlefieldArena();

	-- Set up the scroll frame.
	local displayed_scores = TBG_LeaderBoard_GetPlayerCount();
	FauxScrollFrame_Update(getglobal(frame .. "_ScrollFrame"), displayed_scores, MAX_WORLDSTATE_SCORE_BUTTONS, 10);

	-- Update the scroll bar.
	if (displayed_scores > MAX_WORLDSTATE_SCORE_BUTTONS) then
		scroll_bar = true;
		getglobal(frame .. "_ScrollFrame"):Show();
	else
		getglobal(frame .. "_ScrollFrame"):Hide();
    end

	local pcount = 0;
	local offset = FauxScrollFrame_GetOffset(getglobal(frame .. "_ScrollFrame")) + 1;
	local b      = 1;

	-- Loop through all the players.
	for i = 1, nscores do
		if (not getglobal(frame .. "_ListButton" .. b)) then break; end

		local player = TBG.DB.players.names[TBG.DB.players.list[i]];

		if (TBG.Var.General.leader_board_tab == "HORDE" and player.faction ~= FACTION_HORDE) then
		elseif (TBG.Var.General.leader_board_tab == "ALLIANCE" and player.faction ~= FACTION_ALLIANCE) then
		else
			pcount = pcount + 1;
			if (pcount >= offset) then
				local button = { };
				local color  = "";

				button.ref           = getglobal(frame .. "_ListButton" .. b);
				button.texture_left  = getglobal(button.ref:GetName() .. "_FactionLeft");
				button.texture_right = getglobal(button.ref:GetName() .. "_FactionRight");

				button.class           = getglobal(button.ref:GetName() .. "_ClassIcon");
				button.name            = getglobal(button.ref:GetName() .. "_NameText");
				button.server          = getglobal(button.ref:GetName() .. "_ServerText");
				button.killing_blows   = getglobal(button.ref:GetName() .. "_KillingBlows");
				button.deaths          = getglobal(button.ref:GetName() .. "_Deaths");
				button.honorable_kills = getglobal(button.ref:GetName() .. "_HonorableKills");
				button.damage_done     = getglobal(button.ref:GetName() .. "_DamageDone");
				button.healing_done    = getglobal(button.ref:GetName() .. "_HealingDone");
				button.bonus_honor     = getglobal(button.ref:GetName() .. "_BonusHonor");

				button.arena_team          = getglobal(button.ref:GetName() .. "_ArenaTeamText");
				button.arena_killing_blows = getglobal(button.ref:GetName() .. "_ArenaKillingBlows");
				button.arena_damage_done   = getglobal(button.ref:GetName() .. "_ArenaDamageDone");
				button.arena_healing_done  = getglobal(button.ref:GetName() .. "_ArenaHealingDone");
				button.arena_honor         = getglobal(button.ref:GetName() .. "_ArenaRating");

				button.arena_unrated_damage_done   = getglobal(button.ref:GetName() .. "_ArenaUnratedDamageDone");
				button.arena_unrated_healing_done  = getglobal(button.ref:GetName() .. "_ArenaUnratedHealingDone");

				button.column    = { };
				button.column[1] = getglobal(button.ref:GetName() .. "_Column1");
				button.column[2] = getglobal(button.ref:GetName() .. "_Column2");
				button.column[3] = getglobal(button.ref:GetName() .. "_Column3");
				button.column[4] = getglobal(button.ref:GetName() .. "_Column4");
				button.column[5] = getglobal(button.ref:GetName() .. "_Column5");

				-- Set background colors.
				if (arena) then
					if (player.faction_number == 0) then
						button.texture_left:SetVertexColor(0.19, 0.57, 0.11);
						button.texture_right:SetVertexColor(0.19, 0.57, 0.11);
						button.name:SetVertexColor(0.1, 1.0, 0.1);
					else
						button.texture_left:SetVertexColor(0.85, 0.71, 0.26);
						button.texture_right:SetVertexColor(0.85, 0.71, 0.26);
						button.name:SetVertexColor(1, 0.82, 0);
					end
				else
					if (player.faction == FACTION_HORDE) then
						button.texture_left:SetVertexColor(0.52, 0.075, 0.18);
						button.texture_right:SetVertexColor(0.5, 0.075, 0.18);
						button.name:SetVertexColor(1.0, 0.1, 0.1);
					else
						button.texture_left:SetVertexColor(0.11, 0.26, 0.51);
						button.texture_right:SetVertexColor(0.11, 0.26, 0.51);
						button.name:SetVertexColor(0, 0.68, 0.94);
					end
				end

				if (TBG_Saved("MGI_ScoreFrame_ColorNamesByClass")) then
					if (TBG_Saved("MGI_ScoreFrame_ColorNamesByClassAll") and TBG.Var.General.leader_board_tab == "ALL") then
					else
						color = TBG.Var.Const.COLOR_CLASS[TBG.Var.Const.NAME_CLASS[player.class]].color;
					end
				end

				-- If this is the user.
				if (player.name == TBG.Var.Player.name) then
					if (TBG_Saved("MGI_ScoreFrame_ColorNamesNotPlayer")) then color = "";            end
					if (TBG_Saved("MGI_ScoreFrame_PlayerNameMark"))      then color = color .. "* "; end

					button.name:SetVertexColor(1.0, 0.82, 0);
				end

				-- Show class icon.
				if (player.class_image) then
					local coords = CLASS_BUTTONS[player.class_image];

					button.class:SetTexture("Interface\\WorldStateFrame\\Icons-Classes");
					button.class:SetTexCoord(coords[1], coords[2], coords[3], coords[4]);
					button.class:Show();
				else
					button.class:Hide();
				end

				button.name:SetText(color .. player.name);
				button.server:SetText(player.server);

				if (arena) then
					if (rated) then
						local team, old_rating, new_rating = GetBattlefieldTeamInfo(player.faction_number);

						button.arena_team:SetText(team);
						button.arena_killing_blows:SetText(player.killing_blows);
						button.arena_damage_done:SetText(player.damage);
						button.arena_healing_done:SetText(player.healing);
						button.arena_honor:SetText(new_rating - old_rating);

					else
						button.killing_blows:SetText(player.killing_blows);
						button.arena_unrated_damage_done:SetText(player.damage);
						button.arena_unrated_healing_done:SetText(player.healing);
					end
				else
					button.killing_blows:SetText(player.killing_blows);
					button.deaths:SetText(player.deaths);
					button.honorable_kills:SetText(player.kills);
					button.damage_done:SetText(player.damage);
					button.healing_done:SetText(player.healing);
					button.bonus_honor:SetText(player.honor);
				end

				-- Create tooltip.
				local color = TBG.Var.Const.COLOR_RED;
				if (player.faction == FACTION_ALLIANCE) then color = TBG.Var.Const.COLOR_BLUE; end

				button.name:GetParent().tooltip = color .. player.name .. TBG.Var.Const.COLOR_WHITE .. " - " .. TBG.Var.Const.COLOR_CLASS[TBG.Var.Const.NAME_CLASS[player.class]].color .. player.class .. TBG.Var.Const.COLOR_YELLOW .. " (" .. TBG.Var.Const.COLOR_WHITE .. player.race .. TBG.Var.Const.COLOR_YELLOW .. ")\n";
				button.name:GetParent().tooltip = button.name:GetParent().tooltip .. TBG.Var.Const.COLOR_YELLOW .. player.server;

				if (not arena) then

					-- Hide all objective columns.
					for d = 1, 5 do
						getglobal(button.column[d]:GetName() .. "_Icon"):Hide();
						getglobal(button.column[d]:GetName() .. "_IconText"):Hide();
						getglobal(button.column[d]:GetName() .. "_Text"):Hide();
					end

					-- Show all appropriate objectives.
					if (player.data and (TBG.Var.Player.zone == TBG.Text.Ref.BG_AB or TBG.Var.Player.zone == TBG.Text.Ref.BG_AV or TBG.Var.Player.zone == TBG.Text.Ref.BG_WSG)) then
						for d = 1, 5 do
							if (TBG.Var.Player.zone == TBG.Text.Ref.BG_AB and d > 2)  then break; end
							if (TBG.Var.Player.zone == TBG.Text.Ref.BG_WSG and d > 2) then break; end

							if (player.data[d] and player.data[d].count > 0) then
								if (TBG.Var.Player.zone == TBG.Text.Ref.BG_AV and d == 5) then
									getglobal(button.column[d]:GetName() .. "_Text"):SetText(player.data[d].count);
									getglobal(button.column[d]:GetName() .. "_Text"):Show();
								else
									getglobal(button.column[d]:GetName() .. "_Icon"):SetTexture(player.data[d].icon .. player.faction_number);
									getglobal(button.column[d]:GetName() .. "_IconText"):SetText("x " .. player.data[d].count);
									getglobal(button.column[d]:GetName() .. "_IconText"):Show();
									getglobal(button.column[d]:GetName() .. "_Icon"):Show();
								end
							end
						end
					end
				end

				-- Resize and show the button.
				TBG_LeaderBoard_ResizeListItem(button);
				button.ref:Show();

				b = b + 1;
			end
		end
	end

	TBG.Var.BG.leader_board_last_button = getglobal(frame .. "_ListButton" .. (b - 1));
	TBG_LeaderBoard_UpdateList();

	-- Hide unused buttons.
	if (b <= MAX_WORLDSTATE_SCORE_BUTTONS) then
		for i = b, MAX_WORLDSTATE_SCORE_BUTTONS do
			getglobal(frame .. "_ListButton" .. i):Hide();
		end
	end

	-- Set the number of players in the battleground.
	if (not winner) then
		local players_alliance = TBG.Var.Const.COLOR_WHITE .. TBG.DB.players.alliance .. " " .. TBG.Var.Const.COLOR_YELLOW .. TBG.Text.Message.LEADER_BOARD_PLAYER_COUNT_ALLIANCE;
		local players_horde    = TBG.Var.Const.COLOR_WHITE .. TBG.DB.players.horde .. " " .. TBG.Var.Const.COLOR_YELLOW .. TBG.Text.Message.LEADER_BOARD_PLAYER_COUNT_HORDE;
		local players          = players_alliance .. " / " .. players_horde;

		getglobal(frame .. "_PlayerCount"):SetText(players);
		getglobal(frame .. "_PlayerCount"):ClearAllPoints();
		getglobal(frame .. "_PlayerCount"):SetPoint("TOPLEFT", TBG.Var.BG.leader_board_last_button, "BOTTOMLEFT", 2, -4);
	end

end


-- ## Returns how many actual leader board list items can be displayed.
function TBG_LeaderBoard_GetPlayerCount()
	if (TBG.Var.General.leader_board_tab == "HORDE") then
		return TBG.DB.players.horde;
	elseif (TBG.Var.General.leader_board_tab == "ALLIANCE") then
		return TBG.DB.players.alliance;
	else
		if (TBG.DB.players.list ~= nil) then
			return table.getn(TBG.DB.players.list);
		end
	end

	return 0;
end


-- ## When one of the leader board tabs is clicked.
function TBG_LeaderBoard_Tab_OnClick(tab)
	if (not tab) then tab = this; end

	local faction = tab:GetID();

	PanelTemplates_SetTab(TBGX_LeaderBoard, faction);

	if (faction == 2) then
		faction = "ALLIANCE";
	elseif (faction == 3) then
		faction = "HORDE";
	else
		faction = "ALL";
	end

	TBG.Var.General.leader_board_tab = faction;
	TBG_LeaderBoard_SetHeader();
	TBG_LeaderBoard_UpdatePlayers();
	PlaySound("igCharacterInfoTab");
end


-- ## Sets the leader board header appropriate to the current status of the battleground and leader board.
function TBG_LeaderBoard_SetHeader()
	local winner = GetBattlefieldWinner();

	if (winner ~= nil) then
		local arena, rated                 = IsActiveBattlefieldArena();
		local team, old_rating, new_rating = GetBattlefieldTeamInfo(winner);

		if (winner == 0) then
			if (arena) then
				TBGX_LeaderBoard_WinnerLeft:SetVertexColor(0.19, 0.57, 0.11);
				TBGX_LeaderBoard_WinnerRight:SetVertexColor(0.19, 0.57, 0.11);

				TBGX_LeaderBoard_Winner_Text:SetVertexColor(0.1, 1.0, 0.1);

				if (rated and team) then
					TBGX_LeaderBoard_Winner_Text:SetText(team .. " Wins");
				elseif (rated) then
					TBGX_LeaderBoard_Winner_Text:SetText(VICTORY_TEXT_ARENA_DRAW);
				else
					TBGX_LeaderBoard_Winner_Text:SetText("Green Team Wins");
				end
			else
				TBGX_LeaderBoard_WinnerLeft:SetVertexColor(0.52, 0.075, 0.18);
				TBGX_LeaderBoard_WinnerRight:SetVertexColor(0.5, 0.075, 0.18);

				TBGX_LeaderBoard_Winner_Text:SetVertexColor(1.0, 0.1, 0.1);
				TBGX_LeaderBoard_Winner_Text:SetText("Horde Wins");
			end
		else
			if (arena) then
				TBGX_LeaderBoard_WinnerLeft:SetVertexColor(0.85, 0.71, 0.26);
				TBGX_LeaderBoard_WinnerRight:SetVertexColor(0.85, 0.71, 0.26);

				TBGX_LeaderBoard_Winner_Text:SetVertexColor(1, 0.82, 0);

				if (rated and team) then
					TBGX_LeaderBoard_Winner_Text:SetText(team .. " Wins");
				elseif (rated) then
					TBGX_LeaderBoard_Winner_Text:SetText(VICTORY_TEXT_ARENA_DRAW);
				else
					TBGX_LeaderBoard_Winner_Text:SetText("Gold Team Wins");
				end
			else
				TBGX_LeaderBoard_WinnerLeft:SetVertexColor(0.11, 0.26, 0.51);
				TBGX_LeaderBoard_WinnerRight:SetVertexColor(0.11, 0.26, 0.51);

				TBGX_LeaderBoard_Winner_Text:SetVertexColor(0, 0.68, 0.94);
				TBGX_LeaderBoard_Winner_Text:SetText("Alliance Wins");
			end
		end

		TBGX_LeaderBoard_Winner:Show();
	else
		TBGX_LeaderBoard_Header:SetVertexColor(1.0, 0.82, 0);

		if (TBG.Var.General.leader_board_tab == "ALLIANCE") then
			TBGX_LeaderBoard_Header:SetText("Alliance Stats");
		elseif (TBG.Var.General.leader_board_tab == "HORDE") then
			TBGX_LeaderBoard_Header:SetText("Horde Stats");
		else
			TBGX_LeaderBoard_Header:SetText("All Stats");
		end

		TBGX_LeaderBoard_Winner:Hide();
	end
end


-- ## Resizes the leader board frame based on location.
function TBG_LeaderBoard_Resize()
	local frame        = "TBGX_LeaderBoard";
	local arena, rated = IsActiveBattlefieldArena();

	if (arena) then
		getglobal(frame .. "_Deaths"):Hide();
		getglobal(frame .. "_HonorableKills"):Hide();
		getglobal(frame .. "_DamageDone"):Hide();
		getglobal(frame .. "_HealingDone"):Hide();
		getglobal(frame .. "_BonusHonor"):Hide();

		getglobal(frame .. "_Column1"):Hide();
		getglobal(frame .. "_Column2"):Hide();
		getglobal(frame .. "_Column3"):Hide();
		getglobal(frame .. "_Column4"):Hide();
		getglobal(frame .. "_Column5"):Hide();

		getglobal(frame .. "Tab2"):Hide();
		getglobal(frame .. "Tab3"):Hide();

		if (rated) then
			getglobal(frame .. "_KillingBlows"):Hide();
			getglobal(frame .. "_ArenaUnratedDamageDone"):Hide();
			getglobal(frame .. "_ArenaUnratedHealingDone"):Hide();

			getglobal(frame .. "_ArenaTeam"):Show();
			getglobal(frame .. "_ArenaKillingBlows"):Show();
			getglobal(frame .. "_ArenaDamageDone"):Show();
			getglobal(frame .. "_ArenaHealingDone"):Show();
			getglobal(frame .. "_ArenaRating"):Show();

			getglobal(frame):SetWidth(710);
		else

			getglobal(frame .. "_ArenaTeam"):Hide();
			getglobal(frame .. "_ArenaKillingBlows"):Hide();
			getglobal(frame .. "_ArenaDamageDone"):Hide();
			getglobal(frame .. "_ArenaHealingDone"):Hide();
			getglobal(frame .. "_ArenaRating"):Hide();

			getglobal(frame .. "_ArenaUnratedDamageDone"):Show();
			getglobal(frame .. "_ArenaUnratedHealingDone"):Show();

			getglobal(frame):SetWidth(560);
		end

	else
		getglobal(frame .. "_ArenaTeam"):Hide();
		getglobal(frame .. "_ArenaKillingBlows"):Hide();
		getglobal(frame .. "_ArenaDamageDone"):Hide();
		getglobal(frame .. "_ArenaHealingDone"):Hide();
		getglobal(frame .. "_ArenaRating"):Hide();
		getglobal(frame .. "_ArenaUnratedDamageDone"):Hide();
		getglobal(frame .. "_ArenaUnratedHealingDone"):Hide();

		getglobal(frame .. "_KillingBlows"):Show();
		getglobal(frame .. "_Deaths"):Show();
		getglobal(frame .. "_HonorableKills"):Show();
		getglobal(frame .. "_DamageDone"):Show();
		getglobal(frame .. "_HealingDone"):Show();
		getglobal(frame .. "_BonusHonor"):Show();

		getglobal(frame .. "Tab2"):Show();
		getglobal(frame .. "Tab3"):Show();

		if (TBG.Var.Player.zone == TBG.Text.Ref.BG_AV) then
			getglobal(frame .. "_Column1Text"):SetText("Graveyards Assaulted");
			getglobal(frame .. "_Column1"):SetWidth(70);
			getglobal(frame .. "_Column1"):Show();

			getglobal(frame .. "_Column2Text"):SetText("Graveyards Defended");
			getglobal(frame .. "_Column2"):SetWidth(70);
			getglobal(frame .. "_Column2"):Show();

			getglobal(frame .. "_Column3Text"):SetText("Towers Assaulted");
			getglobal(frame .. "_Column3"):SetWidth(60);
			getglobal(frame .. "_Column3"):Show();

			getglobal(frame .. "_Column4Text"):SetText("Towers Defended");
			getglobal(frame .. "_Column4"):SetWidth(60);
			getglobal(frame .. "_Column4"):Show();

			getglobal(frame .. "_Column5Text"):SetText("Secondary Objectives");
			getglobal(frame .. "_Column5"):SetWidth(60);
			getglobal(frame .. "_Column5"):Show();

			getglobal(frame):SetWidth(1100);

		elseif (TBG.Var.Player.zone == TBG.Text.Ref.BG_AB) then
			getglobal(frame .. "_Column1Text"):SetText("Bases Assaulted");
			getglobal(frame .. "_Column1"):SetWidth(70);
			getglobal(frame .. "_Column1"):Show();

			getglobal(frame .. "_Column2Text"):SetText("Bases Defended");
			getglobal(frame .. "_Column2"):SetWidth(70);
			getglobal(frame .. "_Column2"):Show();

			getglobal(frame):SetWidth(910);

		elseif (TBG.Var.Player.zone == TBG.Text.Ref.BG_WSG) then
			getglobal(frame .. "_Column1Text"):SetText("Flag Captures");
			getglobal(frame .. "_Column1"):SetWidth(60);
			getglobal(frame .. "_Column1"):Show();

			getglobal(frame .. "_Column2Text"):SetText("Flag Returns");
			getglobal(frame .. "_Column2"):SetWidth(50);
			getglobal(frame .. "_Column2"):Show();

			getglobal(frame):SetWidth(860);

		else
			getglobal(frame .. "_Column1"):Hide();
			getglobal(frame .. "_Column2"):Hide();

			getglobal(frame):SetWidth(770);
		end

		if (TBG.Var.Player.zone ~= TBG.Text.Ref.BG_AV) then
			getglobal(frame .. "_Column3"):Hide();
			getglobal(frame .. "_Column4"):Hide();
			getglobal(frame .. "_Column5"):Hide();
		end
	end
end


-- ## Resizes the specified leader board list item.
function TBG_LeaderBoard_ResizeListItem(button)
	local frame        = "TBGX_LeaderBoard";
	local arena, rated = IsActiveBattlefieldArena();

	if (arena) then
		button.deaths:Hide();
		button.honorable_kills:Hide();
		button.damage_done:Hide();
		button.healing_done:Hide();
		button.bonus_honor:Hide();

		getglobal(button.ref:GetName() .. "_Column1"):Hide();
		getglobal(button.ref:GetName() .. "_Column2"):Hide();
		getglobal(button.ref:GetName() .. "_Column3"):Hide();
		getglobal(button.ref:GetName() .. "_Column4"):Hide();
		getglobal(button.ref:GetName() .. "_Column5"):Hide();

		if (rated) then
			button.killing_blows:Hide();
			button.arena_unrated_damage_done:Hide();
			button.arena_unrated_healing_done:Hide();

			button.arena_team:Show();
			button.arena_killing_blows:Show();
			button.arena_damage_done:Show();
			button.arena_healing_done:Show();
			button.arena_honor:Show();

			button.ref:SetWidth(542);
		else
			button.arena_team:Hide();
			button.arena_killing_blows:Hide();
			button.arena_damage_done:Hide();
			button.arena_healing_done:Hide();
			button.arena_honor:Hide();

			button.killing_blows:Show();
			button.arena_unrated_damage_done:Show();
			button.arena_unrated_healing_done:Show();

			button.ref:SetWidth(392);
		end

	else
		button.killing_blows:Show();
		button.deaths:Show();
		button.honorable_kills:Show();
		button.damage_done:Show();
		button.healing_done:Show();
		button.bonus_honor:Show();

		button.arena_team:Hide();
		button.arena_killing_blows:Hide();
		button.arena_damage_done:Hide();
		button.arena_healing_done:Hide();
		button.arena_honor:Hide();

		button.arena_unrated_damage_done:Hide();
		button.arena_unrated_healing_done:Hide();

		if (TBG.Var.Player.zone == TBG.Text.Ref.BG_AV) then
			getglobal(button.ref:GetName() .. "_Column1"):ClearAllPoints();
			getglobal(button.ref:GetName() .. "_Column2"):ClearAllPoints();
			getglobal(button.ref:GetName() .. "_Column3"):ClearAllPoints();
			getglobal(button.ref:GetName() .. "_Column4"):ClearAllPoints();
			getglobal(button.ref:GetName() .. "_Column5"):ClearAllPoints();

			getglobal(button.ref:GetName() .. "_Column1"):SetPoint("CENTER", button.ref, "LEFT", 638, 2);
			getglobal(button.ref:GetName() .. "_Column2"):SetPoint("CENTER", button.ref, "LEFT", 708, 2);
			getglobal(button.ref:GetName() .. "_Column3"):SetPoint("CENTER", button.ref, "LEFT", 776, 2);
			getglobal(button.ref:GetName() .. "_Column4"):SetPoint("CENTER", button.ref, "LEFT", 836, 2);
			getglobal(button.ref:GetName() .. "_Column5"):SetPoint("CENTER", button.ref, "LEFT", 900, 2);

			getglobal(button.ref:GetName() .. "_Column1"):Show();
			getglobal(button.ref:GetName() .. "_Column2"):Show();
			getglobal(button.ref:GetName() .. "_Column3"):Show();
			getglobal(button.ref:GetName() .. "_Column4"):Show();
			getglobal(button.ref:GetName() .. "_Column5"):Show();

			button.ref:SetWidth(934);

		elseif (TBG.Var.Player.zone == TBG.Text.Ref.BG_AB) then
			getglobal(button.ref:GetName() .. "_Column1"):ClearAllPoints();
			getglobal(button.ref:GetName() .. "_Column2"):ClearAllPoints();

			getglobal(button.ref:GetName() .. "_Column1"):SetPoint("CENTER", button.ref, "LEFT", 640, 2);
			getglobal(button.ref:GetName() .. "_Column2"):SetPoint("CENTER", button.ref, "LEFT", 712, 2);

			getglobal(button.ref:GetName() .. "_Column1"):Show();
			getglobal(button.ref:GetName() .. "_Column2"):Show();

			getglobal(button.ref:GetName() .. "_Column3"):Hide();
			getglobal(button.ref:GetName() .. "_Column4"):Hide();
			getglobal(button.ref:GetName() .. "_Column5"):Hide();

			button.ref:SetWidth(742);

		elseif (TBG.Var.Player.zone == TBG.Text.Ref.BG_WSG) then
			getglobal(button.ref:GetName() .. "_Column1"):ClearAllPoints();
			getglobal(button.ref:GetName() .. "_Column2"):ClearAllPoints();

			getglobal(button.ref:GetName() .. "_Column1"):SetPoint("CENTER", button.ref, "LEFT", 634, 2);
			getglobal(button.ref:GetName() .. "_Column2"):SetPoint("CENTER", button.ref, "LEFT", 690, 2);

			getglobal(button.ref:GetName() .. "_Column1"):Show();
			getglobal(button.ref:GetName() .. "_Column2"):Show();

			getglobal(button.ref:GetName() .. "_Column3"):Hide();
			getglobal(button.ref:GetName() .. "_Column4"):Hide();
			getglobal(button.ref:GetName() .. "_Column5"):Hide();

			button.ref:SetWidth(691);

		else
			getglobal(button.ref:GetName() .. "_Column1"):Hide();
			getglobal(button.ref:GetName() .. "_Column2"):Hide();
			getglobal(button.ref:GetName() .. "_Column3"):Hide();
			getglobal(button.ref:GetName() .. "_Column4"):Hide();
			getglobal(button.ref:GetName() .. "_Column5"):Hide();

			button.ref:SetWidth(602);
		end
	end

	if (TBG_LeaderBoard_GetPlayerCount() <= MAX_WORLDSTATE_SCORE_BUTTONS) then
		button.ref:SetWidth(button.ref:GetWidth() + 30);
	end
end


-- ## Retrieve and store player data.
function TBG_LeaderBoard_GetPlayerData(force)
	if (not TBG_IsSupported(TBG.Var.Player.zone)) then return nil; end
	TBG.Var.BG.update_last = GetTime();

	if (force == nil) then force = false; end

	local players_changed = false; -- Indicates if any new players were added on this rotation, or old players were removed.
	local friends         = "";
	local players_server  = { list = { },  names = { }, };
	local servers         = { [FACTION_ALLIANCE] = { index = { }, reference = { }, }, [FACTION_HORDE] = { index = { }, reference = { }, }, };
	local players         = { list = { },  horde = 0, alliance = 0, };
	      players.classes = {
				[1] = {
					["WARRIOR"] = 0,
					["DRUID"]   = 0,
					["MAGE"]    = 0,
					["WARLOCK"] = 0,
					["ROGUE"]   = 0,
					["HUNTER"]  = 0,
					["PRIEST"]  = 0,
					["PALADIN"] = 0,
					["SHAMAN"]  = 0,
				},

				[0] = {
					["WARRIOR"] = 0,
					["DRUID"]   = 0,
					["MAGE"]    = 0,
					["WARLOCK"] = 0,
					["ROGUE"]   = 0,
					["HUNTER"]  = 0,
					["PRIEST"]  = 0,
					["PALADIN"] = 0,
					["SHAMAN"]  = 0,
				},
			};

	-- Update battlefield score data.
	RequestBattlefieldScoreData();

	TBG.Var.General.players_list_updated = force;

	-- Loop through all the players.
	for i = 1, GetNumBattlefieldScores() do
		local name_and_server, killing_blows, kills, deaths, honor, faction_number, rank, race, class, class_image, damage, healing = GetBattlefieldScore(i);

		if (name_and_server ~= nil) then
			local name    = "";
			local faction = "";
			local id      = "";

			-- Split player name and server name.
			if (string.find(name_and_server, "-")) then
				server = string.sub(name_and_server, string.find(name_and_server, "-") + 1, string.len(name_and_server));
				name   = string.sub(name_and_server, 1, string.find(name_and_server, "-") - 1);
			else
				name   = name_and_server;
				server = TBG.Var.Player.realm;
			end

			-- Faction
			if (faction_number == 0) then
				players.horde = players.horde + 1;
				faction       = FACTION_HORDE;
			else
				players.alliance = players.alliance + 1;
				faction          = FACTION_ALLIANCE;
			end

			-- Generate and id.
			id = name .. "|" .. TBG.Var.Const.FACTION_NAME.from[faction];

			-- Count this class.
			if (TBG.Var.Const.NAME_CLASS[class] and players.classes[faction_number]) then
				players.classes[faction_number][TBG.Var.Const.NAME_CLASS[class]] = players.classes[faction_number][TBG.Var.Const.NAME_CLASS[class]] + 1;
			end

			-- Create player list item.
			if (TBG.DB.players.names[id] == nil) then
				TBG.DB.players.names[id]             = { };
				TBG.Var.General.players_list_updated = true;
			end

			-- Store information on this player.
			TBG.DB.players.names[id].standing        = i;
			TBG.DB.players.names[id].id              = id;
			TBG.DB.players.names[id].name_and_server = name_and_server;
			TBG.DB.players.names[id].name            = name;
			TBG.DB.players.names[id].server          = server;
			TBG.DB.players.names[id].killing_blows   = killing_blows;
			TBG.DB.players.names[id].kills           = kills;
			TBG.DB.players.names[id].deaths          = deaths;
			TBG.DB.players.names[id].honor           = honor;
			TBG.DB.players.names[id].faction_number  = faction_number;
			TBG.DB.players.names[id].faction         = faction;
			TBG.DB.players.names[id].rank            = rank;
			TBG.DB.players.names[id].race            = race;
			TBG.DB.players.names[id].class           = class;
			TBG.DB.players.names[id].class_image     = class_image;
			TBG.DB.players.names[id].damage          = damage;
			TBG.DB.players.names[id].healing         = healing;

			-- Store information on objectives.
			TBG.DB.players.names[id].data = TBG_LeaderBoard_GetPlayerObjectiveData(i);

			-- Store friend information.
			if (TBG.DB.friends[name]) then
				if (friends ~= "") then friends = friends .. "\n"; end

				friends = friends .. TBG.Var.Const.COLOR_YELLOW .. name .. "\t";
				friends = friends .. TBG.Var.Const.COLOR_YELLOW .. TBG.Text.Label.Button.KILLING_BLOWS .. TBG.Var.Const.COLOR_GREEN .. TBG.DB.players.names[id].killing_blows .. " ";
				friends = friends .. TBG.Var.Const.COLOR_YELLOW .. TBG.Text.Label.Button.DEATHS .. TBG.Var.Const.COLOR_RED .. TBG.DB.players.names[id].deaths .. " ";
				friends = friends .. TBG.Var.Const.COLOR_YELLOW .. TBG.Text.Label.Button.DAMAGE_DONE .. TBG.Var.Const.COLOR_RED .. TBG.DB.players.names[id].damage .. " ";
				friends = friends .. TBG.Var.Const.COLOR_YELLOW .. TBG.Text.Label.Button.HEALING_DONE .. TBG.Var.Const.COLOR_GREEN .. TBG.DB.players.names[id].healing;
			end

			-- Create raid location information if scan has not been performed.
			if (not TBG.DB.players.names[id].raid) then
				TBG.DB.players.names[id].raid          = -1;
				TBG.DB.players.names[id].x             = 0;
				TBG.DB.players.names[id].y             = 0;
				TBG.DB.players.names[id].last_movement = 0;
			end

			-- Process player location for inactivity checks.
			if (TBG.Var.Player.faction == faction) then
				TBG.DB.players.names[id] = TBG_LeaderBoard_ProcessPlayerLocation(TBG.DB.players.names[id]);
			end

			-- Process information on the server.
			if (TBG_Saved("MD_DisablePercentInAV") and TBG.Var.Player.zone == TBG.Text.Ref.BG_AV) then
			else
				if (servers[faction].reference[server] == nil) then
					servers[faction].reference[server] = 0;
				end

				servers[faction].reference[server] = servers[faction].reference[server] + 1;
			end

			-- If the leader board is visible and being sorted by the server, then store the player data under that server.
			if (TBGX_LeaderBoard:IsVisible() and TBG.Var.General.leader_board_sort == "server") then
				if (players_server.names[server] == nil) then
					local s = { };

					s.name    = server;
					s.players = { };

					table.insert(players_server.list, s);
					players_server.names[server] = table.getn(players_server.list);
				end

				table.insert(players_server.list[players_server.names[server]].players, id);

			-- Otherwise just add the player to the list.
			else
				table.insert(players.list, id);
			end
		end
	end

	-- If the number of players has changed, then the list has been updated.
	if (players.horde ~= TBG.DB.players.horde or players.alliance ~= TBG.DB.players.alliance) then
		TBG.Var.General.players_list_updated = true;
	end

	-- If leader board is visible and being sorted by server, sort the servers alphabetically and add their players to the list.
	if (TBGX_LeaderBoard:IsVisible() and TBG.Var.General.leader_board_sort == "server") then
		players_server.list = TBG_LeaderBoard_SortServerByName(players_server.list);

		-- Loop through the list and add each player.
		for s = 1, table.getn(players_server.list) do
			for p = 1, table.getn(players_server.list[s].players) do
				table.insert(players.list, players_server.list[s].players[p]);
			end
		end
	end

	-- Update the actual server list since it has changed.
	if (TBG.Var.General.players_list_updated) then
		if (TBG_Saved("MD_DisablePercentInAV") and TBG.Var.Player.zone == TBG.Text.Ref.BG_AV) then
		else

			-- Loop through and add all of the servers to the list.
			for faction, value in pairs(servers) do
				for server, count in pairs(value.reference) do
					table.insert(servers[faction].index, server);
				end
			end

			TBG.DB.active.stats.bg.servers = servers;

			-- Sort the servers where applicable.
			if (TBG_Saved("MDB_TT_ServerStats_H") or (TBG_Saved("MDB_Button_TopServerPercentage") and TBG.Var.Player.enemy_faction == TBG.Var.Const.HORDE)) then
				TBG.DB.active.stats.bg.servers[FACTION_HORDE] = TBG_Battleground_ServersSortByCount(TBG.DB.active.stats.bg.servers[FACTION_HORDE]);
			end

			if (TBG_Saved("MDB_TT_ServerStats_A") or (TBG_Saved("MDB_Button_TopServerPercentage") and TBG.Var.Player.enemy_faction == TBG.Var.Const.ALLIANCE)) then
				TBG.DB.active.stats.bg.servers[FACTION_ALLIANCE] = TBG_Battleground_ServersSortByCount(TBG.DB.active.stats.bg.servers[FACTION_ALLIANCE]);
			end
		end
	end

	-- If required, scan the raid.
	if (TBG.Var.BG.scan_raid and GetNumBattlefieldScores() > 0) then
		TBG_Battleground_RaidScan();
		TBG.Var.BG.scan_raid = false;
	end

	-- Update lists.
	TBG.DB.players.list     = players.list;
	TBG.DB.players.horde    = players.horde;
	TBG.DB.players.alliance = players.alliance;
	TBG.DB.players.classes  = players.classes;
	TBG.Var.BG.friends_str  = friends;

	-- Clear variables.
	players        = nil;
	servers        = nil;
	players_server = nil;
	friends        = nil;
end


-- ## Get battleground objective data.
function TBG_LeaderBoard_GetPlayerObjectiveData(standing)
	local columns = GetNumBattlefieldStats();
	local array   = { };

	-- Loop through the statistics.
	for i = 1, MAX_NUM_STAT_COLUMNS do
		if (i <= columns) then
			local _, icon, _ = GetBattlefieldStatInfo(i);

			array[i] = { };
			array[i].count = GetBattlefieldStatData(standing, i);
			array[i].icon  = icon;
		end
	end

	return array;
end


-- ## Process information on player location for inactivity check.
function TBG_LeaderBoard_ProcessPlayerLocation(array)

	-- If this player is part of the raid, check the location.
	if (array.raid ~= nil and array.raid > -1 and TBG.Var.BG.onzone_raidscan_performed) then
		local n = GetRaidRosterInfo(array.raid);
		local t = GetTime();

		-- Make sure we are going to check the position of the correct player.
		if (n ~= array.name) then
			array.raid = TBG_Battleground_RaidGetPlayerLocation(array.name);
		end

		local ox = array.x;
		local oy = array.y;

		if (array.raid > -1) then
			array.x, array.y = GetPlayerMapPosition("raid" .. array.raid);
			array.x          = array.x * 100;
			array.y          = array.y * 100;

			if (not TBG.Var.BG.scanning_raid) then
				local run = TBG.DB.active.stats.bg.run;

				if (not run or run == "" or run == 0) then
					if (TBG.DB.active.stats.bg.run_estimate and TBG.DB.active.stats.bg.run_estimate ~= "" and TBG.DB.active.stats.bg.run_estimate > 0) then
						run = GetTime() - TBG.DB.active.stats.bg.run_estimate;
					end
				end

				-- If the player has moved since last time, set the time they have moved.
				if (((ox - array.x >= 0.02 or array.x - ox >= 0.02) or (oy - array.y >= 0.02 or array.y - oy >= 0.02)) or t - array.last_movement > run) then
					array.last_movement = t;
				end

				-- Check if the player is inactive.
				if ((t - array.last_movement) >= TBG.Var.BG.inactive_delay) then
					if (not array.inactive and TBG.DB.inactives.names[array.id] == nil) then
						table.insert(TBG.DB.inactives.list, array.id);
						TBG.DB.inactives.names[array.id] = table.getn(TBG.DB.inactives.list);
					end

					array.inactive = true;
				else
					array.inactive = false;
				end
			end
		end

		-- If the player is no longer in the raid, then they cannot be inactive.
		if ((array.x == 0 and array.y == 0) or array.raid < 0) then
			array.inactive = false;
		end

		TBG.Var.BG.scanning_raid = false;
	end

	return array;
end


-- ## Colors names on the original leader board by class.
function TBG_LeaderBoard_StatFrameColorNamesByClass()
	if (not TBG_IsBattleground(TBG.Var.Player.zone)) then return nil; end

	if (WorldStateScoreFrame:IsVisible()) then
		for i = 1, MAX_WORLDSTATE_SCORE_BUTTONS do
			local buttonName  = getglobal("WorldStateScoreButton"..i.."NameButtonName");
			local name        = buttonName:GetText();

			local player_id   = "";
			local player_name = "";
			local faction     = "";

			-- Otherwise, adjust the player.
			if (name ~= nil and name ~= "") then
				if (string.find(name, "-")) then
					player_name = string.sub(name, 1, string.find(name, "-") - 1);
				else
					player_name = name;
				end

				local r, g, b, a = buttonName:GetTextColor();

				r = TBG_MathRound(r, 1);

				if (player_name == TBG.Var.Player.name) then
					faction = TBG.Var.Const.FACTION_NAME.to[TBG.Var.Player.faction];
				elseif (r == 1) then
					faction = FACTION_HORDE;
				else
					faction = FACTION_ALLIANCE;
				end

				player_id = player_name .. "|" .. TBG.Var.Const.FACTION_NAME.from[faction];

				if (TBG.DB.players.names[player_id]) then
					local color = "";

					if (TBG_Saved("MGI_ScoreFrame_ColorNamesByClass")) then
						if (TBG_Saved("MGI_ScoreFrame_ColorNamesByClassAll") and TBG.Var.BG.score_frame_tab == 1) then
						else
							color = TBG.Var.Const.COLOR_CLASS[TBG.Var.Const.NAME_CLASS[TBG.DB.players.names[player_id].class]].color;
						end
					end

					if (player_name == TBG.Var.Player.name) then
						if (TBG_Saved("MGI_ScoreFrame_ColorNamesNotPlayer")) then color = "";            end
						if (TBG_Saved("MGI_ScoreFrame_PlayerNameMark"))      then color = color .. "* "; end
					end

					buttonName:SetText(color .. name);
				end
			end
		end
	end
end


-- ## Sorts the players server list for displaying on the leader board.
function TBG_LeaderBoard_SortServerByName(list)
	if (not TBG_IsSupported(TBG.Var.Player.zone)) then return list; end

	table.sort (list, function (v1, v2)
		if (TBG.Var.General.leader_board_sort_type == "desc") then
			return v1.name > v2.name;
		else
			return v1.name < v2.name;
		end
	end);

    return list;
end