TBG_Files_Variables_IsLoaded = true; -- Indicates this file has been loaded into memory.

TBG.Var = { };


-- ###############
-- ## CONSTANTS ##
-- ###############


TBG.Var.Const = { };

-- Addon information variables.
TBG.Var.Const.ADDON_ID              = "TitanBG";
TBG.Var.Const.ADDON_ARTWORK_PATH    = "Interface\\AddOns\\TitanBG\\Artwork\\TitanBG";
TBG.Var.Const.ADDON_UPDATE_FREQ     = 0.5;
TBG.Var.Const.ADDON_DEFAULT_PROFILE = "Default";

TBG.Var.Const.DIALOG_CONSOLE_RELOADUI       = "TBG_CONSOLE_RELOADUI";
TBG.Var.Const.DIALOG_INTRODUCTION           = "TBG_INTRODUCTION";
TBG.Var.Const.DIALOG_RELOAD_HISTORY         = "TBG_RELOAD_HISTORY";
TBG.Var.Const.DIALOG_WARNING                = "TBG_WARNING";
TBG.Var.Const.DIALOG_PROFILE                = "TBG_PROFILE";

-- Status of battlegrounds. Must be exactly as returned by the first variable of GetBattlefieldStatus(i)
TBG.Var.Const.BG_STATUS_NONE    = "none";
TBG.Var.Const.BG_STATUS_QUEUED  = "queued";
TBG.Var.Const.BG_STATUS_CONFIRM = "confirm";
TBG.Var.Const.BG_STATUS_ACTIVE  = "active";

-- Faction names. EXACTLY as returned by UnitFactionGroup("player") or UnitFactionGroup("target").
TBG.Var.Const.ALLIANCE = "Alliance";
TBG.Var.Const.HORDE    = "Horde";

TBG.Var.Const.TEXTURE_CAPTURES_BLANK  = {0.75, 0.875, 0.125, 0.25}; -- Blank texture for the capture timer icons.
TBG.Var.Const.ICON_TITANBUTTON_SPACER = "*";                        -- Spacer around the button text on the Titan Panel.

-- Colors.
TBG.Var.Const.COLOR_RED          = RED_FONT_COLOR_CODE;
TBG.Var.Const.COLOR_GREEN        = GREEN_FONT_COLOR_CODE;
TBG.Var.Const.COLOR_WHITE        = HIGHLIGHT_FONT_COLOR_CODE;
TBG.Var.Const.COLOR_YELLOW       = NORMAL_FONT_COLOR_CODE;
TBG.Var.Const.COLOR_YELLOW_LIGHT = LIGHTYELLOW_FONT_COLOR_CODE;
TBG.Var.Const.COLOR_BLUE         = "|cff0097d0";
TBG.Var.Const.COLOR_ORANGE       = "|cffff954f";
TBG.Var.Const.COLOR_PURPLE       = "|cffd94fff";
TBG.Var.Const.COLOR_GREY         = "|cffb6b6b6";

TBG.Var.Const.COLOR_CLASS = {
	["WARRIOR"] = { color = "|cffbba58d", },
	["DRUID"]   = { color = "|cffffad0f", },
	["MAGE"]    = { color = "|cff3fd7ff", },
	["WARLOCK"] = { color = "|cffc783ff", },
	["ROGUE"]   = { color = "|cffffe92f", },
	["HUNTER"]  = { color = "|cff70ce56", },
	["PRIEST"]  = { color = "|cffffffff", },
	["PALADIN"] = { color = "|cfffe9ee9", },
	["SHAMAN"]  = { color = "|cffff4040", },
};

TBG.Var.Const.COLOR_FACTION = {
	[FACTION_ALLIANCE] = TBG.Var.Const.COLOR_BLUE,
	[FACTION_HORDE]    = TBG.Var.Const.COLOR_RED,
};


TBG.Var.Const.FACTION_NAME = {
	to = {
		["Alliance"] = FACTION_ALLIANCE,
		["Horde"]    = FACTION_HORDE,
	},

	from = {
		[FACTION_ALLIANCE] = "Alliance",
		[FACTION_HORDE]    = "Horde",
	},

	enemy = {
		[FACTION_ALLIANCE] = FACTION_HORDE;
		[FACTION_HORDE]    = FACTION_ALLIANCE;
	},
};

TBG.Var.Const.AUTO_JOIN = {
	var    = "MGB_AutoJoinTime";
	name   = "";
	size   = "";
	paused = false;
};

TBG.Var.Const.AUTO_LEAVE = {
	var    = "MGB_AutoLeaveTime";
	name   = "";
	size   = "";
	paused = false;
};

TBG.Var.Const.BATTLEGROUND_WEEKEND = {
	[0] = TBG.Text.Ref.BG_AB,
	[1] = TBG.Text.Ref.BG_EOTS,
	[2] = TBG.Text.Ref.BG_AV,
	[3] = TBG.Text.Ref.BG_WSG,
};

TBG.Var.Const.BATTLEGROUND_WEEKEND_START_DATE = { d = 31, m = 1, y = 2007, }; -- The day from which battleground weekends are calculated. Arathi Basin weekend this week.

TBG.Var.Const.BATTLEGROUND = "BATTLEGROUND";
TBG.Var.Const.ARENA        = "ARENA";

TBG.Var.Const.BATTLEGROUNDS = {
	[1] = TBG.Text.Ref.BG_AV,
	[2] = TBG.Text.Ref.BG_AB,
	[3] = TBG.Text.Ref.BG_EOTS,
	[4] = TBG.Text.Ref.BG_WSG,
};

TBG.Var.Const.BATTLEGROUNDS_INFORMATION = {
	[TBG.Text.Ref.BG_AB] = {
		has_flag   = false,
		has_points = true,

		point_capture_delay = 60,

		store_history   = true,
		time_is_limited = false,
		has_score       = true,

		stats = {
		},
	},

	[TBG.Text.Ref.BG_EOTS] = {
		has_flag   = true,
		has_points = false,

		point_capture_delay = 0,

		store_history   = true,
		time_is_limited = false,
		has_score       = true,

		stats = {
			flags_captured = { alliance = 0, horde = 0 },

			alliance = { msg = "", flag = 1, player = "", },
			horde    = { msg = "", flag = 1, player = "", },

			minimap = {
				initial    = { x = 0.000147646123713409090909090908, y = 0.00017107203602825, };
				difference = { x = 0.000266102227297045454545454546, y = 0.00037967637181275, };
			},
		},
	},

	[TBG.Text.Ref.BG_WSG] = {
		has_flag   = true,
		has_points = false,

		point_capture_delay = 0,

		store_history   = true,
		time_is_limited = true,
		has_score       = true,

		stats = {
			alliance = { msg = "", flag = 1, player = "", },
			horde    = { msg = "", flag = 1, player = "", },

			minimap = {
				initial    = { x = 0.00052518174052325, y = 0.001078590242700681818181818182, };
				difference = { x = 0.00033140853047275, y = 0.000404394739730568181818181818, };
			},
		},
	},

	[TBG.Text.Ref.BG_AV] = {
		has_flag   = false,
		has_points = true,

		point_capture_delay = 300,

		store_history   = true,
		time_is_limited = true,
		has_score       = false,

		stats = {
			generals = {
				[FACTION_ALLIANCE] = { npc = TBG.Text.Ref.AV_GENERAL_ALLIANCE, color = TBG.Var.Const.COLOR_BLUE, timer = 0, },
				[FACTION_HORDE]    = { npc = TBG.Text.Ref.AV_GENERAL_HORDE,    color = TBG.Var.Const.COLOR_RED,  timer = 0, },
			},

			summons = {
				["IVUS"] = 0,
				["LOK"]  = 0,
			}
		},
	},
}


TBG.Var.Const.ARENAS = {
	[1] = TBG.Text.Ref.ARENA_ALL,
	[2] = TBG.Text.Ref.ARENA_NAGRAND,
	[3] = TBG.Text.Ref.ARENA_BLADE,
};

TBG.Var.Const.ARENA_SIZES = {
	[1] = 2;
	[2] = 3;
	[3] = 5;
}


-- Non language specific class references.
TBG.Var.Const.NAME_CLASS = {
	[TBG.Text.Ref.CLASS_NAME["DRUID"]]   = "DRUID",
	[TBG.Text.Ref.CLASS_NAME["HUNTER"]]  = "HUNTER",
	[TBG.Text.Ref.CLASS_NAME["MAGE"]]    = "MAGE",
	[TBG.Text.Ref.CLASS_NAME["PALADIN"]] = "PALADIN",
	[TBG.Text.Ref.CLASS_NAME["PRIEST"]]  = "PRIEST",
	[TBG.Text.Ref.CLASS_NAME["ROGUE"]]   = "ROGUE",
	[TBG.Text.Ref.CLASS_NAME["SHAMAN"]]  = "SHAMAN",
	[TBG.Text.Ref.CLASS_NAME["WARLOCK"]] = "WARLOCK",
	[TBG.Text.Ref.CLASS_NAME["WARRIOR"]] = "WARRIOR",
};


-- Sounds.
TBG.Var.Const.SOUND_BGWARNING = {
	[1] = { name = TBG.Text.Menu.General.SOUND_DEFAULT,   file = "", },

	[2] = { name = TBG.Text.Menu.General.SOUND_BELL,      file = "Sound\\Doodad\\BoatDockedWarning.wav", },
	[3] = { name = TBG.Text.Menu.General.SOUND_CHIME,     file = "Sound\\Spells\\ShaysBell.wav", },
	[4] = { name = TBG.Text.Menu.General.SOUND_CRASH,     file = "Sound\\Doodad\\ArcaneCrystalOpen.wav", },
	[5] = { name = TBG.Text.Menu.General.SOUND_CYMBAL,    file = "Sound\\interface\\LevelUp.wav", },
	[6] = { name = TBG.Text.Menu.General.SOUND_HORN,      file = "Sound\\Doodad\\DwarfHorn.wav", },
	[7] = { name = TBG.Text.Menu.General.SOUND_LIGHTNING, file = "Sound\\Doodad\\BlastedLandsLightningbolt01Stand-Bolt.wav", },
	[8] = { name = TBG.Text.Menu.General.SOUND_TRUMPET,   file = "Sound\\interface\\levelup2.wav", },
	[9] = { name = TBG.Text.Menu.General.SOUND_WHISTLE,   file = "Sound\\Spells\\PetCall.wav", },
};

-- String references.
TBG.Var.Const.REF_CAPTURE_TIMERS = "{{CAP}}"; -- Indicates the string line is the Capture Timers header.
TBG.Var.Const.REF_CAPTURE_TIMER  = "{{CAP|";  -- Indicates the string line is a Capture Timer.
TBG.Var.Const.REF_MOVEMENT_TIMER = "{{MOVE|"; -- Indicates the string line is a Movement Timer.
TBG.Var.Const.REF_FLAG           = "{{FLAG|"; -- Indicates the string line is a Flag Tracker.

-- The list of menu items.
-- WHERE
--     text     = The button text.
--     level    = Level of the menu item. How much it will be tabbed across. (1 .. n).
--     pre      = How many times should spacers be added before the button. (0 .. n).
--     frame    = The frame number that will be displayed when the button is clicked. (1 .. n).
--     disabled = Whether or not the button should be disabled by default.
--     visible  = Whether or not the button is visible.
--     parent   = The parent frame this sub link belongs to. If initialised, this is the frame link highlighted.
TBG.Var.Const.MENU_LIST = {
	[1] =   { text = TBG.Text.Menu.ITEM_GENERAL,						frame = 1, },
	[2] =   { text = TBG.Text.Menu.ITEM_ACTIONS,						frame = 2, pre = 1, },
	[3] =   { 	text = nil,												frame = 17, visible = false, parent = 2, },
	[4] =   { 	text = TBG.Text.Menu.ITEM_AUTOQUEUE,						level = 2, disabled = true, },
	[5] =   { 	text = TBG.Text.Menu.ITEM_AUTOJOINANDLEAVE,					level = 2, disabled = true, },
	[6] =   { 	text = TBG.Text.Menu.ITEM_AUTORELEASE,						level = 2, disabled = true, },
	[7] =   { 	text = TBG.Text.Menu.ITEM_QUESTSGOSSIP,					frame = 16, level = 2, pre = 1, },
	[8] =   { text = TBG.Text.Menu.ITEM_DISPLAYANDSOUNDS,				frame = 3, pre = 1, },
	[9] =   { 	text = nil,												frame = 19, visible = false, parent = 8, },
	[10] =   { 	text = nil,												frame = 20, visible = false, parent = 8, },
	[11] =  { 	text = TBG.Text.Menu.ITEM_BUTTON,						frame = 5, level = 2, pre = 1, },
	[12] =  {		 text = TBG.Text.Menu.ITEM_ITEMSTODISPLAY,				level = 3, disabled = true, },
	[13] =  {			text = TBG.Text.Menu.ITEM_BATTLEGROUND,			frame = 6, level = 4, },
	[14] =  { 				text = nil,									frame = 14, level = 5, visible = false, parent = 12, },
	[15] =  { 		text = TBG.Text.Menu.ITEM_APEARANCEANDPOSITION,		frame = 7, level = 3, },
	[16] =  { 	text = TBG.Text.Menu.ITEM_TOOLTIP,						frame = 8, level = 2, pre = 1, },
	[17] =  { 		text = TBG.Text.Menu.ITEM_ITEMSTODISPLAY,				level = 3, disabled = true, },
	[18] =  { 			text = TBG.Text.Menu.ITEM_BATTLEGROUND,			frame = 9, level = 4, },
	[19] =  { 				text = nil,									frame = 10, level = 5, visible = false, parent = 17, },
	[20] =  { 		text = TBG.Text.Menu.ITEM_APEARANCEANDPOSITION,		frame = 11, level = 3, },
	[21] =  { 			text = nil,										frame = 12, level = 4, visible = false, parent = 19, },
	[22] =  { 			text = nil,										frame = 18, level = 4, visible = false, parent = 19, },
	[23] =  { text = TBG.Text.Menu.ITEM_PANELS,							frame = 13, level = 2, pre = 1, },
	[24] =  { 	text = TBG.Text.Menu.ITEM_CAPTURETIMERS,					level = 3, disabled = true, },
	[25] =  { 	text = TBG.Text.Menu.ITEM_PLAYERLIST,						level = 3, disabled = true, },
	[26] =  { 	text = TBG.Text.Menu.ITEM_FLAGTRACKER,					frame = 15, level = 3, },
	[27] =  { text = TBG.Text.Menu.ITEM_BLIZZARD,						frame = 4, level = 2, pre = 1, },
	[28] =  {	text = TBG.Text.Menu.ITEM_SCOREFRAME,						level = 3, disabled = true, },
	[29] =  { 	text = TBG.Text.Menu.ITEM_LEADERBOARD,						level = 3, disabled = true, },

};

-- Slash commands.
TBG.Var.Const.Slash = {
	command = "tbg",
	expr    = TBG.Var.Const.COLOR_RED .. "/tbg " .. TBG.Var.Const.COLOR_YELLOW .. "* ( " .. TBG.Var.Const.COLOR_WHITE .. "help" .. TBG.Var.Const.COLOR_YELLOW .. " | " .. TBG.Var.Const.COLOR_WHITE .. "print" .. TBG.Var.Const.COLOR_YELLOW .. " | " .. TBG.Var.Const.COLOR_WHITE .. "reset" .. TBG.Var.Const.COLOR_YELLOW .. " )",
	details = nil,

	[1] = {
		command = "help",
		expr    = nil,
		details = nil,
	},

	[2] = {
		command = "print",
		expr    = TBG.Var.Const.COLOR_RED .. "/tbg " .. TBG.Var.Const.COLOR_BLUE .. "print " .. TBG.Var.Const.COLOR_YELLOW .. "( " .. TBG.Var.Const.COLOR_WHITE .. "flag" .. TBG.Var.Const.COLOR_YELLOW .. " | " .. TBG.Var.Const.COLOR_WHITE .. "cap" .. TBG.Var.Const.COLOR_YELLOW .. " | " .. TBG.Var.Const.COLOR_WHITE .. "move" .. TBG.Var.Const.COLOR_YELLOW .. " )",
		details = nil,

		[1] = {
			command = "flag",
			expr    = TBG.Var.Const.COLOR_RED .. "/tbg " .. TBG.Var.Const.COLOR_BLUE .. "print flag " .. TBG.Var.Const.COLOR_YELLOW .. "( " .. TBG.Var.Const.COLOR_WHITE .. "a" .. TBG.Var.Const.COLOR_YELLOW .. " | " .. TBG.Var.Const.COLOR_WHITE .. "h" .. TBG.Var.Const.COLOR_YELLOW .. " )",
			details = TBG.Text.Message.SLASH_DETAILS_PRINT_FLAG,

			[1] = {
				command = "a",
				expr    = nil,
				details = nil,
			},

			[2] = {
				command = "h",
				expr    = nil,
				details = nil,
			},
		},

		[2] = {
			command = "cap",
			expr    = TBG.Var.Const.COLOR_RED .. "/tbg " .. TBG.Var.Const.COLOR_BLUE .. "print cap " .. TBG.Var.Const.COLOR_YELLOW .. "( " .. TBG.Var.Const.COLOR_WHITE .. "all" .. TBG.Var.Const.COLOR_YELLOW .. " | " .. TBG.Var.Const.COLOR_WHITE .. "top" .. TBG.Var.Const.COLOR_YELLOW .. " | " .. TBG.Var.Const.COLOR_GREY .. "n" .. TBG.Var.Const.COLOR_YELLOW .. " )",
			details = TBG.Text.Message.SLASH_DETAILS_PRINT_CAP,

			[1] = {
				command = "all",
				expr    = nil,
				details = nil,
			},

			[2] = {
				command = "top",
				expr    = TBG.Var.Const.COLOR_RED .. "/tbg " .. TBG.Var.Const.COLOR_BLUE .. "print cap top " .. TBG.Var.Const.COLOR_YELLOW .. "( " .. TBG.Var.Const.COLOR_GREY .. "n" .. TBG.Var.Const.COLOR_YELLOW .. " )",
				details = TBG.Text.Message.SLASH_DETAILS_PRINT_CAP_TOP,
			},
		},

		[3] = {
			command = "move",
			expr    = TBG.Var.Const.COLOR_RED .. "/tbg " .. TBG.Var.Const.COLOR_BLUE .. "print move " .. TBG.Var.Const.COLOR_YELLOW .. "( " .. TBG.Var.Const.COLOR_WHITE .. "ivus" .. TBG.Var.Const.COLOR_YELLOW .. " | " .. TBG.Var.Const.COLOR_WHITE .. "lok" .. TBG.Var.Const.COLOR_YELLOW .. " )",
			details = TBG.Text.Message.SLASH_DETAILS_PRINT_MOVE,

			[1] = {
				command = "ivus",
				expr    = nil,
				details = nil,
			},

			[2] = {
				command = "lok",
				expr    = nil,
				details = nil,
			},
		},
	},

	[3] = {
		command = "reset",
		expr    = TBG.Var.Const.COLOR_RED .. "/tbg " .. TBG.Var.Const.COLOR_BLUE .. "reset " .. TBG.Var.Const.COLOR_YELLOW .. "( " .. TBG.Var.Const.COLOR_WHITE .. "pos" .. TBG.Var.Const.COLOR_YELLOW .. " | " .. TBG.Var.Const.COLOR_WHITE .. "history" .. TBG.Var.Const.COLOR_YELLOW .. " | " .. TBG.Var.Const.COLOR_WHITE .. "save" .. TBG.Var.Const.COLOR_YELLOW .. " )",
		details = TBG.Text.Message.SLASH_DETAILS_RESET,

		[1] = {
			command = "pos",
			expr    = nil,
			details = nil,
		},

		[2] = {
			command = "history",
			expr    = nil,
			details = nil,
		},

		[3] = {
			command = "save",
			expr    = nil,
			details = nil,
		},
	},
};


-- ###############
-- ## VARIABLES ##
-- ###############


-- Addon variables.
TBG.Var.Addon                     = { };
TBG.Var.Addon.titan               = false; -- Whether or not titan panel has been detected.
TBG.Var.Addon.drop_down_menu_open = false; -- Whether or not the drop down menu is open.

TBG.Var.Addon.titan = false; -- Whether or not the titan panel has been detected.

TBG.Var.Addon.TITAN = {
	detected = false,
	scanned  = false,
	enabled  = false,
}


TBG.Var.Addon.ADDON_LOADED          = false;
TBG.Var.Addon.VARIABLES_LOADED      = false;
TBG.Var.Addon.PLAYER_LOADED         = false;
TBG.Var.Addon.PLAYER_ENTERING_WORLD = false;

TBG.Var.Addon.ZONE_CHANGED_NEW_AREA = nil;

TBG.Var.Addon.update_last = 0;
TBG.Var.Addon.update_freq = 0.5;

TBG.Var.Addon.update_countdown_last = 0;
TBG.Var.Addon.update_countdown_freq = 1;

TBG.Var.Addon.first_load = false; -- Indicates if this is the first time the addon was loaded.

-- External interaction tracking variables.
TBG.Var.External                         = { };
TBG.Var.External.blizzard_interactbg     = false; -- If the player interacts with the battleground queue using the blizzard interface.
TBG.Var.External.blizzard_manualshowbg   = nil;   -- "SHOW": Show battlemap. "HIDE": Don't show battlemap.
TBG.Var.External.titan_titanbg_leftclick = false; -- If the player has clicked the TitanBG menu item in the Titan Panel menu.

-- Player variables.
TBG.Var.Player               = { };
TBG.Var.Player.name          = UNKNOWN;
TBG.Var.Player.faction       = UNKNOWN;
TBG.Var.Player.enemy_faction = UNKNWON;
TBG.Var.Player.zone          = UNKNOWN;
TBG.Var.Player.realm         = UNKNOWN;

-- Battlground variables.
TBG.Var.BG = { };

	TBG.Var.BG.update_last = 0;
	TBG.Var.BG.update_freq = 1;

	TBG.Var.BG.leader_board_last_button = nil;

	TBG.Var.BG.battleground_weekend         = UNKNOWN;
	TBG.Var.BG.onload_capture_points_stored = false; -- If capture points have been saved on load.
	TBG.Var.BG.stat_information_stored      = false; -- Indicates if score information has been stored on completion.
	TBG.Var.BG.is_team_percent              = 80;    -- Minimum percentage indicating a team game.
	TBG.Var.BG.score_frame_tab              = 1;
	TBG.Var.BG.final_bg_run_time            = UNKNOWN; -- The time when the battleground ended.
	TBG.Var.BG.bg_close_delay               = 120;     -- The amount of seconds after a battleground ends that it will close in.
	TBG.Var.BG.scan_raid                    = false;   -- Indicates whether or not the raid needs to be scanned.
	TBG.Var.BG.scan_inventory               = false;   -- Indicates whether or not the inventory needs to be scanned.

	-- Confirm.
	TBG.Var.BG.bgready_sound_delay = 20; -- Number of seconds between battleground ready sounds if repetitive.

	-- Active.
	TBG.Var.BG.update_id         = 0;     -- The id number of the last battleground information update.
	TBG.Var.BG.start_delay       = 120;   -- The amount of time before a battle begins inside a battleground.
	TBG.Var.BG.start_delay_arena = 60;    -- The amount of time before a battle begins inside an arena.
	TBG.Var.BG.inactive_delay    = 180;   -- The amount of time before a player is considered inactive inside a battleground.
	TBG.Var.BG.scanning_raid     = false; -- Whether or not the raid is being scanned.
	TBG.Var.BG.friends_asked     = false;
	TBG.Var.BG.friends_str       = "";
	TBG.Var.BG.queue_sound_last  = 0;  -- If repeated, the last time the in queue sound was played.
	TBG.Var.BG.queue_sound_delay = 30; -- If repeated, the delay between playing in queue sounds.

	-- Auto join.
	TBG.Var.BG.autojoin_min = 0;  -- The minimum amount of time that a user can set autojoin to.
	TBG.Var.BG.autojoin_max = 30; -- The maxiumum amount of time that a user can set autojoin to.

	-- Auto leave.
    TBG.Var.BG.autoleave_min    = 0;  -- The minimum amount of time that a user can set autoleave to.
    TBG.Var.BG.autoleave_max    = 30; -- The maxiumum amount of time that a user can set autoleave to.

	-- Alterac Valley
	TBG.Var.BG.AV = { };

		--TBG.Var.BG.AV.point_capture_delay = 300; -- How long it takes a point to capture.

		TBG.Var.BG.AV.ivus             = "ivus";
		TBG.Var.BG.AV.lok              = "lokholar";
		TBG.Var.BG.AV.time_to_movement = 600;

	-- Arathi Basin
	TBG.Var.BG.AB = { };

		--TBG.Var.BG.AB.point_capture_delay   = 60; -- How long it takes a point to capture.
		TBG.Var.BG.AB.time_to_node_increase = 0;  -- Amount of seconds until the nodes needing to be captured increases.

		-- Tracking variables for predicting how much time a team has left before the amount of nodes needing to be captured increased.
		TBG.Var.BG.AB.timeinc_check        = false; -- Whether a check is being performed.
		TBG.Var.BG.AB.timeinc_sec          = 0;     -- The amount of seconds in the future being checked.
		TBG.Var.BG.AB.timeinc_update       = 0;     -- When the last update occured.
		TBG.Var.BG.AB.timeing_update_delay = 0.05;  -- How often between each scan.

-- Display variables.
TBG.Var.Display                  = { };
TBG.Var.Display.display_which_tt = "1";   -- Which tooltip to display. "1"/"2"/"HISTORY";
TBG.Var.Display.captures_min     = 1;     -- The minimum number of captures that can be displayed.
TBG.Var.Display.captures_max     = 14;    -- The maximum number of captures that can be displayed.

TBG.Var.Display.tt_lines_min    = 5;     -- Minimum number of lines the tooltip can display.
TBG.Var.Display.tt_lines_max    = 35;    -- Maximum number of lines the tooltip can display. Equal to the number of FontString instances.
TBG.Var.Display.tt_start_line   = 1;     -- The line at which to start printing the tooltip.
TBG.Var.Display.tt_more_lines   = false; -- Indicates that the tooltip should continue scrolling down.
TBG.Var.Display.tt_update_delay = 0.5;   -- How often to update the tooltip.
TBG.Var.Display.tt_update       = 0;     -- When the last update occured.
TBG.Var.Display.tt_update_min   = TBG.Var.Display.tt_update_delay; -- The fastest possible automatic scrolling speed.
TBG.Var.Display.tt_update_max   = 2;     -- The slowest possible automatic scrolling speed.
TBG.Var.Display.tt_scroll       = 0;     -- When the last scroll occured.
TBG.Var.Display.tt_total_lines  = 0;     -- The total number of lines to be displayed in the tooltip.
TBG.Var.Display.tt_slider_moved = false; -- Indicates if the user has the mouse over the slider.
TBG.Var.Display.tt_mouse_over_last = 0; -- When the mouse was last over the tooltip or button.
TBG.Var.Display.tt_hide_delay_min = 0.1; -- Minimum delay before the tooltip is hidden on mouse out.
TBG.Var.Display.tt_hide_delay_max = 1; -- Maxiumum delay before the tooltip is hidden on mouse out.
TBG.Var.Display.tt_width_min = 200;
TBG.Var.Display.tt_width_max = 1000;

TBG.Var.General = { };

TBG.Var.General.history_displayed    = false; -- Whether or not the battleground history is being displayed.
TBG.Var.General.players_list_updated = false; -- Whether or not the players list was updated on the last scan.

TBG.Var.General.leader_board_tab       = "ALL";
TBG.Var.General.leader_board_sort      = "kb";
TBG.Var.General.leader_board_sort_type = "asc";

-- ##############
-- ## DATABASE ##
-- ##############


TBG.DB             = {                          };
TBG.DB.world_state = {                          }; -- Stores information on the world state score frame.
TBG.DB.bgs         = {                          }; -- Battleground information.
TBG.DB.active      = {                          }; -- Information on the current active battleground.
TBG.DB.popups      = {                          }; -- Popups that appear on the screen containing queue information.
TBG.DB.inactives   = { list = { }, names = { }, }; -- List of possibly inactive players.
TBG.DB.friends     = { };
TBG.DB.players     = { }; -- Leader board list of players in the battleground.
TBG.DB.inventory   = { }; -- Player inventory.

