TITAN_DRUID_ID = "Druid";

-- default icon
TITAN_DRUID_ICON = "Interface\\Icons\\spell_nature_lightning";

--
-- OnFuctions
--
function TitanPanelDruidButton_OnLoad()	
	this.registry = { 
		id = TITAN_DRUID_ID,
		category = "General",
		menuText = "Druid Innervate", 
		buttonTextFunction = "TitanPanelDruidButton_GetButtonText", 
		tooltipTitle = "Druids in raid:",
		tooltipTextFunction = "TitanPanelDruidButton_GetTooltip",
		frequency = 1, 
		icon = TITAN_DRUID_ICON,
		iconWidth = 16,
		savedVariables = {
			ShowIcon = 1,
			ShowLabelText = 1,
			HideMinimap = TITAN_NIL,
		}
	}
	thiscd = "Innervate";
	Titanthiscd = "Innervate";
	if TitanCDInfo == nil then
	TitanCDInfo = {};
	end
	TitanCDInfo[thiscd] = {};
	TitanCDInfo[thiscd]["IsDead"] = 0;
	TitanCDInfo[thiscd]["class"] = "DRUID";
	TitanCDInfo[thiscd]["spell"] = "Innervate";
	TitanCDInfo[thiscd]["prefix"] = "DruidInnervate";
	this:RegisterEvent("CHAT_MSG_SYSTEM");
	this:RegisterEvent("CHAT_MSG_ADDON");
	local _,PlayerClass = UnitClass("player");
	if PlayerClass == "DRUID" then
		TitanPanelDruidFindInnervate();
		TitanCDInfo[thiscd]["IsDruid"] = 1;
		this:RegisterEvent("SPELL_UPDATE_COOLDOWN");
	else
		TitanCDInfo[thiscd]["IsDruid"] = 0;
		this:UnregisterEvent("SPELL_UPDATE_COOLDOWN");
	end
	TitanCDInfo[thiscd]["cd"] = {}
end

function TitanPanelDruidButton_SendMsg(msg)
	SendAddonMessage(TitanCDInfo[thiscd]["prefix"], msg, "RAID");
end


function TitanPanelDruidButton_OnEvent(event)
if (strsub(event,1,20) == "PARTY_MEMBER_DISABLE") then
				local numJobs = table.getn(TitanCDInfo[thiscd]["cd"]);
				local i, a;
				for a = 1, numJobs do
					local druid = TitanCDInfo[thiscd]["cd"][a];
					if (druid.name == arg1) then
						TitanCDInfo[thiscd]["cd"][a]["online"] = 0;
					end
				end
end
if (strsub(event,1,15) == "CHAT_MSG_SYSTEM") then
			if arg1 == "You have joined a raid group" then
				TitanPanelDruidButton_SendMsg("REQUP")
			end
			if string.find(arg1, "(.+) has left the raid group") then
				local _, _, PlayerLeftRaid = string.find(arg1, "(.+) has left the raid group")
				local numJobs = table.getn(TitanCDInfo[thiscd]["cd"]);
				local a;
				for a = 1, numJobs do
					local druid = TitanCDInfo[thiscd]["cd"][a];
					if druid ~= nil then
					if (druid.name == PlayerLeftRaid) then
						table.remove (TitanCDInfo[thiscd]["cd"], a);
					end
					end
				end
			end
			if string.find(arg1, "(.+) has gone offline.") then
				local _, _, PlayerGoneOffline = string.find(arg1, "(.+) has gone offline.")
				local numJobs = table.getn(TitanCDInfo[thiscd]["cd"]);
				local a;
				for a = 1, numJobs do
					local druid = TitanCDInfo[thiscd]["cd"][a];
					if (druid.name == PlayerGoneOffline) then
						TitanCDInfo[thiscd]["cd"][a]["online"] = 2;
					end
				end
			end
			if string.find(arg1, "[(.+)] has come online.") then
				local _, _, PlayerComeOnline = string.find(arg1, "[(.+)] has come online.")
				local numJobs = table.getn(TitanCDInfo[thiscd]["cd"]);
				local a;
				for a = 1, numJobs do
					local druid = TitanCDInfo[thiscd]["cd"][a];
					if (druid.name == PlayerComeOnline) then
						TitanCDInfo[thiscd]["cd"][a]["online"] = 0;
					end
				end
			end
			if arg1 == "You have left the raid group" then
				TitanCDInfo[thiscd]["cd"] = {};
			end
	end


if (strsub(event,1,21) == "SPELL_UPDATE_COOLDOWN" and TitanCDInfo[thiscd]["spellSlot"] ~= nil) then
		local start, duration, enable = GetSpellCooldown(TitanCDInfo[thiscd]["spellSlot"], BOOKTYPE_SPELL);
		if ( start > 0 and (duration - ( GetTime() - start)) > 359.9) then
			local cooldown = duration - ( GetTime() - start);
			TitanPanelDruidButtonSendUpdate()
		end
end

	if strsub(event,1,16) == "CHAT_MSG_ADDON" and arg1 == TitanCDInfo[thiscd]["prefix"] then
	local msg = arg2;
	local plr = arg4;
			if msg == "REQUP" then
				if TitanCDInfo[thiscd]["IsDruid"] == 1 then
				TitanPanelDruidButtonSendUpdate();
				end
			end
			if msg == "DEAD" then
					local druidspot = TitanPanelDruidIsFound(arg4);
					TitanCDInfo[thiscd]["cd"][druidspot]["online"] = 0;
				end
			if msg == "ALIVE" then
					local druidspot = TitanPanelDruidIsFound(arg4);
					TitanCDInfo[thiscd]["cd"][druidspot]["online"] = 1;
			end
			if (strsub(msg, 1, 6) == "UPDATE") then
				local _, _, PlayerName, PlayerOnline, PlayerStatus, PlayerCd = string.find(msg, "UPDATE (.+) ZX (.+) ZZ (.+) XX (.+)");
				TitanPanelDruidReciveUpdate(PlayerName, PlayerOnline, PlayerStatus, PlayerCd)
			end
	end
end


function TitanPanelDruidButtonSendUpdate()
		if TitanCDInfo[thiscd]["spellSlot"] == nil then
			TitanPanelDruidFindInnervate();
		end
		if TitanCDInfo[thiscd]["spellSlot"] ~= nil then
		local start, duration, enable = GetSpellCooldown(TitanCDInfo[thiscd]["spellSlot"], BOOKTYPE_SPELL);
		local ready = 0;
		if (start == 0) then
			local ready = 1;
		end
		local cooldown = duration - ( GetTime() - start);
		local msg = "UPDATE "..UnitName("player").." ZX 1 ZZ "..ready.." XX "..cooldown;
		TitanPanelDruidButton_SendMsg(msg)
		end
end


function TitanPanelDruidButton_OnClick(button)
	TitanCDInfo[thiscd]["cd"] = {};
	TitanPanelDruidButton_SendMsg("REQUP")
end

function TitanPanelDruidButton_GetButtonText(id)	
	local buttonRichText = "0";
	local time = GetTime();
	local menuText = TitanCDInfo[thiscd]["spell"].."s: ";
	local spellcounts = 0;
	local i, soonname;
	local numJobs = table.getn(TitanCDInfo[thiscd]["cd"]);
	local soontime = 999999999999999;
	local onlyready = "";
		for i = 1, numJobs do
			local druid = TitanCDInfo[thiscd]["cd"][i];
			if (druid.status == 1 and druid.online == 1 and druid.raid == 1) then
				spellcounts = spellcounts + 1;
				onlyready = druid.name;
			else
			if (druid.cd < time and druid.online == 1 and druid.raid == 1) then
				spellcounts = spellcounts + 1;
				onlyready = druid.name;
			end
			if (druid.cd < soontime and druid.online == 1 and druid.raid == 1) then
			 soontime = druid.cd;
			 soonname = druid.name;
			end
		end
		end
		if spellcounts == 0 then 
			if soonname ~= nil then
			local druidcd = soontime - time;
			local min = math.floor(druidcd/60);
			local sec = math.floor(druidcd - (min * 60));
			if sec < 10 then
			sec = "0"..sec;
			end 
			buttonRichText = soonname..": "..TitanUtils_GetHighlightText(min..":"..sec);
			end
		end
	if spellcounts > 1 then
	buttonRichText = TitanUtils_GetGreenText(spellcounts);
	elseif spellcounts == 1 then
	buttonRichText = TitanUtils_GetGreenText(onlyready);
	end
	TitanPanelDruidButton_OnUpdate()
	return menuText, buttonRichText;
end

------------------------------
function TitanPanelDruidButton_GetTooltip(id)
	local tooltipRichText = "";
					local numJobst = table.getn(TitanCDInfo[thiscd]["cd"]);
					local time = GetTime();
					local a;
					for a = 1, numJobst do
					local druid = TitanCDInfo[thiscd]["cd"][a];
					local status = "";
					if (druid.raid == 1) then
					if (druid.online == 0 or druid.online == 2) then
						if druid.online == 0 then
							if druid.cd < time then
								status = TitanUtils_GetGreenText("DEAD");
							else
								status = TitanUtils_GetRedText("DEAD");
							end
						end
						if druid.online == 2 then
							if druid.cd < time then
								status = TitanUtils_GetGreenText("OFFLINE");
							else
								status = TitanUtils_GetRedText("OFFLINE");
							end
						end
						else
							if (druid.status == 1) then
								status = TitanUtils_GetGreenText("Ready");
								else
								if (druid.cd < time) then
									TitanPanelDruidReciveUpdate(druid.name, 1, 1, 0)
								status = TitanUtils_GetGreenText("Ready");
								else
									local druidcd = druid.cd - time;
									local min = math.floor(druidcd/60);
									local sec = math.floor(druidcd - (min * 60));
									if sec < 10 then
										sec = "0"..sec;
									end 
									status = TitanUtils_GetHighlightText(min..":"..sec);
								end
							end
					end
					tooltipRichText = tooltipRichText..druid.name..": "..status.."\n";
					end
	end
	return tooltipRichText;
end

function TitanPanelDruid_ToggleVar()
	TitanToggleVar(TITAN_DRUID_ID, this.value);
	TitanPanelButton_UpdateButton(TITAN_DRUID_ID);
end

function TitanPanelDruid_ChatPrint(msg)
        DEFAULT_CHAT_FRAME:AddMessage(msg);
end

function TitanPanelDruidButton_OnUpdate()
	if TitanCDInfo[thiscd].IsDruid == 1 then
	if UnitIsDeadOrGhost("player") and TitanCDInfo[thiscd].IsDead == 0 then
	TitanCDInfo[thiscd]["IsDead"] = 1;
	TitanPanelDruidButton_SendMsg("DEAD")
	elseif UnitIsDeadOrGhost("player") == nil and TitanCDInfo[thiscd].IsDead == 1 then
	TitanCDInfo[thiscd]["IsDead"] = 0;
	TitanPanelDruidButton_SendMsg("ALIVE")
	end
	end
end

function TitanPanelDruidFindInnervate()
	local i;
	local maxSpells = 0;
		for i=1, 4 do
		_, _, _, numSpells = GetSpellTabInfo(i)
		maxSpells = maxSpells +numSpells;
		end
	for i=1, maxSpells do
	spellName = GetSpellName(i, BOOKTYPE_SPELL);
	if spellName == TitanCDInfo[thiscd]["spell"] then
	TitanCDInfo[thiscd]["spellSlot"] = i;
	end
	end
end

function TitanPanelDruidIsFound(name)
	local nameFound = 0;
	local numJobs = table.getn(TitanCDInfo[thiscd]["cd"]);
		for i = 1, numJobs do
			local druid = TitanCDInfo[thiscd]["cd"][i];
			if (druid.name == name) then
				nameFound = i;
			end
		end
	if nameFound == 0 then
table.insert(TitanCDInfo[thiscd]["cd"], {
            ["name"] = name,
            ["online"] = 0,
            ["status"] = 0,
            ["cd"] = 0,
            ["raid"] = 1,
});
	nameFound = numJobs + 1;
	end
	return nameFound
end

function TitanPanelDruidReciveUpdate(name, online, status, cd)
	if name ~= nil then
	local druidspot = TitanPanelDruidIsFound(name);
		if online ~= nil then
			online = online + 0;
			TitanCDInfo[thiscd]["cd"][druidspot]["online"] = online;
		end
		if status ~= nil then
			status = status + 0;
			TitanCDInfo[thiscd]["cd"][druidspot]["status"] = status;
		end
		if cd ~= nil then
			cd = cd + GetTime();
			TitanCDInfo[thiscd]["cd"][druidspot]["cd"] = cd;
		end
	end	
end