--[[/*
	Titan [Gathered] v 1.15b original Titan Ore
	An addon for World of Warcraft that shows information about
	trade items in Titan Panel.
	Programed By Radek Roza 12-20-2006 - 03-21-2007 (c)
	Medyn medyn@volny.cz Tabor/Czech Republic

	License:
		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.

		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.

*/]]

TITAN_ORE_VERSION 				= "v1.16";
TITAN_ORE_AUTHOR 				= "Medyn";
TITAN_ORE_EMAIL 				= "radek.roza@rrsoft.cz";
TITAN_ORE_WEB	 				= "www.rrsoft.cz";
TITAN_ORE_GERMAN				= "Aranel";
TITAN_ORE_FRANCE				= "...";

TITAN_ORE_EV 					= 0;
TITAN_ORE_DEBUG 				= 0;


TITAN_ORE_LOCAL_ORES			= "Ores: ";
TITAN_ORE_LOCAL_BARS			= "Bars: ";
TITAN_ORE_LOCAL_STONES			= "Stones: ";
TITAN_ORE_LOCAL_GEMS			= "Gems: ";
TITAN_ORE_LOCAL_LEATHERS		= "Leathers: ";
TITAN_ORE_LOCAL_SCALES			= "Scales: ";
TITAN_ORE_LOCAL_CLOTHS			= "Cloths: ";
TITAN_ORE_LOCAL_HIDES			= "Hides: ";
TITAN_ORE_LOCAL_SHARDS			= "Shards: ";
TITAN_ORE_LOCAL_HERBS			= "Herbs: ";
TITAN_ORE_LOCAL_ESSENCES		= "Essences: ";
TITAN_ORE_LOCAL_BANDAGES		= "Bandages: ";
TITAN_ORE_LOCAL_POISONS			= "Poisons: ";
TITAN_ORE_LOCAL_MISC			= "Misc: ";
TITAN_ORE_LOCAL_PMATS			= "Poison mats: ";
TITAN_ORE_LOCAL_PROFESSIONS		= "Professions: ";
TITAN_ORE_LOCAL_NAME			= "Titan Gathered";
TITAN_ORE_LOCAL_HIDDE_ZERO		= "Show zero items";
TITAN_ORE_LOCAL_SHOW_BANK		= "Show bank stacks";
TITAN_ORE_LOCAL_EXCLUDE_ZERO	= "Ignore bag zero stacks";
TITAN_ORE_LOCAL_SHOW_CATEGORIES	= "Show categories";
TITAN_ORE_LOCAL_SHOW_TITAN_OPT	= "Titan options";
TITAN_ORE_LOCAL_SHOW_ITEMS		= "Show Items in category";
TITAN_ORE_LOCAL_SHOW_SKILLS		= "Show prof. skills";
TITAN_ORE_LOCAL_SHOW_ORE		= "Show ores";
TITAN_ORE_LOCAL_SHOW_BAR		= "Show bars";
TITAN_ORE_LOCAL_SHOW_GEM		= "Show gems";
TITAN_ORE_LOCAL_SHOW_STONE		= "Show stones";
TITAN_ORE_LOCAL_SHOW_LEATHER	= "Show leathers";
TITAN_ORE_LOCAL_SHOW_SCALE		= "Show scales";
TITAN_ORE_LOCAL_SHOW_CLOTH		= "Show cloths";
TITAN_ORE_LOCAL_SHOW_HIDE		= "Show hides";
TITAN_ORE_LOCAL_SHOW_HERB		= "Show herbs";
TITAN_ORE_LOCAL_SHOW_ESSENCE	= "Show essences";
TITAN_ORE_LOCAL_SHOW_BANDAGE	= "Show bandages";
TITAN_ORE_LOCAL_SHOW_POISON		= "Show poisons";
TITAN_ORE_LOCAL_SHOW_MISC		= "Show miscs";
TITAN_ORE_LOCAL_SHOW_PMAT		= "Show Poison mats";
TITAN_ORE_LOCAL_BANK_ITEMS		= "Bank Items";
TITAN_ORE_ABOUT_TEXT			= "About";
TITAN_ORE_LOCAL_LIST_TEXT		= "Track item list";
TITAN_ORE_LOCAL_SKILL_MINE_NAME	= "Mining";
TITAN_ORE_LOCAL_SKILL_HERB_NAME	= "Herbaling";
TITAN_ORE_LOCAL_SKILL_SKIN_NAME = "Skinning";
TITAN_ORE_LOCAL_SKILL_ENCH_NAME = "Enchanting";
TITAN_ORES_LOCAL_PERCENT		= 0;


TITAN_ORE_RED 		= "|cFFFF0000";
TITAN_ORE_ORANGE 	= "|cffff8020";
TITAN_ORE_YELLOW 	= "|cffffff20";
TITAN_ORE_GREEN 	= "|cFF00FF00";
TITAN_ORE_GOLD	 	= "|r";
TITAN_ORE_BLUE 		= "|cFF0000FF";
TITAN_ORE_GREY 		= "|cffdddddd";

TITAN_ORE_ABOUT_POPUP_TEXT 		= TitanUtils_GetGreenText("Titan Panel [Gathered]")..TitanUtils_GetHighlightText(" By ")..TitanUtils_GetNormalText(TITAN_ORE_AUTHOR).."\n"..TitanUtils_GetNormalText("Version: ")..TitanUtils_GetHighlightText(TITAN_ORE_VERSION).."\n"..TitanUtils_GetNormalText("email: ")..TitanUtils_GetHighlightText(TITAN_ORE_EMAIL).." - "..TitanUtils_GetHighlightText(TITAN_ORE_WEB);



TITAN_ORE_CATEGORIES = {
	{ tag = "TITAN_ORE_LOCAL_ORES", 	name = "Ores: ",		save = "ShowOre", 		smenu = "Show ores", 		skillneed = "Mining"},
	{ tag = "TITAN_ORE_LOCAL_BARS", 	name = "Bars: ",		save = "ShowBar", 		smenu = "Show bars", 		skillneed = "Mining"},
	{ tag = "TITAN_ORE_LOCAL_STONES", 	name = "Stones: ",		save = "ShowStone", 	smenu = "Show gems", 		skillneed = "Mining"},
	{ tag = "TITAN_ORE_LOCAL_GEMS", 	name = "Gems: ",		save = "ShowGem", 		smenu = "Show stones", 		skillneed = "Mining"},
	{ tag = "TITAN_ORE_LOCAL_LEATHERS", name = "Leathers: ",	save = "ShowLeather", 	smenu = "Show leathers",	skillneed = "Skinning"},
	{ tag = "TITAN_ORE_LOCAL_SCALES", 	name = "Scales: ",		save = "ShowScale", 	smenu = "Show scales",		skillneed = ""},
	{ tag = "TITAN_ORE_LOCAL_HIDES", 	name = "Hides: ",		save = "ShowHide", 		smenu = "Show hides", 		skillneed = "Skinning"},
	{ tag = "TITAN_ORE_LOCAL_CLOTHS", 	name = "Cloths: ",		save = "ShowCloth", 	smenu = "Show cloths", 		skillneed = ""},
	{ tag = "TITAN_ORE_LOCAL_HERBS", 	name = "Herbs: ",		save = "ShowHerb", 		smenu = "Show herbs", 		skillneed = "Herbalism"},
	{ tag = "TITAN_ORE_LOCAL_ESSENCES", name = "Essences: ",	save = "ShowEssence", 	smenu = "Show essences",	skillneed = "Enchanting"},
	{ tag = "TITAN_ORE_LOCAL_BANDAGES",	name = "Bandages: ",	save = "ShowBandage", 	smenu = "Show bandages",	skillneed = "First Aid"},
	{ tag = "TITAN_ORE_LOCAL_POISONS",	name = "Poisons: ",		save = "ShowPoison", 	smenu = "Show poisons",		skillneed = "Poisons"},
	{ tag = "TITAN_ORE_LOCAL_MISC",		name = "Misc: ",		save = "ShowMisc",	 	smenu = "Show misc",		skillneed = ""},
	{ tag = "TITAN_ORE_LOCAL_PMATS",	name = "Poison mats: ",	save = "ShowPmat",	 	smenu = "Show poison mats", skillneed = ""},
}


TITAN_ORE_ITEMS = {
	{ tag = "TITAN_ORE_COPPER",		short = "Cop", name = "Copper Ore",				save = "Copper", 				cat = TITAN_ORE_LOCAL_ORES, 	skill = 1},
	{ tag = "TITAN_ORE_TIN",		short = "Tin", name = "Tin Ore",				save = "Tin", 					cat = TITAN_ORE_LOCAL_ORES, 	skill = 65},
	{ tag = "TITAN_ORE_SILVER",		short = "Sil", name = "Silver Ore",				save = "Silver", 				cat = TITAN_ORE_LOCAL_ORES, 	skill = 75},
	{ tag = "TITAN_ORE_IRON",		short = "Iro", name = "Iron Ore",				save = "Iron", 					cat = TITAN_ORE_LOCAL_ORES, 	skill = 125},
	{ tag = "TITAN_ORE_GOLD",		short = "Gol", name = "Gold Ore",				save = "Gold", 					cat = TITAN_ORE_LOCAL_ORES, 	skill = 155},
	{ tag = "TITAN_ORE_MITHRIL",	short = "Mit", name = "Mithril Ore",			save = "Mithril", 				cat = TITAN_ORE_LOCAL_ORES, 	skill = 175},
	{ tag = "TITAN_ORE_TRUESILVER",	short = "Tru", name = "Truesilver Ore",			save = "Truesilver",			cat = TITAN_ORE_LOCAL_ORES, 	skill = 230},
	{ tag = "TITAN_ORE_THORIUM",	short = "Tho", name = "Thorium Ore",			save = "Thorium", 				cat = TITAN_ORE_LOCAL_ORES, 	skill = 245},
	{ tag = "TITAN_ORE_DARKIRON",	short = "DIr", name = "Dark Iron Ore",			save = "DIron", 				cat = TITAN_ORE_LOCAL_ORES, 	skill = 230},
	{ tag = "TITAN_ORE_FELIRONORE",	short = "Flo", name = "Fel Iron Ore",			save = "FelIronOre",			cat = TITAN_ORE_LOCAL_ORES, 	skill = 300},
	{ tag = "TITAN_ORE_ADAMATIORE",	short = "Ada", name = "Adamatite Ore",			save = "AdamantiteOre",			cat = TITAN_ORE_LOCAL_ORES, 	skill = 325},
	{ tag = "TITAN_ORE_ADAMATIORE",	short = "Ete", name = "Eternium Ore",			save = "EterniumOre",			cat = TITAN_ORE_LOCAL_ORES, 	skill = 350},
	{ tag = "TITAN_ORE_KHORIUMORE",	short = "Kho", name = "Khorium Ore",			save = "KhoriumOre",			cat = TITAN_ORE_LOCAL_ORES, 	skill = 375},
	{ tag = "TITAN_ORE_ELEMENTORE",	short = "Kho", name = "Elementium Ore",			save = "ElementiumOre",			cat = TITAN_ORE_LOCAL_ORES, 	skill = 400},

	{ tag = "TITAN_ORE_COP_BAR",	short = "CoB", name = "Copper Bar",				save = "CopperBar",				cat = TITAN_ORE_LOCAL_BARS, 	skill = 1},
	{ tag = "TITAN_ORE_TIN_BAR",	short = "TiB", name = "Tin Bar",				save = "TinBar",				cat = TITAN_ORE_LOCAL_BARS, 	skill = 65},
	{ tag = "TITAN_ORE_BRO_BAR",	short = "BrB", name = "Bronze Bar",				save = "BronzeBar",				cat = TITAN_ORE_LOCAL_BARS, 	skill = 65},
	{ tag = "TITAN_ORE_SIL_BAR",	short = "SiB", name = "Silver Bar",				save = "SilverBar",				cat = TITAN_ORE_LOCAL_BARS, 	skill = 75},
	{ tag = "TITAN_ORE_IRO_BAR",	short = "IrB", name = "Iron Bar",				save = "IronBar",				cat = TITAN_ORE_LOCAL_BARS, 	skill = 125},
	{ tag = "TITAN_ORE_GOL_BAR",	short = "GoB", name = "Gold Bar",				save = "GoldBar",				cat = TITAN_ORE_LOCAL_BARS, 	skill = 155},
	{ tag = "TITAN_ORE_STI_BAR",	short = "StB", name = "Steel Bar",				save = "SteelBar",				cat = TITAN_ORE_LOCAL_BARS, 	skill = 165},
	{ tag = "TITAN_ORE_MIT_BAR",	short = "MiB", name = "Mithril Bar",			save = "MithrilBar",			cat = TITAN_ORE_LOCAL_BARS, 	skill = 175},
	{ tag = "TITAN_ORE_TRU_BAR",	short = "TrB", name = "Truesilver Bar",			save = "TruesilverBar",			cat = TITAN_ORE_LOCAL_BARS, 	skill = 225},
	{ tag = "TITAN_ORE_DIR_BAR",	short = "DiB", name = "Dark Iron Bar",			save = "DarkIronBar",			cat = TITAN_ORE_LOCAL_BARS, 	skill = 230},
	{ tag = "TITAN_ORE_THO_BAR",	short = "ThB", name = "Thorium Bar",			save = "ThoriumBar",			cat = TITAN_ORE_LOCAL_BARS, 	skill = 250},
	{ tag = "TITAN_ORE_ELE_BAR",	short = "ElB", name = "Elementium Bar",			save = "ElementiumBar",			cat = TITAN_ORE_LOCAL_BARS, 	skill = 300},
	{ tag = "TITAN_ORE_ARB_BAR",	short = "ArB", name = "Arcanite Bar",			save = "ArcaniteBar",			cat = TITAN_ORE_LOCAL_BARS, 	skill = 230},
	{ tag = "TITAN_ORE_FEL_BAR",	short = "Fel", name = "Fel Iron Bar",			save = "FelIronBar",			cat = TITAN_ORE_LOCAL_BARS, 	skill = 250},
	{ tag = "TITAN_ORE_ETB_BAR",	short = "ETB", name = "Enchanted Thorium Bar",	save = "EThoriumBar",			cat = TITAN_ORE_LOCAL_BARS, 	skill = 300},
	{ tag = "TITAN_ORE_ADA_BAR",	short = "Ada", name = "Adamantite Bar",			save = "AdamantiteBar",			cat = TITAN_ORE_LOCAL_BARS, 	skill = 325},
	{ tag = "TITAN_ORE_ETH_BAR",	short = "EtB", name = "Eternium Bar",			save = "EterniumBar",			cat = TITAN_ORE_LOCAL_BARS, 	skill = 350},
	{ tag = "TITAN_ORE_KHO_BAR",	short = "KhB", name = "Khorium Bar",			save = "KhoriumBar",			cat = TITAN_ORE_LOCAL_BARS, 	skill = 375},
	{ tag = "TITAN_ORE_HAB_BAR",	short = "HAB", name = "Hardened Adamantite Bar",save = "HardenedAdaBar",		cat = TITAN_ORE_LOCAL_BARS, 	skill = 375},
	{ tag = "TITAN_ORE_FEL_BAR",	short = "FlB", name = "Felsteel Bar",			save = "FelsteelBar",			cat = TITAN_ORE_LOCAL_BARS, 	skill = 400},

	{ tag = "TITAN_ORE_RS",			short = "RS", name = "Rough Stone",				save = "RStone",				cat = TITAN_ORE_LOCAL_STONES, 	skill = 1},
	{ tag = "TITAN_ORE_CS",			short = "CS", name = "Coarse Stone",			save = "CStone",				cat = TITAN_ORE_LOCAL_STONES, 	skill = 65},
	{ tag = "TITAN_ORE_HS",			short = "HS", name = "Heavy Stone",				save = "HStone",				cat = TITAN_ORE_LOCAL_STONES, 	skill = 125},
	{ tag = "TITAN_ORE_SS",			short = "SS", name = "Solid Stone",				save = "SStone",				cat = TITAN_ORE_LOCAL_STONES, 	skill = 175},
	{ tag = "TITAN_ORE_DS",			short = "DS", name = "Dense Stone",				save = "DStone",				cat = TITAN_ORE_LOCAL_STONES, 	skill = 245},
	{ tag = "TITAN_ORE_RGS",		short = "RgS", name = "Rough Grinding Stone",	save = "RGStone",				cat = TITAN_ORE_LOCAL_STONES, 	skill = 1},
	{ tag = "TITAN_ORE_CGS",		short = "CgS", name = "Coarse Grinding Stone",	save = "CGStone",				cat = TITAN_ORE_LOCAL_STONES, 	skill = 65},
	{ tag = "TITAN_ORE_HGS",		short = "HgS", name = "Heavy Grinding Stone",	save = "HGStone",				cat = TITAN_ORE_LOCAL_STONES, 	skill = 125},
	{ tag = "TITAN_ORE_SGS",		short = "SgS", name = "Solid Grinding Stone",	save = "SGStone",				cat = TITAN_ORE_LOCAL_STONES, 	skill = 175},
	{ tag = "TITAN_ORE_DGS",		short = "DgS", name = "Dense Grinding Stone",	save = "DGStone",				cat = TITAN_ORE_LOCAL_STONES, 	skill = 245},

	{ tag = "TITAN_ORE_MAL",		short = "Mal", name = "Malachite",				save = "Malachite",				cat = TITAN_ORE_LOCAL_GEMS, 	skill = 1},
	{ tag = "TITAN_ORE_TIG",		short = "Tig", name = "Tigerseye",				save = "Tigerseye",				cat = TITAN_ORE_LOCAL_GEMS, 	skill = 1},
	{ tag = "TITAN_ORE_SHA",		short = "Sha", name = "Shadowgem",				save = "Shadowgem",				cat = TITAN_ORE_LOCAL_GEMS, 	skill = 1},
	{ tag = "TITAN_ORE_MOS",		short = "Mos", name = "Moss Agate",				save = "Moss Agate",			cat = TITAN_ORE_LOCAL_GEMS, 	skill = 65},
	{ tag = "TITAN_ORE_LES",		short = "Les", name = "Lesser Moonstone",		save = "LMoonstone",			cat = TITAN_ORE_LOCAL_GEMS, 	skill = 65},
	{ tag = "TITAN_ORE_JAD",		short = "Jad", name = "Jade",					save = "Jade", 					cat = TITAN_ORE_LOCAL_GEMS, 	skill = 125},
	{ tag = "TITAN_ORE_CIT",		short = "Cit", name = "Citrine",				save = "Citrine",				cat = TITAN_ORE_LOCAL_GEMS, 	skill = 125},
	{ tag = "TITAN_ORE_BVI",		short = "Bvi", name = "Black Vitriol",			save = "BVitriol",				cat = TITAN_ORE_LOCAL_GEMS, 	skill = 175},
	{ tag = "TITAN_ORE_AQA",		short = "Aqa", name = "Aquamarine",				save = "Aquamarine",			cat = TITAN_ORE_LOCAL_GEMS, 	skill = 175},
	{ tag = "TITAN_ORE_SRU",		short = "Sru", name = "Star Ruby",				save = "StarRuby",				cat = TITAN_ORE_LOCAL_GEMS, 	skill = -1},
	{ tag = "TITAN_ORE_BDI",		short = "Bdi", name = "Black Diamond",			save = "BlackDiamond",			cat = TITAN_ORE_LOCAL_GEMS, 	skill = 230},
	{ tag = "TITAN_ORE_SOU",		short = "Sou", name = "Souldarite"	,			save = "Souldarite",			cat = TITAN_ORE_LOCAL_GEMS, 	skill = 230},
	{ tag = "TITAN_ORE_BOM",		short = "BoM", name = "Blood of the Mountain",  save = "BOMountain",			cat = TITAN_ORE_LOCAL_GEMS, 	skill = 230},
	{ tag = "TITAN_ORE_LOP",		short = "Lop", name = "Large Opal",  			save = "LargeOpal",				cat = TITAN_ORE_LOCAL_GEMS, 	skill = 245},
	{ tag = "TITAN_ORE_BLS",		short = "BSa", name = "Blue Sapphire",			save = "BSapphire",				cat = TITAN_ORE_LOCAL_GEMS, 	skill = 245},
	{ tag = "TITAN_ORE_PBD",		short = "PbD", name = "Pristine Black Diamond",	save = "PBDiamond",				cat = TITAN_ORE_LOCAL_GEMS, 	skill = -1},
	{ tag = "TITAN_ORE_HEM",		short = "Hem", name = "Huge Emerald",			save = "HugeEmerald",			cat = TITAN_ORE_LOCAL_GEMS, 	skill = 245},
	{ tag = "TITAN_ORE_AZD",		short = "AzD", name = "Azerothian Diamond",		save = "AzerothianDiamond",		cat = TITAN_ORE_LOCAL_GEMS, 	skill = 245},
	{ tag = "TITAN_ORE_ACR",		short = "Acr", name = "Arcane Crystal",			save = "ArcaneCrystal",			cat = TITAN_ORE_LOCAL_GEMS, 	skill = 250},
	{ tag = "TITAN_ORE_YPC",		short = "YPC", name = "Yellow Power Crystal",	save = "YPowerCrystal",			cat = TITAN_ORE_LOCAL_GEMS, 	skill = 300},
	{ tag = "TITAN_ORE_RPC",		short = "RPC", name = "Red Power Crystal",		save = "RPowerCrystal",			cat = TITAN_ORE_LOCAL_GEMS, 	skill = 300},
	{ tag = "TITAN_ORE_GPC",		short = "GPC", name = "Green Power Crystal",	save = "GPowerCrystal",			cat = TITAN_ORE_LOCAL_GEMS, 	skill = 300},
	{ tag = "TITAN_ORE_BPC",		short = "BPC", name = "Blue Power Crystal",		save = "BPowerCrystal",			cat = TITAN_ORE_LOCAL_GEMS, 	skill = 300},
	
	{ tag = "TITAN_ORE_SHARD",		short = "SSh", name = "Soul Shard",				save = "Shard", 				cat = TITAN_ORE_LOCAL_SHARDS, 	skill = -1},

	{ tag = "TITAN_ORE_RLS",		short = "RLS", name = "Ruined Leather Scraps",	save = "RLeatherS",				cat = TITAN_ORE_LOCAL_LEATHERS, skill = 0},
	{ tag = "TITAN_ORE_LL",			short = "LL",  name = "Light Leather",			save = "LLeather",				cat = TITAN_ORE_LOCAL_LEATHERS, skill = 0},
	{ tag = "TITAN_ORE_ML",			short = "ML",  name = "Medium Leather",			save = "MLeather",				cat = TITAN_ORE_LOCAL_LEATHERS, skill = 0},
	{ tag = "TITAN_ORE_HL",			short = "HL",  name = "Heavy Leather",			save = "HLeather",				cat = TITAN_ORE_LOCAL_LEATHERS, skill = 0},
	{ tag = "TITAN_ORE_TL",			short = "TL",  name = "Thick Leather",			save = "TLeather",				cat = TITAN_ORE_LOCAL_LEATHERS, skill = 0},
	{ tag = "TITAN_ORE_RL",			short = "RL",  name = "Rugged Leather",			save = "RLeather",				cat = TITAN_ORE_LOCAL_LEATHERS, skill = 0},
	{ tag = "TITAN_ORE_CL",			short = "CL",  name = "Core Leather",			save = "CoreLeather",			cat = TITAN_ORE_LOCAL_LEATHERS, skill = 0},
	{ tag = "TITAN_ORE_ChL",		short = "ChL", name = "Chimera Leather",		save = "ChimeraLeather",		cat = TITAN_ORE_LOCAL_LEATHERS, skill = 0},
	{ tag = "TITAN_ORE_FrL",		short = "FrL", name = "Frostsaber Leather",		save = "FrostsaberLeather",		cat = TITAN_ORE_LOCAL_LEATHERS, skill = 0},
	{ tag = "TITAN_ORE_WaL",		short = "WaL", name = "Warbear Leather",		save = "WarbearLeather",		cat = TITAN_ORE_LOCAL_LEATHERS, skill = 0},
	{ tag = "TITAN_ORE_DeL",		short = "DeL", name = "Devilsaur Leather",		save = "DevilsaurLeather",		cat = TITAN_ORE_LOCAL_LEATHERS, skill = 0},
	{ tag = "TITAN_ORE_PBL",		short = "PBL", name = "Primal Bat Leather",		save = "PrimalBatLeather",		cat = TITAN_ORE_LOCAL_LEATHERS, skill = 0},
	{ tag = "TITAN_ORE_PTL",		short = "PTL", name = "Primal Tiger Leather",	save = "PrimalTigerLeather",	cat = TITAN_ORE_LOCAL_LEATHERS, skill = 0},
	{ tag = "TITAN_ORE_PTL",		short = "PTL", name = "Silithid Chitin",		save = "SilithidChitin",		cat = TITAN_ORE_LOCAL_LEATHERS, skill = 0},
	{ tag = "TITAN_ORE_LSC",		short = "LSC", name = "Light Silithid Carapace",save = "LightSilithidCarapace",	cat = TITAN_ORE_LOCAL_LEATHERS, skill = 0},
	{ tag = "TITAN_ORE_HSC",		short = "HSC", name = "Heavy Silithid Carapace",save = "HeavySilithidCarapace",	cat = TITAN_ORE_LOCAL_LEATHERS, skill = 0},
	{ tag = "TITAN_ORE_EL",			short = "EL",  name = "Enchanted Leather",		save = "Enchanted Leather",		cat = TITAN_ORE_LOCAL_LEATHERS, skill = 0},
	{ tag = "TITAN_ORE_TKL",		short = "TKL", name = "Thin Kodo Leather",		save = "ThinKodoLeather",		cat = TITAN_ORE_LOCAL_LEATHERS, skill = 0},
	
	{ tag = "TITAN_SCL_DS",			short = "DS",  name = "Deviate Scale",			save = "DeviateScale",			cat = TITAN_ORE_LOCAL_SCALES, 	skill = 0},
	{ tag = "TITAN_SCL_PDS",		short = "PDS", name = "Perfect Deviate Scale",	save = "PerfectDeviateScale",	cat = TITAN_ORE_LOCAL_SCALES, 	skill = 0},
	{ tag = "TITAN_SCL_RWS",		short = "RWS", name = "Red Whelp Scale",		save = "RedWhelpScale",			cat = TITAN_ORE_LOCAL_SCALES, 	skill = 0},
	{ tag = "TITAN_SCL_GWS",		short = "GWS", name = "Green Whelp Scale",		save = "GreenWhelpScale",		cat = TITAN_ORE_LOCAL_SCALES, 	skill = 0},
	{ tag = "TITAN_SCL_TS",			short = "TS",  name = "Turtle Scale",			save = "TurtleScale",			cat = TITAN_ORE_LOCAL_SCALES, 	skill = 0},
	{ tag = "TITAN_SCL_SS",			short = "SS",  name = "Scorpid Scale",			save = "ScorpidScale",			cat = TITAN_ORE_LOCAL_SCALES, 	skill = 0},
	{ tag = "TITAN_ORE_HSS",		short = "HSS", name = "Heavy Scorpid Scale",	save = "HeavyScorpidScale",		cat = TITAN_ORE_LOCAL_SCALES,	skill = 0},
	{ tag = "TITAN_ORE_WD",			short = "WD",  name = "Worn Dragonscale",		save = "WornDragonscale",		cat = TITAN_ORE_LOCAL_SCALES,	skill = 0},
	{ tag = "TITAN_ORE_DEV",		short = "Dev", name = "Devilscale",				save = "Devilscale",			cat = TITAN_ORE_LOCAL_SCALES,	skill = 0},
	{ tag = "TITAN_ORE_RDS",		short = "RDS", name = "Red Dragonscale",		save = "RedDragonscale",		cat = TITAN_ORE_LOCAL_SCALES,	skill = 0},
	{ tag = "TITAN_ORE_GDS",		short = "GDS", name = "Green Dragonscale",		save = "GreenDragonscale",		cat = TITAN_ORE_LOCAL_SCALES,	skill = 0},
	{ tag = "TITAN_ORE_BDS",		short = "BDS", name = "Blue Dragonscale",		save = "BlueDragonscale",		cat = TITAN_ORE_LOCAL_SCALES,	skill = 0},
	{ tag = "TITAN_ORE_BLS",		short = "BLS", name = "Black Dragonscale",		save = "BlackDragonscale",		cat = TITAN_ORE_LOCAL_SCALES,	skill = 0},
	{ tag = "TITAN_ORE_SMS",		short = "SMS", name = "Slimy Murloc Scale",		save = "SlimyMurlocScale",		cat = TITAN_ORE_LOCAL_SCALES,	skill = 0},
	
	{ tag = "TITAN_ORE_LH",			short = "LH",  name = "Light Hide",				save = "LHide",					cat = TITAN_ORE_LOCAL_HIDES, 	skill = -1},
	{ tag = "TITAN_ORE_MH",			short = "MH",  name = "Medium Hide",			save = "MHide",					cat = TITAN_ORE_LOCAL_HIDES, 	skill = -1},
	{ tag = "TITAN_ORE_HH",			short = "HH",  name = "Heavy Hide",				save = "HHide",					cat = TITAN_ORE_LOCAL_HIDES,	skill = -1},
	{ tag = "TITAN_ORE_TH",			short = "TH",  name = "Thick Hide",				save = "THide",					cat = TITAN_ORE_LOCAL_HIDES,	skill = -1},
	{ tag = "TITAN_ORE_RH",			short = "RH",  name = "Rugged Hide",			save = "RHide",					cat = TITAN_ORE_LOCAL_HIDES,	skill = -1},
	{ tag = "TITAN_ORE_RPH",		short = "RPH", name = "Raptor Hide",			save = "RPHide",				cat = TITAN_ORE_LOCAL_HIDES,	skill = -1},
	{ tag = "TITAN_ORE_SCH",		short = "SCH", name = "Shadowcat Hide",			save = "SCHide",				cat = TITAN_ORE_LOCAL_HIDES,	skill = -1},
	{ tag = "TITAN_ORE_DEH",		short = "DEH", name = "Devils Hide",			save = "DEHide",				cat = TITAN_ORE_LOCAL_HIDES,	skill = -1},
	{ tag = "TITAN_ORE_CLH",		short = "CLH", name = "Cured Light Hide",		save = "CLHide",				cat = TITAN_ORE_LOCAL_HIDES,	skill = -1},
	{ tag = "TITAN_ORE_CMH",		short = "CMH", name = "Cured Medium Hide",		save = "CMHide",				cat = TITAN_ORE_LOCAL_HIDES,	skill = -1},
	{ tag = "TITAN_ORE_CHH",		short = "CHH", name = "Cured Heavy Hide",		save = "CHHide",				cat = TITAN_ORE_LOCAL_HIDES,	skill = -1},
	{ tag = "TITAN_ORE_CTH",		short = "CTH", name = "Cured Thick Hide",		save = "CTHide",				cat = TITAN_ORE_LOCAL_HIDES,	skill = -1},
	
	{ tag = "TITAN_ORE_SIL",		short = "Sil", name = "Silverleaf",				save = "Silverleaf",			cat = TITAN_ORE_LOCAL_HERBS, 	skill = 1},
	{ tag = "TITAN_ORE_PCB",		short = "Pea", name = "Peacebloom",				save = "Peacebloom",			cat = TITAN_ORE_LOCAL_HERBS, 	skill = 1},
	{ tag = "TITAN_ORE_EAR",		short = "Ear", name = "Earthroot",				save = "Earthroot",				cat = TITAN_ORE_LOCAL_HERBS, 	skill = 15},
	{ tag = "TITAN_ORE_MAG",		short = "Mag", name = "Mageroyal",				save = "Mageroyal",				cat = TITAN_ORE_LOCAL_HERBS, 	skill = 50},
	{ tag = "TITAN_ORE_BRI",		short = "Bri", name = "Briarthorn",				save = "Briarthorn",			cat = TITAN_ORE_LOCAL_HERBS, 	skill = 75},
	{ tag = "TITAN_ORE_SWI",		short = "Swi", name = "Swiftthistle",			save = "Swiftthistle",			cat = TITAN_ORE_LOCAL_HERBS, 	skill = 75},
	{ tag = "TITAN_ORE_STR",		short = "Str", name = "Stranglekelp",			save = "Stranglekelp",			cat = TITAN_ORE_LOCAL_HERBS, 	skill = 85},
	{ tag = "TITAN_ORE_BRU",		short = "Bru", name = "Bruiseweed",				save = "Bruiseweed",			cat = TITAN_ORE_LOCAL_HERBS, 	skill = 100},
	{ tag = "TITAN_ORE_WIL",		short = "Wil", name = "Wild Steelbloom",		save = "Wild Steelbloom",		cat = TITAN_ORE_LOCAL_HERBS, 	skill = 115},
	{ tag = "TITAN_ORE_GRA",		short = "Gra", name = "Grave Moss",				save = "Grave Moss",			cat = TITAN_ORE_LOCAL_HERBS, 	skill = 120},
	{ tag = "TITAN_ORE_KIN",		short = "Kin", name = "Kingsblood",				save = "Kingsblood",			cat = TITAN_ORE_LOCAL_HERBS, 	skill = 125},
	{ tag = "TITAN_ORE_LIF",		short = "Lif", name = "Liferoot",				save = "Liferoot",				cat = TITAN_ORE_LOCAL_HERBS, 	skill = 150},
	{ tag = "TITAN_ORE_FAD",		short = "Fad", name = "Fadeleaf",				save = "Fadeleaf",				cat = TITAN_ORE_LOCAL_HERBS, 	skill = 160},
	{ tag = "TITAN_ORE_GOL",		short = "Gol", name = "Goldthorn",				save = "Goldthorn",				cat = TITAN_ORE_LOCAL_HERBS, 	skill = 175},
	{ tag = "TITAN_ORE_KHA",		short = "Kha", name = "Khadgar's Whisker",		save = "Khadgar's Whisker",		cat = TITAN_ORE_LOCAL_HERBS, 	skill = 185},
	{ tag = "TITAN_ORE_WIN",		short = "Win", name = "Wintersbite",			save = "Wintersbite",			cat = TITAN_ORE_LOCAL_HERBS, 	skill = 195},
	{ tag = "TITAN_ORE_FIR",		short = "Fir", name = "Firebloom",				save = "Firebloom",				cat = TITAN_ORE_LOCAL_HERBS, 	skill = 205},
	{ tag = "TITAN_ORE_PUR",		short = "Pur", name = "Purple Lotus",			save = "Purple Lotus",			cat = TITAN_ORE_LOCAL_HERBS, 	skill = 210},
	{ tag = "TITAN_ORE_ART",		short = "Art", name = "Arthas' Tears",			save = "Arthas' Tears",			cat = TITAN_ORE_LOCAL_HERBS, 	skill = 220},
	{ tag = "TITAN_ORE_SUN",		short = "Sun", name = "Sungrass",				save = "Sungrass",				cat = TITAN_ORE_LOCAL_HERBS, 	skill = 230},
	{ tag = "TITAN_ORE_BLI",		short = "Bli", name = "Blindweed",				save = "Blindweed",				cat = TITAN_ORE_LOCAL_HERBS, 	skill = 235},
	{ tag = "TITAN_ORE_GHO",		short = "Gho", name = "Ghost Mushroom",			save = "Ghost Mushroom",		cat = TITAN_ORE_LOCAL_HERBS, 	skill = 245},
	{ tag = "TITAN_ORE_GRO",		short = "Gro", name = "Gromsblood",				save = "Gromsblood",			cat = TITAN_ORE_LOCAL_HERBS, 	skill = 250},
	{ tag = "TITAN_ORE_GOS",		short = "GoS", name = "Golden Sansam",			save = "Golden Sansam",			cat = TITAN_ORE_LOCAL_HERBS, 	skill = 260},
	{ tag = "TITAN_ORE_DRE",		short = "Dre", name = "Dreamfoil",				save = "Dreamfoil",				cat = TITAN_ORE_LOCAL_HERBS, 	skill = 270},
	{ tag = "TITAN_ORE_MOU",		short = "Mou", name = "Mountain Silversage",	save = "Mountain Silversage",	cat = TITAN_ORE_LOCAL_HERBS, 	skill = 280},
	{ tag = "TITAN_ORE_PLA",		short = "Pla", name = "Plaguebloom",			save = "Plaguebloom",			cat = TITAN_ORE_LOCAL_HERBS, 	skill = 285},
	{ tag = "TITAN_ORE_ICE",		short = "Ice", name = "Icecap",					save = "Icecap",				cat = TITAN_ORE_LOCAL_HERBS, 	skill = 290},
	{ tag = "TITAN_ORE_BLA",		short = "Bla", name = "Black Lotus",			save = "Black Lotus",			cat = TITAN_ORE_LOCAL_HERBS, 	skill = 300},
	{ tag = "TITAN_ORE_FEL",		short = "Fel", name = "Felweed",				save = "Felweed",				cat = TITAN_ORE_LOCAL_HERBS,	skill = 301},
	{ tag = "TITAN_ORE_DRE",		short = "Dre", name = "Dreaming Glory",			save = "Dreaming Glory",		cat = TITAN_ORE_LOCAL_HERBS, 	skill = 301},
	{ tag = "TITAN_ORE_RAG",		short = "Rag", name = "Ragveil",				save = "Ragveil",				cat = TITAN_ORE_LOCAL_HERBS, 	skill = 301},
	{ tag = "TITAN_ORE_TER",		short = "Ter", name = "Terocone",				save = "Terocone",				cat = TITAN_ORE_LOCAL_HERBS, 	skill = 325},
	{ tag = "TITAN_ORE_FCA",		short = "FCa", name = "FlameCap",				save = "FlameCap",				cat = TITAN_ORE_LOCAL_HERBS, 	skill = 335},
	{ tag = "TITAN_ORE_ACL",		short = "AcL", name = "Ancient Lichen",			save = "AncientLichen",			cat = TITAN_ORE_LOCAL_HERBS, 	skill = 340},
	{ tag = "TITAN_ORE_NIV",		short = "NiV", name = "Nightmare Vine",			save = "NightmareVine",			cat = TITAN_ORE_LOCAL_HERBS, 	skill = 365},
	{ tag = "TITAN_ORE_NET",		short = "Net", name = "Netherbloom",			save = "Netherbloom",			cat = TITAN_ORE_LOCAL_HERBS, 	skill = 375},
	{ tag = "TITAN_ORE_MAT",		short = "MaT", name = "Mana Thistle",			save = "ManaThistle",			cat = TITAN_ORE_LOCAL_HERBS, 	skill = 375},
	{ tag = "TITAN_ORE_FLO",		short = "FLo", name = "Fel Lotus",				save = "FelLotus",				cat = TITAN_ORE_LOCAL_HERBS, 	skill = 400},

	{ tag = "TITAN_ORE_LC",			short = "LC", name = "Linen Cloth",				save = "LCloth",				cat = TITAN_ORE_LOCAL_CLOTHS, 	skill = -1},
	{ tag = "TITAN_ORE_WC",			short = "WC", name = "Wool Cloth",				save = "WCloth",				cat = TITAN_ORE_LOCAL_CLOTHS, 	skill = -1},
	{ tag = "TITAN_ORE_SC",			short = "SC", name = "Silk Cloth",				save = "SCloth",				cat = TITAN_ORE_LOCAL_CLOTHS, 	skill = -1},
	{ tag = "TITAN_ORE_MC",			short = "MC", name = "Mageweave Cloth",			save = "MCloth",				cat = TITAN_ORE_LOCAL_CLOTHS, 	skill = -1},
	{ tag = "TITAN_ORE_RC",			short = "RC", name = "Runecloth",				save = "RCloth",				cat = TITAN_ORE_LOCAL_CLOTHS, 	skill = -1},
	{ tag = "TITAN_ORE_FC",			short = "FC", name = "Felcloth",				save = "FCloth",				cat = TITAN_ORE_LOCAL_CLOTHS, 	skill = -1},
	{ tag = "TITAN_ORE_MOC",		short = "MOC",name = "Mooncloth",				save = "MOCloth",				cat = TITAN_ORE_LOCAL_CLOTHS, 	skill = -1},
	{ tag = "TITAN_ORE_NC",			short = "NC", name = "Netherweave Cloth",		save = "Netherweave Cloth",		cat = TITAN_ORE_LOCAL_CLOTHS, 	skill = -1},

	{ tag = "TITAN_ORE_LME",		short = "LME", name = "Lesser Magic Essence",	save = "LMEssence",				cat = TITAN_ORE_LOCAL_ESSENCES,	skill = 0},
	{ tag = "TITAN_ORE_GME",		short = "GME", name = "Greater Magic Essence",	save = "GMEssence",				cat = TITAN_ORE_LOCAL_ESSENCES,	skill = 0},
	{ tag = "TITAN_ORE_LAE",		short = "LAE", name = "Lesser Astral Essence",	save = "LAEssence",				cat = TITAN_ORE_LOCAL_ESSENCES,	skill = 0},
	{ tag = "TITAN_ORE_GAE",		short = "GAE", name = "Greater Astral Essence",	save = "GAEssence",				cat = TITAN_ORE_LOCAL_ESSENCES,	skill = 0},
	{ tag = "TITAN_ORE_LMy",		short = "LMy", name = "Lesser Mystic Essence",	save = "LMyEssence",			cat = TITAN_ORE_LOCAL_ESSENCES,	skill = 0},
	{ tag = "TITAN_ORE_GMy",		short = "GMy", name = "Greater Mystic Essence",	save = "GMyEssence",			cat = TITAN_ORE_LOCAL_ESSENCES,	skill = 0},
	{ tag = "TITAN_ORE_LNE",		short = "LNE", name = "Lesser Nether Essence",	save = "LNEssence",				cat = TITAN_ORE_LOCAL_ESSENCES,	skill = 0},
	{ tag = "TITAN_ORE_GNE",		short = "GNE", name = "Greater Nether Essence",	save = "GNEssence",				cat = TITAN_ORE_LOCAL_ESSENCES,	skill = 0},
	{ tag = "TITAN_ORE_LEE",		short = "LEE", name = "Lesser Eternal Essence",	save = "LEEssence",				cat = TITAN_ORE_LOCAL_ESSENCES,	skill = 0},
	{ tag = "TITAN_ORE_GEE",		short = "GEE", name = "Greater Eternal Essence",save = "GEEssence",				cat = TITAN_ORE_LOCAL_ESSENCES,	skill = 0},
	{ tag = "TITAN_ORE_EOA",		short = "EoA", name = "Essence of Air",			save = "EOAir",					cat = TITAN_ORE_LOCAL_ESSENCES,	skill = 0},
	{ tag = "TITAN_ORE_EOE",		short = "EoE", name = "Essence of Earth",		save = "EOEarth",				cat = TITAN_ORE_LOCAL_ESSENCES,	skill = 0},
	{ tag = "TITAN_ORE_EOU",		short = "EoU", name = "Essence of Undeath",		save = "EOUndeath",				cat = TITAN_ORE_LOCAL_ESSENCES,	skill = 0},
	{ tag = "TITAN_ORE_EOU",		short = "EoW", name = "Essence of Water",		save = "EOWater",				cat = TITAN_ORE_LOCAL_ESSENCES,	skill = 0},
	{ tag = "TITAN_ORE_LES",		short = "LEs", name = "Living Essence",			save = "LivingEssence",			cat = TITAN_ORE_LOCAL_ESSENCES,	skill = 0},

	{ tag = "TITAN_MSC_ELE",		short = "ElE", name = "Elemental Earth",		save = "EEarth",				cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_ELA",		short = "ElA", name = "Elemental Air",			save = "EAir",					cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_ELF",		short = "ElF", name = "Elemental Fire",			save = "EFire",					cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_ELW",		short = "ElW", name = "Elemental Water",		save = "EWater",				cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_COE",		short = "CoE", name = "Core of Earth",			save = "CoreofEarth",			cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_SLP",		short = "SLP", name = "Small Lustrous Pearl",	save = "SLPearl",				cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_IRP",		short = "IRP", name = "Iridescent Pearl",		save = "IRPearl",				cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_BLP",		short = "BLP", name = "Blue Pearl",				save = "BluePearl",				cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_BCP",		short = "BCP", name = "Black Pearl",			save = "BlackPearl",			cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_GOP",		short = "GOP", name = "Golden Pearl",			save = "GoldenPearl",			cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_RIO",		short = "RiO", name = "Righteous Orb",			save = "RighteousOrb",			cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_GUS",		short = "GuS", name = "Guardian Stone",			save = "GuardianStone",			cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_FRR",		short = "FrR", name = "Frozen Rune",			save = "FrozenRune",			cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_HOF",		short = "HoF", name = "Heart of Fire",			save = "Heart of Fire",			cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_FIE",		short = "FIE", name = "Fiery Core",				save = "FieryCore",				cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_LAC",		short = "LAC", name = "Lava Core",				save = "LavaCore",				cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_DaR",		short = "DaR", name = "Dark Rune",				save = "DarkRune",				cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_DeR",		short = "DeR", name = "Demonic Rune",			save = "DemonicRune",			cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_PwM",		short = "PwM", name = "Powerful Mojo",			save = "PowerfulMojo",			cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_PrA",		short = "PrA", name = "Primal Air",				save = "PrimalAir",				cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_PrF",		short = "PrF", name = "Primal Fire",			save = "PrimalFire",			cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_PrL",		short = "PrL", name = "Primal Live",			save = "PrimalLive",			cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_PrS",		short = "PrS", name = "Primal Shadow",			save = "PrimalShadow",			cat = TITAN_ORE_LOCAL_MISC,		skill = -1},
	{ tag = "TITAN_MSC_PrW",		short = "PrW", name = "Primal Water",			save = "PrimalWater",			cat = TITAN_ORE_LOCAL_MISC,		skill = -1},

	{ tag = "TITAN_BDG_LB",			short = "LB",  name = "Linen Bandage",			save = "LinenBandage",			cat = TITAN_ORE_LOCAL_BANDAGES,	skill = 1},
	{ tag = "TITAN_BDG_HLB",		short = "HLB", name = "Heavy Linen Bandage",	save = "HeavyLinenBandage",		cat = TITAN_ORE_LOCAL_BANDAGES,	skill = 40},
	{ tag = "TITAN_BDG_WB",			short = "WB",  name = "Wool Bandage",			save = "WoolBandage",			cat = TITAN_ORE_LOCAL_BANDAGES,	skill = 80},
	{ tag = "TITAN_BDG_HWB",		short = "HWB", name = "Heavy Wool Bandage",		save = "HeavyWoolBandage",		cat = TITAN_ORE_LOCAL_BANDAGES,	skill = 115},
	{ tag = "TITAN_BDG_SB",			short = "SB",  name = "Silk Bandage",			save = "SilkBandage",			cat = TITAN_ORE_LOCAL_BANDAGES,	skill = 150},
	{ tag = "TITAN_BDG_HSB",		short = "HSB", name = "Heavy Silk Bandage",		save = "HeavySilkBandage",		cat = TITAN_ORE_LOCAL_BANDAGES,	skill = 180},
	{ tag = "TITAN_BDG_MB",			short = "MB",  name = "Mageweave Bandage",		save = "MageweaveBandage",		cat = TITAN_ORE_LOCAL_BANDAGES,	skill = 210},
	{ tag = "TITAN_BDG_HMB",		short = "HMB", name = "Heavy Mageweave Bandage",save = "HeavyMageweaveBandage",	cat = TITAN_ORE_LOCAL_BANDAGES,	skill = 240},
	{ tag = "TITAN_BDG_RB",			short = "RB",  name = "Runecloth Bandage",		save = "RuneclothBandage",		cat = TITAN_ORE_LOCAL_BANDAGES,	skill = 260},
	{ tag = "TITAN_BDG_HRB",		short = "HRB", name = "Heavy Runecloth Bandage",save = "HeavyRuneclothBandage",	cat = TITAN_ORE_LOCAL_BANDAGES,	skill = 290},
	{ tag = "TITAN_BDG_NB",			short = "NB",  name = "Netherweave Bandage",	save = "NetherweaveBandage",	cat = TITAN_ORE_LOCAL_BANDAGES,	skill = 330},
	{ tag = "TITAN_BDG_HNB",		short = "HNB", name = "Heavy Netherweave Bandage",save = "HeavyNetherweaveBandage",	cat = TITAN_ORE_LOCAL_BANDAGES,	skill = 360},
	{ tag = "TITAN_BDG_AV",			short = "AV",  name = "Anti-Venom",				save = "AntiVenom",				cat = TITAN_ORE_LOCAL_BANDAGES,	skill = 80},
	{ tag = "TITAN_BDG_SAV",		short = "SAV", name = "Strong Anti-Venom",		save = "StrongAntiVenom",		cat = TITAN_ORE_LOCAL_BANDAGES,	skill = 130},
	{ tag = "TITAN_BDG_PAV",		short = "PAV", name = "Powerful Anti-Venom",	save = "PowerfullStrongAntiVenom",	cat = TITAN_ORE_LOCAL_BANDAGES,	skill = 300},
	
	{ tag = "TITAN_PSN_BP",			short = "BP",  name = "Blinding Powder",		save = "BlindingPowder",		cat = TITAN_ORE_LOCAL_POISONS,	skill = 34},
	{ tag = "TITAN_PSN_AnP",		short = "AnP", name = "Anesthetic Poison",		save = "AnestheticPoison",		cat = TITAN_ORE_LOCAL_POISONS,	skill = 68},
	{ tag = "TITAN_PSN_MnP",		short = "MnP", name = "Mind-numbing Poison",	save = "MindnumbingPoison",		cat = TITAN_ORE_LOCAL_POISONS,	skill = 24},
	{ tag = "TITAN_PSN_IP1",		short = "IP1", name = "Instant Poison", 		save = "InstantPoison",			cat = TITAN_ORE_LOCAL_POISONS,	skill = 20},
	{ tag = "TITAN_PSN_DP1",		short = "DP1", name = "Deadly Poison",			save = "DeadlyPoison",			cat = TITAN_ORE_LOCAL_POISONS,	skill = 30},
	{ tag = "TITAN_PSN_CP1",		short = "CP1", name = "Crippling Poison",		save = "CripplingPoison",		cat = TITAN_ORE_LOCAL_POISONS,	skill = 20},
	{ tag = "TITAN_PSN_WP1",		short = "WP1", name = "Wound Poison",			save = "WoundPoison",			cat = TITAN_ORE_LOCAL_POISONS,	skill = 32},

	{ tag = "TITAN_PMT_LeR",		short = "LeR", name = "Lethargy Root",			save = "LethargyRoot",			cat = TITAN_ORE_LOCAL_PMATS,	skill = -1},
	{ tag = "TITAN_PMT_Dea",		short = "Dea", name = "Deathweed",				save = "Deathweed",				cat = TITAN_ORE_LOCAL_PMATS,	skill = -1},
	{ tag = "TITAN_PMT_Fad",		short = "Fad", name = "Fadeleaf",				save = "Fadeleaf",				cat = TITAN_ORE_LOCAL_PMATS,	skill = -1},
	{ tag = "TITAN_PMT_EoP",		short = "EoP", name = "Essence of Pain",		save = "EssenceofPain",			cat = TITAN_ORE_LOCAL_PMATS,	skill = -1},
	{ tag = "TITAN_PMT_DDe",		short = "DDe", name = "Dust of Decay",			save = "DustofDecay",			cat = TITAN_ORE_LOCAL_PMATS,	skill = -1},
	{ tag = "TITAN_PMT_DoD",		short = "DoD", name = "Dust of Deterioration",	save = "DustofDeterioration",	cat = TITAN_ORE_LOCAL_PMATS,	skill = -1},
	{ tag = "TITAN_PMT_EoA",		short = "EoA", name = "Essence of Agony",		save = "EssenceofAgony",		cat = TITAN_ORE_LOCAL_PMATS,	skill = -1},
	{ tag = "TITAN_PMT_MsA",		short = "MsA", name = "Maiden's Anguish",		save = "MaidensAnguish",		cat = TITAN_ORE_LOCAL_PMATS,	skill = -1},
	{ tag = "TITAN_PMT_EV",			short = "EV",  name = "Empty Vial",				save = "EmptyVial",				cat = TITAN_ORE_LOCAL_PMATS,	skill = -1},
	{ tag = "TITAN_PMT_LV",			short = "LV",  name = "Leaded Vial",			save = "LeadedVial",			cat = TITAN_ORE_LOCAL_PMATS,	skill = -1},
	{ tag = "TITAN_PMT_CV",			short = "CV",  name = "Crystal Vial",			save = "CrystalVial",			cat = TITAN_ORE_LOCAL_PMATS,	skill = -1},
	{ tag = "TITAN_PMT_Swi",		short = "Swi", name = "Swiftthistle",			save = "Swiftthistle",			cat = TITAN_ORE_LOCAL_PMATS,	skill = -1},
	{ tag = "TITAN_PMT_RSW",		short = "RSW", name = "Refreshing Spring Water",save = "RefreshingSpringWater",	cat = TITAN_ORE_LOCAL_PMATS,	skill = -1},
}

